2020-03-13  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Date, Version): Release 1.0.4

        * inst/include/Rcpp/config.h: Idem
        * inst/NEWS.Rd: Idem
        * vignettes/rmd/Rcpp.bib: Idem
        * inst/bib/Rcpp.bib: Idem

2020-03-12  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/rmd/Rcpp.bib: Updated to current package versions
	* inst/bib/Rcpp.bib: Idem

2020-02-24  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/exceptions_impl.h: Remove spurious semicolon

2020-02-23  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/generated/Vector__create.h: Added #nocov tags
	* inst/include/Rcpp/exceptions_impl.h: Idem
	* src/api.cpp: Idem plus some whitespace realignment

2020-02-13  Dirk Eddelbuettel  <edd@debian.org>

	* README.md: Add a Debian badge

2020-02-12  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

	* README.md: Added indirect CRAN use badge

2020-02-09  Joshua Pritikin  <jpritikin@pobox.com>

	* inst/include/Rcpp.h: Include exceptions_impl.h
	* inst/include/Rcpp/exceptions.h: Make thread-safe
	* inst/include/Rcpp/exceptions_impl.h: New home for code moved
	from src/api.cpp

2020-01-05  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/exceptions.h: A few more #nocov tags
	* inst/include/Rcpp/generated/Vector__create.h: Idem, plus whitespace

2020-01-04  Dirk Eddelbuettel  <edd@debian.org>

	* R/Attributes.R: A few more #nocov tags

2020-01-01  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/module/Module.h: A few more #nocov tags
	* inst/include/Rcpp/XPtr.h: Idem
	* inst/include/Rcpp/vector/Vector.h: Idem

2019-12-31  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

2019-12-29  Qiang Kou  <qkou@qkou.info>

	* inst/include/Rcpp/vector/Matrix.h: Ensure scalar OP matrix do not
	change right-hand side in operation
	* inst/tinytest/test_matrix.R: New tests
	* inst/tinytest/cpp/Matrix.cpp: Idem

2019-12-20  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

2019-12-18  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/XPtr.h: Additional null check, refactored

2019-12-17  Kirill Müller  <krlmlr@mailbox.org>

	* inst/include/Rcpp/XPtr.h: Clear external pointer before finalizer

2019-12-17  Dirk Eddelbuettel  <edd@debian.org>

	* R/Attributes.R (sourceCpp): Very minor cosmetic changes

2019-12-15  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

2019-12-14  Dirk Eddelbuettel  <edd@debian.org>

	* R/Attributes.R (sourceCpp): Support new argument windowsDebugDLL to
	create a debug DLL, supported on Windows only
	* man/sourceCpp.Rd: Document it

	* src/date.cpp: A few more #nocov tage

2019-12-13  Dirk Eddelbuettel  <edd@debian.org>

	* src/api.cpp: A few more #nocov tags
	* src/attributes.cpp: Idem
	* src/barrier.cpp: Idem

2019-12-08  Dirk Eddelbuettel  <edd@debian.org>

	* tests/tinytest.R: Turn verbose tests on in dev and on Travis

	* inst/tinytest/test_client_package.R: Finer-grained skip messages
	* inst/tinytest/test_module_client_package.R: Idem
	* inst/tinytest/test_expose_class.R: Idem
	* inst/tinytest/test_interface.R: Idem
	* inst/tinytest/test_rcpp_package_skeleton.R: Idem
	* inst/tinytest/test_reference.R: Idem

	* inst/tinytest/test_*.R: Streamlined initial test and sourceCpp call

	* src/attributes.cpp: Remove dangling '#nocov end'

2019-12-07  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

	* inst/tinytest/test_binary_package.R: Finer-grained skip messages

	* inst/tinytest/test_misc.R: Add commented-out test that fails
	* tests/tinytest.R: Minor edit

	* docker/ci/Dockerfile: Add curl and ssl -dev packages needed for covr

2019-12-05  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/rmd/Rcpp-FAQ.Rmd (Rcpp): Add entry about "'dataptr' (or
	'enterRNGScope') not provided by Rcpp" recommending proper importFrom

2019-12-03  Dirk Eddelbuettel  <edd@debian.org>

	* docker/ci/Dockerfile: Lighter builds as fewer Suggests:
	* docker/plus/Dockerfile: Take packages moved from ci/Dockerfile

2019-12-01  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

	* DESCRIPTION (Suggests): Remove knitr, rmarkdown, pinp
	* DESCRIPTION (VignetteBuilder): Remove knitr

2019-11-26  Dirk Eddelbuettel  <edd@debian.org>

	* inst/tinytest/test_embedded_r.R: Use sink to suppress noisy output,
	reenable tests (still conditional on usual environment variable)

2019-11-25  Dirk Eddelbuettel  <edd@debian.org>

	* inst/tinytest/cpp/Vector.cpp (no_op): Suppress compiler warning

2019-11-24  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Suggests): Add tinytest, remove RUnit

	* tests/doRUnit.R: Removed
	* tests/tinytest.R: Added

	* tests/tinytest.R: Converted from RUnit to tinytest
 	* inst/tinytest/test_algorithm.R: Idem
 	* inst/tinytest/test_as.R: Idem
	* inst/tinytest/test_binary_package.R: Idem (but inactive for now)
	* inst/tinytest/test_client_package.R: Idem (but inactive for now)
	* inst/tinytest/test_dataframe.R: Idem
	* inst/tinytest/test_date.R: Idem (but condition two test sets on TZ)
	* inst/tinytest/test_dispatch.R: Idem
	* inst/tinytest/test_embedded.R: Idem
	* inst/tinytest/test_environments.R: Idem
	* inst/tinytest/test_exceptions.R: Idem
	* inst/tinytest/test_exceptions_nocall.R: Idem
	* inst/tinytest/test_expose_class.R: Idem
	* inst/tinytest/test_function.R: Idem
	* inst/tinytest/test_interface.R: Idem (but inactive for now)
	* inst/tinytest/test_internal_function.R: Idem
	* inst/tinytest/test_internal_function_cpp11.R: Idem
	* inst/tinytest/test_language.R: Idem
	* inst/tinytest/test_listof.R: Idem
	* inst/tinytest/test_matrix.R: Idem
	* inst/tinytest/test_misc.R: Idem
	* inst/tinytest/test_modref.R: Idem
	* inst/tinytest/test_module.R: Idem
	* inst/tinytest/test_module_client_package.R: Idem
	* inst/tinytest/test_na.R: Idem
	* inst/tinytest/test_quickanddirty.R: Idem
	* inst/tinytest/test_rcpp_package_skeleton.R: Idem
	* inst/tinytest/test_reference.R: Idem
	* inst/tinytest/test_rmath.R: Idem
	* inst/tinytest/test_robject.R: Idem
	* inst/tinytest/test_s4.R: Idem
	* inst/tinytest/test_stack.R: Idem
	* inst/tinytest/test_stats.R: Idem
	* inst/tinytest/test_string.R: Idem
	* inst/tinytest/test_subset.R: Idem
	* inst/tinytest/test_sugar.R: Idem
	* inst/tinytest/test_sugar_var.R: Idem
	* inst/tinytest/test_support.R: Idem
	* inst/tinytest/test_system.R: Idem
	* inst/tinytest/test_table.R: Idem
	* inst/tinytest/test_vector.R: Idem
	* inst/tinytest/test_vector_old.R: Idem
	* inst/tinytest/test_wrap.R: Idem
	* inst/tinytest/test_wstring.R: Idem
	* inst/tinytest/test_xptr.R: Idem

	* inst/tinytest/cpp/*: C++ support files for tests
	* inst/tinytest/*: Other support files and directories from unitTests

	* R/unitTests.R: Removed as tied to RUnit setuo

	* inst/tinytest/test_attributes.R: Added test for error with
	non-existing package in cppFunction

2019-11-23  Dirk Eddelbuettel  <edd@debian.org>

	* docker/ci/Dockerfile: Add tinytest to ci Docker image

2019-11-20  Dirk Eddelbuettel  <edd@debian.org>

	* R/Attributes.R: Test for and report unavailable 'LinkingTo' package

2019-11-19  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

2019-11-18  Kun Ren  <mail@renkun.me>

	* src/attributes.cpp: Add invisible param to export attribute (#1024)
	* vignettes/rmd/Rcpp-attributes.Rmd: Add an section of Returning
	invisible object

2019-11-13  Dirk Eddelbuettel  <edd@debian.org>

	* .github/ISSUE_TEMPLATE.md: Another small edit
	* .github/PULL_REQUEST_TEMPLATE.md: Idem

2019-11-13  Stephen Wade  <stephematician@gmail.com>

	* inst/include/Rcpp/XPtr.h: Delete delegating ctor (follow-up #1012)
	* inst/unitTests/runit.XPTr.R: Reinsert self-tag test on Windows

2019-11-11  Dirk Eddelbuettel  <edd@debian.org>

	* inst/unitTests/runit.packageversion.R: New test
	* inst/unitTests/cpp/rcppversion.cpp: Cpp portion of test

2019-11-10  Dirk Eddelbuettel  <edd@debian.org>

	* .github/: Add files CONTRIBUTING.md, FUNDING.yml, ISSUE_TEMPLATE.md
	and PULL_REQUEST_TEMPLATE.md

	* inst/include/Rcpp/config.h: Correct RCPP_VERSION and
	RCPP_DEV_VERSION to 1.0.3

2019-11-09  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

2019-11-09  TJ McKinley  <t.mckinley@exeter.ac.uk>

	* R/Attributes.R: Correct how cppFunction() deals with multiple
	depends arguments

2019-11-08  Romain Francois  <romain@rstudio.com>

	* inst/include/Rcpp/lang.h: Safer Rcpp_list* and Rcpp_lang*
	* inst/include/Rcpp/Function.h: Add Function.invoke() for operator()
	* inst/include/Rcpp/generated/Function__operator.h: Safer
	Function.operator() using Function.invoke()

2019-11-08  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Date, Version): Release 1.0.3

        * inst/include/Rcpp/config.h: Idem
        * inst/NEWS.Rd: Idem
        * inst/bib/Rcpp.bib: Idem
        * vignettes/Rcpp.bib: Idem

2019-11-06  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

	* inst/include/Rcpp/XPtr.h: Provided fallback for old constructor
	when C++11 is not available (follow-up to #1003)
	* inst/unitTests/runit.XPTr.R (test.XPtr): On Windows (as a proxy for
	old compilers) do not test new feature

	* tests/doRUnit.R: Protect printing to /tmp from Windows use

	* vignettes/rmd/Rcpp.bib: Updated
	* inst/bib/Rcpp.bib: Idem

2019-11-02  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

	* inst/include/Rcpp/Reference.h: Shield Rf_mkstring inside Rf_lang2
	* inst/include/Rcpp/Environment.h: Idem (inside Rf_lang4)
	* inst/include/Rcpp/proxy/FieldProxy.h: Idem (inside Rf_lang3 and 4)

2019-10-31  Romain Francois  <romain@rstudio.com>

	* inst/include/Rcpp/DataFrame.h: Protect temporaries from gc
	* inst/include/Rcpp/Environment.h: Idem
	* inst/include/Rcpp/r_cast.h: Idem

2019-10-27  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

	* inst/unitTests/runit.exposeClass.R: Updated to pass with r-devel

	* vignettes/rmd/Rcpp-FAQ.Rmd: Two new short section on speedier
	compilation and lack of exceptions / stop() across shared libraries

2019-10-26  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/Rcpp-package.Rnw: Another wrapper
	* vignettes/Rcpp-jss-2011.Rnw: Idem

	* vignettes/Makefile: Refinements
	* vignettes/rmd/Makefile: Idem

	* cleanup: Removed bashism, added invocation of make clean

2019-10-23  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/Rcpp-*.Rnw: Wrappers around pdf/*pdf
	* vignettes/Makefile: Added

2019-10-21  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/rmd/*: Moved from parent directory
	* vignettes/pdf/*: New target directory

2019-10-20  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

	* vignettes/Rcpp-FAQ.Rmd: Turn off knitr cache
	* vignettes/Rcpp-introduction.Rmd: Idem

	* vignettes/Makefile: Add simple Makefile
	* .Rbuildignore: Exclude vignettes/Makefile

2019-10-19  Stephen Wade  <stephematician@gmail.com>

	* inst/include/Rcpp/XPtr.h: XPtr constructor split up, a single
	argument does not modify tags and protected data of the external pointer
	* inst/unitTests/cpp/Xptr.cpp: Added test
	* inst/unitTests/runit.XPtr.R: Idem

2019-10-14  Dirk Eddelbuettel  <edd@debian.org>

	* README.md: Added CRAN + BioConductor badges for reverse depends,

2019-10-11  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/exceptions.h: Condition use of typeid() on
	absence of RCPP_NO_RTTI in two places
	* inst/include/Rcpp/r/headers.h: RCPP_NO_RTTI implies RCPP_NO_MODULES

2019-10-04  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/Rcpp-attributes.Rmd: Correct two unevaluated knitr C++
	chunks to mode 'Rcpp' rather than the (unregistered) C++ mode
	* vignettes/Rcpp-extending.Rmd: Minor white-space tweak to avoid
	paragraph-spacing warnings from latex and its mdframed style
	* vignettes/Rcpp-modules.Rmd: Idem
	* vignettes/Rcpp-sugar.Rmd: Idem

2019-10-01  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

2019-09-30  Kevin Ushey  <kevinushey@gmail.com>

	* inst/include/Rcpp.h: add RCPP_NO_MODULES
	* inst/include/Rcpp/api/meat/is.h: Idem
	* inst/include/Rcpp/api/meat/meat.h: Idem

2019-09-28  Dirk Eddelbuettel  <edd@debian.org>

	* README.md: Add a stackoverflow tag to indicate where to ask questions,
	also updated package counts on CRAN and BioC for Rcpp users

2019-08-06  Riccardo Porreca  <riccardo.porreca@mirai-solutions.com>

	* vignettes/Rcpp-modules.Rmd: Extensive review and edit improving the
	Modules vignette

2019-08-04  Dirk Eddelbuettel  <edd@debian.org>

	* README.md: Add thre doi badges

	* inst/NEWS.Rd: Two minor edits

2019-07-21  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

2019-07-21  Riccardo Porreca  <riccardo.porreca@mirai-solutions.com>

	* R/Module.R: Use an explicit Rcpp:: in the initalize method for C++
	classes wrapped inside modules to ensure proper initialization

2019-07-20  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 1.0.2

        * inst/include/Rcpp/config.h: Idem
        * inst/NEWS.Rd: Idem
        * inst/bib/Rcpp.bib: Idem
        * vignettes/Rcpp.bib: Idem

2019-07-18  Pierrick Roger  <pk.roger@icloud.com>

	* src/attributes.cpp: Correct parsing of default function values
	* inst/unitTests/cpp/attributes.cpp: Added tests
	* inst/unitTests/runit.attributes.R: Idem

2019-07-16  Dirk Eddelbuettel  <edd@debian.org>

	* debian/: Removed, see https://salsa.debian.org/edd/r-base/ instead

2019-07-04  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/Rcpp.bib: Updated
	* inst/bib/Rcpp.bib: Idem

2019-05-05  Dirk Eddelbuettel  <edd@debian.org>

	* .Rbuildignore: Small tweak

2019-04-27  Dirk Eddelbuettel  <edd@debian.org>

	* R/Rcpp.package.skeleton.R (Rcpp.package.skeleton): Use getRcppVersion()

2019-04-26  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

	* R/tools.R (getRcppVersion): More idiomatic code

2019-04-25  Dirk Eddelbuettel  <edd@debian.org>

	* R/tools.R (getRcppVersion): Export R (and dev) package version
	* man/getRcppVersion.Rd: Documentation for new function

	* inst/include/Rcpp/config.h (RCPP_VERSION_STRING): New version
	and development version string #define
	* src/api.cpp (getRcppVersionStrings): Expose new versions strings
	* src/internal.h: Register new version string exporter
	* src/rcpp_init.cpp (callEntries[]): Idem

	* inst/unitTests/runit.misc.R (test.getRcppVersion): test new function

2019-03-23  Ralf Stubner  <ralf.stubner@daqana.com>

	* vignettes/Rcpp-modules.Rmd: Describe RCPP_EXPOSED_* macros
	* vignettes/Rcpp-extending.Rmd: Reference Modules extensions

2019-03-23  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

	* inst/NEWS.Rd: Updated

2019-03-20  James J Balamuta  <balamut2@illinois.edu>

	* inst/include/Rcpp/sugar/functions/unique.h: Added decreasing
	parameter to control sort.
	* inst/unitTests/runit.sugar.R: Added sort_unique() tests
	* inst/unitTests/cpp/sugar.cpp: Ditto

2019-03-20  Dirk Eddelbuettel  <edd@debian.org>

	* src/date.cpp: Renamed from Date.cpp
	* src/module.cpp: Renamed from Module.cpp
	* src/rcpp_init.cpp: Renamed from Rcpp_init.cpp

2019-03-19  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

	* tests/doRUnit.R: On Travis always set RunAllRcppTests

	* docker/ci/Dockerfile: Set environment variables container-wide

2019-03-18  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/macros/macros.h (END_RCPP_RETURN_ERROR): Add
	UNPROTECT to reference nprot, also check for stop_sym

2019-03-17  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 1.0.1

        * inst/include/Rcpp/config.h: Idem
        * inst/NEWS.Rd: Idem
        * inst/bib/Rcpp.bib: Idem
        * vignettes/Rcpp.bib: Idem

2019-03-16  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): Roll minor version

	* inst/unitTests/runit.sugar.R: Set the sample() behaviour to R 3.5.0
	as R 3.6.0 has a breaking change (for the better)

2019-03-13  Romain François <romain@purrple.cat>

	* inst/include/Rcpp/macros/macros.h: Add UNPROTECT to please rchk

2019-03-12  Romain François <romain@purrple.cat>

	* inst/include/Rcpp/api/meat/proxy.h: AttributeProxy::set() with
	Shield<> and a few related uses of Shield<> to please rchk
	* inst/include/Rcpp/clone.h: Idem
	* inst/include/Rcpp/proxy/AttributeProxy.h: Idem
	* inst/include/Rcpp/proxy/NamesProxy.h: Idem
	* inst/include/Rcpp/vector/Matrix.h: Idem
	* inst/include/Rcpp/vector/Vector.h: Idem

2019-02-25  Dirk Eddelbuettel  <edd@debian.org>

	* .travis.yml (after_success): Setting CODECOV_TOKEN to reenable
	codecov.io coverage as detailed by Ralf in GitHub issue #941

2019-02-16  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/sugar/functions/cbind.h: Converted CRLF to CR

2019-02-15  Dirk Eddelbuettel  <edd@debian.org>

	* inst/README: Moved stale file to local/
	* inst/THANKS: Idem

2019-02-13  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Version, Date): New minor version

2019-02-11  Kevin Ushey  <kevinushey@gmail.com>

	* R/Attributes.R: better handle pre-existing RcppExports.cpp,
	RcppExports.R when calling compileAttributes()

2019-02-09  Ralf Stubner  <ralf.stubner@daqana.com>

	* Rcpp-modules.Rmd: Added example for .factory

2019-01-31  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/protection/Shelter.h (Rcpp): Only increase
	nprotected count if object is not NULL (suggested by Stepan Sindelar)

2018-12-26  Zhuoer Dong  <dongzhuoer@mail.nankai.edu.cn>

	* vignettes/Rcpp-quickref.Rmd: Fix three bugs: use `Named()`, define
	`glob`, `glob.ls(TRUE)`.

2018-12-01  Dirk Eddelbuettel  <edd@debian.org>

	* R/Attributes.R: Added new 'c++2a' plugin for '-std=c++2a'
	compilation standard supported by g++ 8 or later

2018-11-11  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/vector/Subsetter.h (check_indices): More
	informative error message as suggested by KK

2018-11-09  William Nolan  <will@landale.net>

        * inst/include/Rcpp/vector/Subsetter.h: Fixed to use R_xlen_t instead
	of int for indexing and added warning when indexing by IntegerVector
	(only for large enough vectors)

2018-11-05  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Date, Version): Version 1.0, and happy 10th birthday!

        * inst/include/Rcpp/config.h: Idem
        * inst/NEWS.Rd: Idem
        * inst/bib/Rcpp.bib: Idem
        * vignettes/Rcpp.bib: Idem

2018-11-04  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Date, Version): Roll minor version
	* inst/include/Rcpp/config.h (RCPP_DEV_VERSION): Idem

	* README.md: Updated stated package and test numbers

2018-10-25  Kevin Ushey  <kevinushey@gmail.com>

	* inst/include/Rcpp/String.h: Use Rf_mkCharLenCE() as appropriate
	* inst/unitTests/cpp/String.cpp: Add unit tests
	* inst/unitTests/runit.String.R: Add unit tests

2018-10-12  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Date, Version): Roll minor version
	* inst/include/Rcpp/config.h (RCPP_DEV_VERSION): Idem

	* tests/doRUnit.R: Simplified to something similar to what
	RcppArmadillo (and other packages) had for a while now

	* vignettes/Rcpp-unitTests.Rnw: Removed as less useful now

2018-10-08  JJ Allaire  <jj@rstudio.com>

	* R/Attributes.R: Sort the files scanned for attributes in the C locale
	for stable output across systems.

2018-10-07  Ralf Stubner  <ralf.stubner@daqana.com>

        * vignettes/Rcpp-extending.Rmd: Correct EXPORT to EXPOSED in displays
	of the corresponding macro, and remove two spurious semicolons

2018-10-02  Dirk Eddelbuettel  <edd@debian.org>

	* DESCRIPTION (Date, Version): Roll minor version
	* inst/include/Rcpp/config.h (RCPP_DEV_VERSION): Idem

2018-10-02  Romain Francois  <romain@rstudio.com>

	* inst/include/Rcpp/vector/Matrix.h: Init nrow in Matrix(no_init) ctor
	* inst/unitTests/runit.Matrix.R: New test
	* inst/unitTests/cpp/Matrix.cpp: Idem

2018-09-30  Dirk Eddelbuettel  <edd@debian.org>

	* man/RcppUnitTests.Rd: Remove \details{} with conditional code which
	R-devel (as of Sep 28) warns about as empty

2018-09-28  Dirk Eddelbuettel  <edd@debian.org>

	* .travis.yml (env): Set distinct build and check options to skip
	tests of vignettes

2018-09-27  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

	* inst/include/Rcpp/date_datetime/Date.h: Remove the empty destructor
	to make g++-9 (prerelease) happy [CRAN request]

	* inst/unitTests/runit.Matrix.R: Correct typo

2018-09-27  Romain Francois  <romain@rstudio.com>

	* inst/include/Rcpp/vector/Matrix.h: Fix Matrix(no_init(int,int))
	constructor
	* inst/unitTests/runit.Matrix.R: test for above
	* inst/unitTests/cpp/Matrix.cpp: same

2018-09-26  Dirk Eddelbuettel  <edd@debian.org>

	* docker/ci/Dockerfile: Set env var RunAllRcppTests=yes
	* .travis.yml: Do not set env var here as needed in Docker

2018-09-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.19
        * inst/NEWS.Rd: Idem
        * inst/bib/Rcpp.bib: Idem
        * vignettes/Rcpp.bib: Idem
        * inst/include/Rcpp/config.h: Idem

	* R/RcppLdpath.R (RcppLdPath, RcppLdFlags, CxxFlags, RcppCxx0xFlags):
	After discussion with CRAN, do not mark as .Deprecated() as too many
	packages are involved. This will need to be phased in more slowly.

2018-09-20  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/Rcpp-FAQ.Rmd: Set 'eval=FALSE' on another
	RcppArmadillo example to not create a build-time dependency

2018-09-18  JJ Allaire  <jj@rstudio.com>

	* src/attributes.cpp: Add support for [[Rcpp::init]] attribute
	* vignettes/Rcpp-attributes.Rmd: Documentation for [[Rcpp::init]]
	attribute

2018-09-17  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/r/headers.h: Define STRICT_R_HEADERS, but until
	September 2019 protect by defining RCPP_NO_STRICT_HEADERS

	* .travis.yml (env): Switch to rcpp/ci for ci use

2018-09-15  Dirk Eddelbuettel  <edd@debian.org>

	* docker/ci/Dockerfile: Move Dockerfile to docker/ci
	* docker/run/Dockerfile: Add deployment Dockerfile
	* docker/plus/Dockerfile: Add 'plus-sized' Dockerfile suitable for
	different add-on packages requiring Rcpp{Armadillo,Eigen,GSL} or BH

2018-09-02  Dirk Eddelbuettel  <edd@debian.org>

	* .travis.yml: Switch to rcpp/rcpp-testing container

2018-08-29  Dirk Eddelbuettel  <edd@debian.org>

	* .travis.yml: Use Dockerfile

2018-08-28  Dirk Eddelbuettel  <edd@debian.org>

	* docker/Dockerfile: Add Dockerfile for use by Travis CI

2018-08-27  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

	* man/Rcpp-deprecated.Rd: Fix two-char typo/thinko in \link{}

2018-07-29  Dirk Eddelbuettel  <edd@debian.org>

	* README.md: Refreshed via some edits and updates

        * DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

2018-07-28  Dirk Eddelbuettel  <edd@debian.org>

	* R/RcppLdpath.R (RcppLdPath, RcppLdFlags, CxxFlags, RcppLdFlags)
	(RcppCxx0xFlags): Marked as deprecated

	* man/Rcpp-deprecated.Rd: Add exported functions LdFlags() and
	RcppLdFlags() as deprecated
	* man/RcppLdFlags.Rd: Idem

2018-07-27  Dirk Eddelbuettel  <edd@debian.org>

	* man/loadRcppModules-deprecated.Rd: Fix typo; was deprecated in
	0.12.5, not 0.16.5 which does not exist

2018-07-26  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/Rcpp-FAQ.Rmd: Use collapse: true
	* vignettes/Rcpp-introduction.Rmd: Idem

2018-07-25  Dirk Eddelbuettel  <edd@debian.org>

	* vignettes/Rcpp-extending.Rmd: Use collapse: true

2018-07-24  Martin Lysy  <mlysy@uwaterloo.ca>

        * R/loadRcppClass.R: Search in R module for 'Class' instead of
	'CppClass'.
        * R/exposeClass.R: Fixed 'rename' argument to work as expected.
        * inst/unitTests/runit.exposeClass.R: Added unit tests for the
	above.

2018-07-23  Dirk Eddelbuettel  <edd@debian.org>

	* inst/bib/Rcpp.bib: More updates
        * vignettes/Rcpp.bib: Idem

2018-07-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.18
        * inst/NEWS.Rd: Idem
        * inst/bib/Rcpp.bib: Idem
        * vignettes/Rcpp.bib: Idem
        * inst/include/Rcpp/config.h: Idem

	* vignettes/Rcpp.bib: Updated other references
	* inst/bib/Rcpp.bib: Idem

	* inst/unitTests/runit.sugar.R: Additional min, max unit tests
	* inst/unitTests/cpp/sugar.cpp: Idem

2018-07-20  Dirk Eddelbuettel  <edd@debian.org>

	* inst/include/Rcpp/sugar/functions/max.h: Also consider case of an
	empty vector
	* inst/include/Rcpp/sugar/functions/min.h: Idem

2018-07-19  Jack Wasey  <jack@jackwasey.com>

        * inst/include/Rcpp/r_cast.h: Error and abort if debugging for STRSXP
2018-07-24  Martin Lysy  <mlysy@uwaterloo.ca>
	* R/loadRcppClass.R: Search in R module for 'Class' instead of 'CppClass'.
	* R/exposeClass.R: Fixed 'rename' argument to work as expected.
	* inst/unitTests/runit.exposeClass.R: Added unit tests for the above.

2018-07-12  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

2018-07-12  Jack Wasey  <jack@jackwasey.com>

	* R/Attributes.R: Use case-insensitive sort of filenames to make
	RcppExports more deterministic

2018-07-10  Lionel Henry  <lionel@rstudio.com>

        * inst/include/Rcpp/exceptions.h: Move LongjumpException from the
        Rcpp::internal namespace to the public Rcpp namespace. If you have a
        catch-all statement like `catch (...)`, be sure to catch and rethrow
        Rcpp::LongjumpException to prevent the R longjump from being ignored.
        * inst/include/Rcpp/macros/macros.h (VOID_END_RCPP): idem
        * src/attributes.cpp: idem

2018-07-09  Dirk Eddelbuettel  <edd@debian.org>

	* src/Date.cpp: Skip 'tm_gmtoff' on AIX as well (thanks to PR 876
	by @ayappanec)

2018-07-05  Lionel Henry  <lionel@rstudio.com>

        * inst/include/Rcpp/api/meat/Rcpp_eval.h: Rename `RCPP_PROTECTED_EVAL`
        to `RCPP_USE_UNWIND_PROTECT` because the new API is now more general
        than just evaluation of R code.
        * inst/NEWS.Rd: idem
        * inst/unitTests/runit.interface.R: idem
        * R/unit.tests.R (unitTestSetup): Pass extra arguments to sourceCpp()
        for easier debugging.

        * R/Attributes.R (.plugins[["unwindProtect"]]): You can now add
        `[[Rcpp::plugins(unwindProtect)]]` in one of your source file to enable
        the new unwind-protect mechanism easily. It appends
        `-DRCPP_USE_UNWIND_PROTECT` to `PKG_CPPFLAGS`.

        This is safer than using a `#define` because it ensures unwind-protect
        is enabled in all compilation units, including RcppExports.cpp.

        * inst/unitTests/cpp/stack.cpp: Use new plugin to enable unwind-protect.

2018-06-22  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/api/meat/Rcpp_eval.h: Ensure R_BaseEnv is used

2018-06-21  Lionel Henry  <lionel@rstudio.com>

        * inst/include/Rcpp/api/meat/unwind.h: Extract unwind protection from
        Rcpp::Rcpp_fast_eval() into Rcpp::unwindProtect(). Use this function
        whenever you need to call a C function that might longjump, for instance
        a function from R's C API. Rcpp::unwindProtect() will protect your C++
        stack and throw a Rcpp::internal::LongJump exception to ensure all
        destructors are called. The R longjump is then resumed once it is safe
        to do so. This function powers Rcpp_fast_eval().

        You can use Rcpp::unwindProtect() in two ways. First with a C-like
        callback interface that takes a `SEXP (*)(void* data)` function pointer
        and a `void*` data argument that is passed to the function. Second, if
        you have C++11 enabled, Rcpp::unwindProtect() implements an
        `std::function<SEXP(void)>` overload. You can pass any function object
        or lambda function with the right signature.
        * inst/include/Rcpp/api/meat/Rcpp_eval.h: Idem

2018-06-15  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

2018-06-13  Filip Schouwenaars  <filip@datacamp.com>

        * inst/unitTests/runit.embeddedR.R: Evaluate in environment derived
        of baseenv

2018-06-11  Romain Francois  <romain@purrple.cat>

        * inst/include/Rcpp/exceptions.h: Control call and stack display
        after exception / stop
        * inst/unitTests/cpp/Exceptions_nocall.cpp: new test
        * inst/unitTests/runit.Exceptions_nocall.R: idem

2018-06-09  Qiang Kou  <qkou@umail.iu.edu>

        * inst/include/Rcpp/DataFrame.h: Use Rcpp_fast_eval, not Rcpp_eval
        * inst/include/Rcpp/Environment.h: Idem
        * inst/include/Rcpp/Function.h: Idem
        * inst/include/Rcpp/Language.h: Idem
        * inst/include/Rcpp/Module.h: Idem
        * inst/include/Rcpp/Reference.h: Idem
        * inst/include/Rcpp/exceptions.h: Idem
        * inst/include/Rcpp/generated/Function__operator.h: Idem
        * inst/include/Rcpp/proxy/FieldProxy.h: Idem
        * inst/include/Rcpp/proxy/NamesProxy.h: Idem
        * inst/include/Rcpp/r_cast.h: Idem
        * inst/include/Rcpp/vector/Vector.h: Idem
        * inst/examples/SugarPerformance/sugarBenchmarks.R: Idem
        * inst/unitTests/cpp/language.c: Idem
        * inst/unitTests/cpp/misc.c: Idem
        * src/barrier.c: Idem

2018-06-09  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.embeddedR.R: Suspend test for now

2018-06-08  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h: Idem

        * Contributing.md: Minor update coding style

2018-06-07  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/config.h: bump dev version

2018-06-06  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/RNGScope.h: Allow suspension of RNG synchronization
        * inst/include/Rcpp/routines.h: Idem
        * src/Rcpp_init.cpp: Idem
        * src/api.cpp: Idem

        * inst/include/Rcpp/api/meat/Rcpp_eval.h: Evaluate in base env

2018-06-05  Jack Wasey  <jack@jackwasey.com>

        * inst/include/Rcpp/r_cast.h: Error and abort if debugging

2018-06-02  Lionel Henry  <lionel@rstudio.com>

        * inst/unitTests/runit.interface.R: New test for the case where
        the client package was compiled without protected evaluation
        enabled. On R 3.5, longjump exceptions thrown from imported
        functions are still caught and dealt with properly by the client
        package.

        * inst/unitTests/runit.interface.R: Test both Rcpp_eval() and
        Rcpp_fast_eval().

2018-06-01  Lionel Henry  <lionel@rstudio.com>

        * inst/unitTests/runit.interface.R: New tests for interfaces and unwind.
        These tests build two packages, and that exports a function via
        Rcpp::interfaces(cpp) and the other that calls it. The attributes are
        regenerated and the packages rebuilt each time the tests are run. The
        tests check in particular that the C++ stack is properly unwound when a
        long jump occurs.

2018-06-01  Romain Francois  <romain@purrple.cat>

        * inst/include/Rcpp/Environment.h: Make Environment::new_child() const

2018-05-31  Lionel Henry  <lionel@rstudio.com>

        * inst/include/Rcpp/api/meat/Rcpp_eval.h: Fix protected evaluation.

        Setting `RCPP_PROTECTED_EVAL` before including Rcpp.h enables a new R
        3.5 API for safe evaluation of R code. R longjumps are now correctly
        intercepted and rethrown. Thanks to this the C++ stack is now safely
        unwound when a longjump is detected while calling into R code. This
        includes the following cases: thrown errors, caught condition of any
        class, long return, restart invokation, debugger exit. Note that this is
        still experimental!

        When `RCPP_PROTECTED_EVAL` is enabled, Rcpp_eval() uses the
        protect-unwind API under the hood in order to gain safety. It is fully
        backward-compatibile and still catches errors and interrupts to rethrow
        them as typed C++ exceptions. If you don't need to catch those, consider
        using Rcpp_fast_eval() instead to avoid the catching overhead.

        Rcpp_fast_eval() is a wrapper around Rf_eval(). Unlike Rcpp_eval(), it
        does not evaluate R code within tryCatch() and thus avoids the overhead
        of wrapping and evaluating the expression in a tryCatch() call. When
        Rcpp is compiled with a lower version than R 3.5, Rcpp_fast_eval() falls
        back to Rf_eval() without any protection from long jumps, even when
        `RCPP_PROTECTED_EVAL` is set. Either add R 3.5 to your `Depends` or make
        sure the legacy Rcpp_eval() function is called instead of Rcpp_fast_eval()
        when your package is compiled with an older version of R.

        Note that Rcpp_fast_eval() behaves a bit differently to Rcpp_eval(). The
        former has the semantics of the C function Rf_eval() whereas the latter
        behaves like the R function base::eval(). This has subtle implications
        for control flow. For instance evaluating a return() expression within a
        frame environment returns from that frame rather than from the
        Rcpp_eval() call.

        * inst/include/Rcpp/macros/macros.h: Leave the try/catch scope before
        resuming jump to ensure proper destruction of the exception reference.

        * inst/include/Rcpp/exceptions.h: Functions to create and check a
        longjump sentinel. This sentinel is used as return value in contexts
        where it is not safe to resume a jump (i.e. in the glue code of cpp
        interfaces).

        * inst/include/Rcpp/macros/macros.h: Return a longjump sentinel in
        END_RCPP_RETURN_ERROR.

        * src/attributes.cpp: Detect longjump sentinels and resume jump.

2018-05-27  Romain Francois  <romain@purrple.cat>

        * inst/include/Rcpp/vector/string_proxy.h: Make
        StringProxy::operator== const
        * inst/unitTests/cpp/Vector.cpp: New test
        * inst/unitTests/runit.Vector.R: Idem

2018-05-09  Filip Schouwenaars  <filip@datacamp.com>

        * R/Attributes.R: Set local environment in source()
        * inst/unitTests/cpp/embeddedR.cpp: New test
        * inst/unitTests/runit.embeddedR.R: Idem

2018-05-09  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.17
        * inst/NEWS.Rd: Release 0.12.17
        * inst/bib/Rcpp.bib: Release 0.12.17
        * vignettes/Rcpp.bib: Release 0.12.17
        * inst/include/Rcpp/config.h: Release 0.12.17

        * debian/*: Changes for Debian release of 0.12.16

2018-05-05  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rmd: Also mention TAS paper
        * vignettes/Rcpp-introduction.Rmd: Idem
        * vignettes/Rcpp-jss-2011.Rnw: Idem

2018-05-04  Romain Francois  <romain@purrple.cat>

        * inst/include/Rcpp/String.h: Extend StoragePolicy support
        * inst/include/Rcpp/vector/00_forward_proxy.h: Idem
        * inst/include/Rcpp/vector/Vector.h: Idem
        * inst/include/Rcpp/vector/const_generic_proxy.h: Idem
        * inst/include/Rcpp/vector/const_string_proxy.h: Idem
        * inst/include/Rcpp/vector/generic_proxy.h: Idem
        * inst/include/Rcpp/vector/proxy.h: Idem
        * inst/include/Rcpp/vector/string_proxy.h: Idem
        * inst/include/Rcpp/vector/traits.h: Idem

        * inst/unitTests/cpp/Vector.cpp: New test
        * inst/unitTests/runit.Vector.R: Idem

2018-04-25  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

2018-04-25  Romain Francois  <romain@purrple.cat>

        * inst/include/Rcpp/Benchmark/Timer.h: If defined, undefine FALSE

2018-04-17  Ralf Stubner  <ralf.stubner@daqana.com>

        * vignettes/Rcpp-attributes.Rmd: Replace back-quote with straight quote
        * vignettes/Rcpp-modules.Rmd: Idem

2018-04-02  Dirk Eddelbuettel  <edd@debian.org>

        * .editorconfig: Added support for editorconfig.org
        * .clang_format: Removed
        * .dir-locals.el: Removed

2018-03-31  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sprintf.h (Rcpp): Remove parens [gcc8 warning]

        * vignettes/Rcpp-attributes.Rmd: Update link to JSS intro vignette
        * vignettes/Rcpp-modules.Rmd: Idem

2018-03-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

2018-03-18  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/stats/random/random.h: No inheritance from RNGScope

2018-03-14  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rmd: Correct a double-quote (thanks, Joris Meys)

2018-03-08  Peter Hickey  <peter.hickey@gmail.com>

        * vignettes/Rcpp-attributes.Rmd: Correct stray backslash

2018-03-08  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.16
        * inst/NEWS.Rd: Release 0.12.16
        * inst/bib/Rcpp.bib: Release 0.12.16
        * vignettes/Rcpp.bib: Release 0.12.16
        * inst/include/Rcpp/config.h: Release 0.12.16

        * debian/*: Changes for Debian release of 0.12.16

2018-02-07  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/longlong.h: Revised and more general logic for long
        long on 64bit Windows etc via C++11 and as int64_t alias where possible

2018-03-01  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sugar/functions/complex.h (Rcpp): Remove RCPP_HYPOT
        macro and use ::hypot() throught as it is provided with C99

        * inst/include/Rcpp/sugar/undoRmath.h: Also uncomment pythag here

2018-02-28  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Rmath.h (R): Rf_pythag has been remove in R 2.14.0
        so comment-out the R::pythag wrapper (per request of Brian Ripley)

2018-02-26  Kevin Ushey  <kevinushey@gmail.com>

        * src/api.cpp: Always set / put RNG state when calling Rcpp function

2018-02-25  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp.bib: Updated
        * inst/bib/Rcpp.bib: Idem

        * vignettes/Rcpp-FAQ.Rmd (Note): Expand conda answer by adding link

2018-02-14  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): New minor version

2018-02-14  Kirill Müller  <krlmlr@mailbox.org>

        * R/Attributes.R: Code compiled with cppFunction() uses .Call instead
        of .Primitive(".Call"), #795

2018-02-07  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/longlong.h: Allow long long on 64bit Windows

2018-01-21  Dirk Eddelbuettel  <edd@debian.org>

        * README.md: Added new section 'Support'

        * vignettes/Rcpp-FAQ.Rmd (vignette): Uppercase index to 'Rcpp-FAQ';
        removed reference to Gmane which sadly is no more

2018-01-19  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rmd (Note): Document the conda package
        `gxx_linux-64` as helpful in that environment

2018-01-16  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.15
        * inst/NEWS.Rd: Release 0.12.15
        * inst/bib/Rcpp.bib: Release 0.12.15
        * vignettes/Rcpp.bib: Release 0.12.15
        * inst/include/Rcpp/config.h: Release 0.12.15

        * debian/*: Changes for Debian release of 0.12.15

2018-01-15  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/RcppCommon.h: Check for new #define RCPP_USE_UNWIND_PROTECT
        and unset if defined, this is being be used to "park" code from #789
        * inst/include/Rcpp/Environment.h: Ifdef #789 via RCPP_USE_UNWIND_PROTECT
        * inst/include/Rcpp/Language.h: Idem
        * inst/include/Rcpp/api/meat/Rcpp_eval.h: Idem
        * inst/include/Rcpp/exceptions.h: Idem
        * inst/include/Rcpp/macros/macros.h: Idem

        * inst/unitTests/runit.stack.R: Ensure test is not running

2018-01-14  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): New minor version 0.12.14.8

        * inst/include/Rcpp/traits/is_na.h (Rcpp): Also speed up
        Rcpp::is_na<Rcomplex>

2018-01-14  Lionel Henry  <lionel@rstudio.com>

        * inst/unitTests/cpp/stack.cpp: Move stack unwinding tests from misc.cpp
        * inst/unitTests/runit.stack.R: Move stack unwinding tests from misc.R;
        disaggregate stack unwinding tests; also disable for now

2018-01-11  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/traits/is_na.h: Speed up Rcpp::is_na<double>()

2018-01-09  Iñaki Ucar  <i.ucar86@gmail.com>

        * inst/include/Rcpp/vector/proxy.h: Improve support for NVCC, the CUDA
        compiler, by making three more methods const

2018-01-06  Kendon Bell  <kmb56@berkeley.edu>

        * src/api.cpp: Allow for compilation on ANDROID

2017-12-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Date, Version): Updated minor version and date

2017-12-21  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/internal/wrap.h: Appease gcc-7 with fall-through
        * inst/include/Rcpp/macros/unroll.h: Idem

2017-12-20  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/utils/tinyformat.h: Update to new upstream
        c42f/tinyformat@8f60162, simplify future updates by separating
        Rcpp-specific changes (issue #786).

2017-12-19  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/internal/na.h: Remove 'clever' NA / NaN checks

2017-12-16  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Date, Version): Updated minor version and date

2017-12-13  Lionel Henry  <lionel@rstudio.com>

        * inst/include/Rcpp/api/meat/Rcpp_eval.h: Add Rcpp_fast_eval() for safe
        and fast evaluation of R code using the new protect-unwind API in R 3.5.
        [ This is however disabled for release 0.12.15. ]

        * inst/include/Rcpp/exceptions.h: Add LongjumpException and
        resumeJump() to support Rcpp_fast_eval().

        * inst/include/Rcpp/macros/macros.h: Catch LongjumpException and call
        resumeJump(). If resumeJump() doesn't jump (on old R versions), throw an
        R error (this normally should not happen).

        * inst/include/RcppCommon.h: Add Rcpp_fast_eval() to the public API and
        internal::Rcpp_eval_impl() to the private API.

        * inst/include/Rcpp/Environment.h: Use safe evaluation
        * inst/include/Rcpp/Language.h: idem

2017-12-05  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/Environment.h: Use public R APIs
        * inst/include/Rcpp/api/meat/Environment.h: Idem

2017-12-04  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/RObject.h: Protect temporary wrapped SEXPs
        * inst/include/Rcpp/api/meat/DataFrame.h: Idem
        * inst/include/Rcpp/api/meat/Environment.h: Idem
        * inst/include/Rcpp/api/meat/proxy.h: Idem
        * inst/include/Rcpp/proxy/ProtectedProxy.h: Idem
        * inst/include/Rcpp/vector/generic_proxy.h: Idem

2017-12-03  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): New minor version

        * inst/include/Rcpp/sugar/functions/is_na.h: Correct test for NA to work
        with new as well as old Date(time)Vectors

        * inst/unitTests/cpp/dates.cpp (has_na): Added tests
        * inst/unitTests/runit.Date.R (test.NA): Idem

2017-11-30  James J Balamuta  <balamut2@illinois.edu>

        * src/attributes.cpp: Fixed missing Rcpp namespace in export interface
        generation

2017-11-25  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

        * inst/include/Rcpp/exceptions/cpp11/exceptions.h: Ensure Rf_format gets
        a format string
        * inst/include/Rcpp/exceptions/cpp98/exceptions.h (Rcpp): Ditto

2017-11-18  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

        * vignettes/Rcpp-FAQ.Rmd: Use Rcpp::Rcpp.plugin.maker(), not ':::'

2017-11-17  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.14
        * inst/NEWS.Rd: Release 0.12.14
        * inst/bib/Rcpp.bib: Release 0.12.14
        * vignettes/Rcpp.bib: Release 0.12.14
        * inst/include/Rcpp/config.h: Release 0.12.14

2017-11-04  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rmd: Add 'skip_final_break: true' toggle
        * vignettes/Rcpp-attributes.Rmd: Idem
        * vignettes/Rcpp-extending.Rmd: Idem
        * vignettes/Rcpp-modules.Rmd: Idem
        * vignettes/Rcpp-sugar.Rmd: Idem

2017-10-30  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp.h: Unless RCPP_FORCE_OLD_DATE_DATETIME_VECTORS is
        defined, define RCPP_NEW_DATE_DATETIME_VECTORS to switch to new date and
        datetime vector as announced in release 0.12.8 one year ago

2017-10-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/iostream/Rstreambuf.h: White-space edits

2017-10-02  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/iostream/Rstreambuf.h: Embed buffer class instance
        in Rostream to not require run-time allocation, and please Coverity

2017-09-29  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

        * DESCRIPTION (Description): Add <doi:...> per suggestion by CRAN

        * inst/CITATION: Add PeerJ article, add doi info, reindent

2017-09-26  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/vector/MatrixRow.h: Added cbegin() / cend() to
        MatrixRow, and fixing return types
        * inst/include/Rcpp/vector/VectorBase.h: Ditto

2017-09-24  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.13
        * inst/NEWS.Rd: Release 0.12.13
        * inst/bib/Rcpp.bib: Release 0.12.13
        * inst/include/Rcpp/config.h: Release 0.12.13

2017-09-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/bib/Rcpp.bib: Updated references
        * viignettes/Rcpp.bib: Idem

2017-09-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

        * vignettes/Rcpp-FAQ.Rmd (Rcpp): Add entry for 'symbols not found' error
        requiring two runs of compileAttributes

2017-09-20  James J Balamuta  <balamut2@illinois.edu>

        * vignettes/rcpp-docs.cls: Removed

2017-09-20  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rmd: Modified formatting and cleaned a bit more.
        * vignettes/Rcpp-sugar.Rmd: Idem
        * vignettes/Rcpp-introduction.Rmd: Added new PeerJ preprint

2017-09-19  James J Balamuta  <balamut2@illinois.edu>

        * vignettes/Rcpp-FAQ.Rmd: Formatted and cleaned up vignette.
        * vignettes/Rcpp-sugar.Rmd: Idem

2017-09-19  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-attributes.Rmd: Formatted and cleaned up vignette.
        * vignettes/Rcpp-extending.Rmd: Idem
        * vignettes/Rcpp-modules.Rmd: Idem
        * vignettes/Rcpp-package.Rmd: Idem
        * vignettes/Rcpp-quickref.Rmd: Idem

2017-09-18  James J Balamuta  <balamut2@illinois.edu>

        * DESCRIPTION (Suggests): Added rmarkdown, knitr, and pinp dependencies
        * .travis.yml: idem
        * vignettes/Rcpp-quickref.Rmd: Translated vignette from highlight/sweave
        to RMarkdown for use with the pinp template.
        * vignettes/Rcpp-sugar.Rmd: Idem
        * vignettes/Rcpp-package.Rmd: Idem
        * vignettes/Rcpp-modules.Rmd: Idem
        * vignettes/Rcpp-FAQ.Rmd: Idem
        * vignettes/Rcpp-extending.Rmd: Idem
        * vignettes/Rcpp-attributes.Rmd: Idem

2017-09-18  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/vector/MatrixRow.h: Added cbegin() and cend() to
        the class along with a framework for proper const-correctness in the
        future.

2017-09-03  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

2017-09-02  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/vector/VectorBase.h: Defined both iterator AND
        const_iterator for future considerations.  Currently, as before, only
        const_iterator is available (though it used to be called iterator).
        Added cbegin() and cend() functions.  We should revisit whether there
        should be a non-const iterator on VectorBase in the future.

        * inst/include/Rcpp/vector/Matrix.h: Added cbegin() and cend()
        functions.  Iterator defintions inherited from Vector are appropriate.

        * inst/include/Rcpp/vector/MatrixColumn.h: Added cbegin() and cend()
        functions.  Iterator definitions inherited from Vector are appropriate
        because Matrix is column-major.

        * inst/include/Rcpp/vector/Vector.h: Added cbegin() and cend()
        functions.  Iterators are appropriate minus the problem with the const
        proxy class of objects (which may or may not actually be const depending
        on which one).

        * inst/include/Rcpp/vector/traits.h: Removed (accidentally) some some
        trailing whitespace on lines.

2017-09-02  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Roll minor version

        * vignettes/Rcpp-jss-2011.Rnw: Renamed again from Rcpp-introduction-2011,
        added reference to new Rcpp-introduction

        * inst/bib/Rcpp.bib: Merged bibliography from new vignette; also added
        PeerJ Preprint with new Rcpp Introduction

2017-09-01  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-introduction.Rnw: New introductory vignette from PeerJ
        preprints but typeset 'more nicely'

        * vignettes/rcpp-docs.cls: New LaTeX style file derived from pnas-new
        and its supporting files

        * vignettes/figures/: Three support figures for new vignette
        * vignettes/intro2Rcpp.bib: New bibliography

        * vignettes/Rcpp-introduction-2011.Rnw: Renamed from from Rcpp-introduction

2017-08-26  Dirk Eddelbuettel  <edd@debian.org>

        * .travis.yml (before_install): Use https for curl fetch

2017-08-14  James J Balamuta  <balamut2@illinois.edu>

        * vignettes/Rcpp-FAQ.Rnw: Sunset macOS documentation dealing with
        toolchains by redirecting to the R Installation and Administration manual
        * vignettes/.gitignore: Added various LaTeX build artifacts to ignore.

2017-08-05  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version and date

        * inst/include/Rcpp/XPtr.h: Whitespace only-changes

2017-08-04  Lei Yu  <leiyu_1981@qq.com>

        * inst/include/Rcpp/Module.h: Correct one closing parenthesis

2017-07-13  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.12
        * inst/NEWS.Rd: Release 0.12.12
        * inst/bib/Rcpp.bib: Release 0.12.12
        * inst/include/Rcpp/config.h: Release 0.12.12

        * README.md: Updated counts for dependents and tests

        * debian/*: Changes for Debian release of 0.12.12

2017-07-10  Jeff Pollock  <jeffpollock9@gmail.com>

        * inst/include/Rcpp/Module.h: Avoid unused variable warning
        * inst/include/Rcpp/Module_generated_Constructor.h: Ditto

2017-07-09  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h (RCPP_DEV_VERSION): Ditto

        * inst/NEWS.Rd: Added missing entries

2017-07-08  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/vector/no_init.h: Accept R_xlen_t instead of int

        * inst/include/Rcpp/internal/wrap.h: Use R_xlen_t not int in loop unroll
        * inst/include/Rcpp/macros/unroll.h: Ditto
        * inst/include/Rcpp/vector/Vector.h: Ditto

2017-07-05  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h (RCPP_DEV_VERSION): Ditto

2017-07-02  JJ Allaire  <jj@rstudio.com>

        * src/attributes.cpp: Generate C++ native routines with underscore
        prefix to avoid export when standard exportPattern is used in NAMESPACE

2017-06-29  JJ Allaire  <jj@rstudio.com>

        * src/attributes.cpp: Replace dot (".") with underscore ("_") in package
        names when generating native routine registrations.

2017-06-27  Jeroen Ooms  <jeroenooms@gmail.com>

        * inst/include/RcppCommon.h: Support attribute_visible macro

2017-06-17  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/Dimension.h: Explicit cast to int

        * inst/include/Rcpp/exceptions.h: Don't declare unused arguments
        * src/attributes.cpp: Ditto

2017-06-14  JJ Allaire  <jj@rstudio.com>

        * src/attributes.cpp: Add Shield around parameters in Rcpp::interfaces

2017-06-07  Dirk Eddelbuettel  <edd@debian.org>

        * README.md: Use alternates for img.shields.io GPL-2+ badges

2017-06-06  Yu Gong  <armgong@yahoo.com>

        * src/api.cpp: Also permit compilation under Haiku-OS

2017-06-04  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version

        * man/Rcpp.plugin.maker.Rd: Update manual page to additional Imports
        argument

2017-06-02  JJ Allaire  <jj@rstudio.com>

        * src/attributes.cpp: Automatically register init functions for
        RcppModules
        * R/Rcpp.package.skeleton.R: compileAttributes only after all code is
        generated

2017-06-01  JJ Allaire  <jj@rstudio.com>

        * src/attributes.cpp: Fix registration for exports with name attribute.

2017-05-30  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/utils/tinyformat.h: Added missing newline

2017-05-23  JJ Allaire  <jj@rstudio.com>

        * R/Attributes.R: Execute tools::package_native_routine_registration_skeleton
        within package rather than current working directory.
        * src/attributes.cpp: Execute tools::package_native_routine_registration_skeleton
         within package rather than current working directory.

2017-05-22  Dirk Eddelbuettel  <edd@debian.org>

        * R/inline.R (Rcpp.plugin.maker): Whitespace changes

2017-05-20  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.11
        * inst/NEWS.Rd: Release 0.12.11
        * inst/bib/Rcpp.bib: Release 0.12.11
        * inst/include/Rcpp/config.h: Release 0.12.11

        * README.md: Updated counts for dependents and tests

        * debian/*: Changes for Debian release of 0.12.10

2017-05-19  Dirk Eddelbuettel  <edd@debian.org>

        * inst/NEWS.Rd: Removed one duplicate entry
        * inst/include/Rcpp/api/meat/Rcpp_eval.h (Rcpp): Minor whitespace changes

2017-05-18  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll Date and Version once more
        * inst/NEWS.Rd: Updated

        * R/Attributes.R (.plugins[["openmp"]]): Fix typo in comment

        * src/attributes.cpp (Rcpp): Use size_t (twice) to suppress nags from g++

2017-05-16  JJ Allaire  <jj@rstudio.com>

        * R/Attributes.R: Automatically generate native routine registrations.
        * src/attributes.cpp: Automatically generate native routine registrations.
        * R/Rcpp.package.skeleton.R: Don't generate native routines when creating
        a package using attributes.

2017-05-09  Dirk Eddelbuettel  <edd@debian.org>

        * R/Rcpp.package.skeleton.R (Rcpp.package.skeleton): Under R 3.4.0, run
        tools::package_native_routine_registration_skeleton to create src/init.c

2017-05-07  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version again

        * inst/include/Rcpp/module/Module_Property.h: Remove two typed exception
        specifications which upset g++ 7.1 or higher

2017-05-05  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/date_datetime/Date.h: Suppress -Wconversion warnings
        * inst/include/Rcpp/date_datetime/Datetime.h: Idem
        * inst/include/Rcpp/date_datetime/newDateVector.h: Idem
        * inst/include/Rcpp/date_datetime/newDatetimeVector.h: Idem
        * inst/include/Rcpp/sugar/functions/rowSums.h: Idem
        * inst/include/Rcpp/sugar/functions/sample.h: Idem
        * inst/include/Rcpp/sugar/functions/strings/trimws.h: Idem

2017-04-26  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/exceptions.h (string_to_try_error): Protect result
        from Rf_mkString

2017-04-25  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R (.plugins[["cpp11"]]): If R 3.4.0 or newer is used, set
        USE_CXX11 (instead of the older USE_CXX1X);
        (.plugins[["cpp14"]]): similarly updated for C++14
        (.plugins[["cpp17"]]): similarly updated for C++17
        (.plugins[["cpp98"]]): added

2017-04-22  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/strings/trimws.h: Added sugar
        function trimws with unit tests
        * inst/include/Rcpp/sugar/functions/strings/strings.h: Idem
        * inst/unitTests/cpp/sugar.cpp: Idem
        * inst/unitTests/runit.sugar.R: Idem

2017-04-20  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version
        * inst/include/Rcpp/config.h (RCPP_DEV_VERSION): Idem

        * inst/include/Rcpp/exceptions/cpp98/exceptions.h
        (RCPP_ADVANCED_EXCEPTION_CLASS): Suppressing some warnings

2017-04-20  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/api/meat/DottedPairImpl.h: Corrected format
        specifier from '%s' to '%i'.

2017-04-18  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/vector/Matrix.h: Corrected exception throws from
        not_compatible to not_a_matrix.
        * inst/include/Rcpp/S4.h: Fixed documentation detailing exception class
        throw.
        * inst/include/Rcpp/Environment.h: Improved error handling messages
        * inst/include/Rcpp/Function.h: idem
        * inst/include/Rcpp/Promise.h: idem
        * inst/include/Rcpp/String.h: idem
        * inst/include/Rcpp/Symbol.h: idem
        * inst/include/Rcpp/XPtr.h: idem
        * inst/include/Rcpp/as.h: idem
        * inst/include/Rcpp/r_cast.h: idem
        * inst/include/Rcpp/api/meat/DottedPairImpl.h: idem
        * inst/include/Rcpp/internal/export.h: idem
        * inst/include/Rcpp/proxy/DottedPairProxy.h: idem
        * inst/include/Rcpp/proxy/SlotProxy.h: idem
        * inst/include/Rcpp/vector/MatrixColumn.h: idem
        * inst/include/Rcpp/vector/MatrixRow.h: idem
        * inst/include/Rcpp/vector/Vector.h: idem

2017-04-17  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/Rcpp/exceptions/cpp11/exceptions.h: Removed
        semicolons from RCPP_ADVANCED_EXCEPTION_CLASS to quiet 'extra ;'
        -Wpedantic
        * inst/include/Rcpp/exceptions.h: Modified exceptions macros to support
        a default string and removed generated stop, warning from file.
        * inst/include/Rcpp/Rcpp/exceptions/cpp98/exceptions.h: Contains
        generated RCPP_ADVANCED_EXCEPTION_CLASS macro, stop & warning.
        * inst/include/Rcpp/Rcpp/exceptions/cpp11/exceptions.h: idem but
        for variadic versions.
        * inst/include/Rcpp/utils/tinyformat.h: Enabled ability to use variadic
        tinyformat function if c++11 is detected.

2017-04-14  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/utils/tinyformat.h: Refreshed tinyformat.h against
        May 13, 2016 upstream, retained local mods.

2017-04-14  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/macros/macros.h: Remove unused variable warning in
        BEGIN_RCPP macro

        * inst/include/Rcpp/DataFrame.h: Explicitly call parent constructor

        * inst/include/Rcpp/sugar/functions/rep.h: Remove variable name in
        function declaration to suppress unused argument warning
        * src/Rcpp_init.cpp: Ditto
        * src/attributes.cpp: Ditto

2017-04-11  Dirk Eddelbuettel  <edd@debian.org>

        * inst/inst/unitTests/testRcppClass/src/init.c (R_init_testRcppClass): Call
        R_registerRoutines() and R_useDynamicSymbols(); also ensure
        _rcpp_module_boot_* is registered for each module
        * inst/unitTests/testRcppClass/NAMESPACE: Added registration

        * inst/unitTests/testRcppClass/DESCRIPTION (Title): Title case

        * inst/unitTests/testRcppClass/R/rcpp_hello_world.R (rcpp_hello_world):
        Call the renamed C++ function
        * inst/unitTests/testRcppClass/src/rcpp_hello_world.cpp (rcpp_hello_world_cpp):
        Renamed C++ function to be distinct from R function calling it
        * inst/unitTests/testRcppClass/src/rcpp_hello_world.h: Ditto
        * inst/unitTests/testRcppClass/man/rcpp_hello_world.Rd: Alias renamed
        C++ function

2017-04-09  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/testRcppModule/src/init.c (R_init_testRcppModule): Call
        R_registerRoutines() and R_useDynamicSymbols(); also ensure
        _rcpp_module_boot_* is registered for each module
        * inst/unitTests/testRcppModule/NAMESPACE: Added registration

        * inst/unitTests/testRcppModule/DESCRIPTION (Title): Title case

        * inst/unitTests/testRcppModule/R/rcpp_hello_world.R (rcpp_hello_world):
        Call the renamed C++ function
        * inst/unitTests/testRcppModule/src/rcpp_hello_world.cpp (rcpp_hello_world_cpp):
        Renamed C++ function to be distinct from R function calling it
        * inst/unitTests/testRcppModule/src/rcpp_hello_world.h: Ditto
        * inst/unitTests/testRcppModule/man/rcpp_hello_world.Rd: Alias renamed
        C++ function

        * inst/unitTests/testRcppModule/man/Rcpp_modules_examples.Rd: Alias
        renamed modules
        * inst/unitTests/testRcppModule/tests/modules.R: Call renamed module

2017-04-03  Jim Hester  <james.f.hester@gmail.com>

        * inst/include/Rcpp/exceptions.h: Added support for throwing
        exceptions without call stacks.
        * inst/include/Rcpp/macros/macros.h: Idem
        * inst/unitTests/cpp/exceptions.cpp: Idem
        * inst/unitTests/runit.exceptions.R: Idem

2017-03-28  James J Balamuta  <balamut2@illinois.edu>

        * inst/vignettes/Rcpp-FAQ.Rnw: Added "Known Issues" section to FAQ

2017-03-25  Dirk Eddelbuettel  <edd@debian.org>

        * LICENSE: Added
        * .Rbuildignore: Do not include LICENSE in package

2017-03-17  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.10
        * inst/NEWS.Rd: Release 0.12.10
        * inst/bib/Rcpp.bib: Release 0.12.10
        * inst/include/Rcpp/config.h: Release 0.12.10

        * README.md: Updated counts for dependents and tests

        * debian/*: Changes for Debian release of 0.12.10

2017-03-15  Jeroen Ooms  <jeroenooms@gmail.com>

        * inst/include/Rcpp/XPtr.h: added finalizeOnExit parameter

2017-02-28  Dirk Eddelbuettel  <edd@debian.org>

        * src/Rcpp_init.cpp (R_init_Rcpp): Call R_useDynamicSymbols()

        * DESCRIPTION (Version, Date): New minor version

2017-02-25  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: New subsection on C++11, C++14, C++17

2017-02-17  Dirk Eddelbuettel  <edd@debian.org>

        * R/tools.R: More #nocov
        * inst/include/Rcpp/internal/r_vector.h: Idem

2017-02-15  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): New minor version

2017-02-14  Iñaki Ucar  <i.ucar86@gmail.com>

        * inst/include/Rcpp/iostream/Rstreambuf.h: Fixed single-character handling
        (pull request #649, fixes issue #647)

2017-02-13  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R (.plugins[["cpp17"]]): New plugin
        (.plugins[["cpp1z"]]): Idem

2017-02-04  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/algorithm.h: Improved setup for Intel's icc

2017-01-31  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Date, Version): Roll minor version

        * inst/include/Rcpp/algorithm.h: Allow algorithm.h to be compiler under
        Intel's compiler, add copyright header and include guard

2017-01-31  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/matrix/upper_tri.h: Inherit from MatrixBase
        and use correct comparators in get() to fix segfault
        * inst/include/Rcpp/sugar/matrix/lower_tri.h: Idem
        * inst/unitTests/cpp/sugar.cpp: Added unit tests for upper_tri and
        lower_tri
        * inst/unitTests/runit.sugar.R: Idem

2017-01-23  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/DataFrame.h: Corrected return type for column size.

2017-01-22  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/DataFrame.h: Simplified and removed deprecation language.

2017-01-21  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/DataFrame.h: Added alias for column and row size
        * inst/unitTests/runit.DataFrame.R: Added unit tests for aliases
        * inst/unitTests/cpp/DataFrame.cpp: Idem

2017-01-17  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version and Date

        * inst/include/Rcpp/config.h (RCPP_DEV_VERSION): Roll minor

        * src/Date.cpp (Rcpp): Do not access tm_gmtoff on Solaris

2017-01-14  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.9
        * inst/NEWS.Rd: Release 0.12.9
        * inst/bib/Rcpp.bib: Release 0.12.9
        * inst/include/Rcpp/config.h: Release 0.12.9

        * README.md: Updated counts for dependents and tests

        * debian/*: Changes for Debian release of 0.12.9

2017-01-13  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/exceptions.h: Added more #nocov tags
        * inst/include/Rcpp/api/bones/wrap_extra_steps.h: Idem
        * inst/include/Rcpp/iostream/Rstreambuf.h: Idem
        * inst/include/Rcpp/traits/named_object.h: Idem
        * inst/include/Rcpp/r_cast.h: Idem
        * src/Module.cpp: Idem

2017-01-12  Dirk Eddelbuettel  <edd@debian.org>

        * inst/bib/Rcpp.bib: Moved from vignettes/ directory
        * R/bib.R (bib): Idem

        * vignettes/Rcpp-FAQ.Rnw: Evaluate \Sexpr{Rcpp:::bib()}
        * vignettes/Rcpp-attributes.Rnw: Idem
        * vignettes/Rcpp-extending.Rnw: Idem
        * vignettes/Rcpp-introduction.Rnw: Idem
        * vignettes/Rcpp-modules.Rnw: Idem
        * vignettes/Rcpp-packages.Rnw: Idem
        * vignettes/Rcpp-sugar.Rnw: Idem

        * inst/unitTests/runit.misc.R (test.bib): New test

        * R/exceptions.R: Added #nocov

2017-01-11  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp.bib: Updated references

        * src/attributes.cpp (Rcpp): Correct typos in #nocov tags, added tags

2017-01-07  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/sugar/functions/complex.h: Added Arg() function
        * inst/unitTests/runit.sugar.R: Added Arg() unit test to complex list
        * inst/unitTests/cpp/sugar.cpp: Idem

2017-01-06  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Mark new minor version

        * src/attributes.cpp: Additional nocov tags

2017-01-04  Dirk Eddelbuettel  <edd@debian.org>

        * src/Date.cpp (Rcpp): Protect assignment to tm_gmtoff to not being
        under MinGW; could potentially bite other too-limited systems

        * inst/unitTests/runit.Date.R (test.Datetime.formating): Do not set TZ
        when running test, only set digits option

2017-01-01  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.Date.R (test.mktime, test.gmtime): New tests
        * inst/unitTests/cpp/dates.cpp (test_mktime, test_gmtime): Idem

2016-12-31  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/Matrix.h: Minor simplification

2016-12-31  James J Balamuta  <balamut2@illinois.edu>

        * inst/include/Rcpp/vector/Matrix.h: Fixed non-symmetric case of matrix
        fills by switching to a loop based solution from iterator.
        * inst/unitTests/runit.Matrix.R: Added unit tests for diagonally
        filling matrices.
        * inst/unitTests/cpp/Matrix.cpp: Idem

2016-12-30  Dirk Eddelbuettel  <edd@debian.org>

        * src/Date.cpp: Synchronized internal code with R

        * inst/unitTests/cpp/dates.cpp (gmtime_mktime): New test
        * inst/unitTests/runit.Date.R (test.mktime_gmtime): Idem

2016-12-26  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R: Added #nocov markers
        * R/Module.R: Idem
        * R/exposeClass.R: Idem, added copyright header

2016-12-25  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Date, Version): Roll minor version

        * src/api.cpp: Added #nocov markers
        * src/Rcpp_init.cpp: Idem
        * src/Date.cpp: Date

2016-12-14  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/sample.h: Use vector instead of
        manual memory management.

2016-12-13  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/sample.h: Use malloc.h instead of
        alloca.h when building on Windows
        * inst/include/Rcpp/date_datetime/Date.h: Include time.h when building
        on Windows
        * inst/include/Rcpp/date_datetime/Datetime.h: Idem

2016-12-12  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sugar/functions/sample.h: In case sample.h from the
        RcppArmadillo extensions was included, skip this file

2016-12-10  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/sample.h: New function
        sample()
        * inst/include/Rcpp/sugar/functions/functions.h: Idem
        * inst/unitTests/cpp/sugar.cpp: Unit tests for sample()
        * inst/unitTests/runit.sugar.R: Idem

2016-12-10  Dirk Eddelbuettel  <edd@debian.org>

        * R/loadRcppModules.R: Added #nocov tags
        * R/loadModule.R: Ditto

        * R/unit.tests.R (test): Adjusted one #nocov tag

2016-12-09  Dirk Eddelbuettel  <edd@debian.org>

        * R/00_classes.R: Added #nocov tags
        * R/01_show.R: Ditto
        * R/02_completion.R: Ditto
        * R/03_prompt.R: Ditto

2016-12-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/Matrix.h: Add 'using ...' to disambiguate size()

2016-12-04  Dirk Eddelbuettel  <edd@debian.org>

        * .codecov.yml (comment): Enable more verbose codecov.io reports

2016-12-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/cpp/dates.cpp (Datetime_format): Additional ostream tests
        * inst/unitTests/runit.Date.R (test.Date.formating): Ditto

        * inst/unitTests/runit.system.R (test.RcppCxx): New tests

        * R/RcppLdpath.R (canUseCXX0X): Simplified as we can now rely on more
        modern compilers;  underlying C++ code has not been present for a while

        * R/compilerCheck.R (compilerCheck): Added some #nocov tags
        * R/unit.tests.R (test, gctortureRUnitTest): Ditto
        * R/zzz.R (.onLoad): Ditto

2016-11-29  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll minor version to 0.12.8.2

2016-11-28  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/cpp/dates.cpp (Date_format, Datetime_format): New tests
        * inst/unitTests/runit.Date.R (test.Date.formating): Ditto
        (test.Datetime.formating): Ditto

        * inst/unitTests/runit.sugar.R (test.intersect): Added sort() around
        call to Sugar's intersect to ensure sorted output with g++-6.*

2016-11-27  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/date_datetime/Date.h (format, operator<<): Added
        * inst/include/Rcpp/date_datetime/Datetime.h (format, operator<<): Ditto
        * inst/include/Rcpp/date_datetime/newDateVector.h (operator<<): Ditto
        * inst/include/Rcpp/date_datetime/newDatetimeVector.h (operator<<): Ditto

2016-11-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/config.h (RCPP_DEV_VERSION): Set minor version

2016-11-22  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Date, Version): Roll minor version

        * inst/include/Rcpp/date_datetime/newDatetimeVector.h (Rcpp): Small
        correction concerning timezone attribute to ctor from RTYPE

2016-11-22  Jim Hester  <james.f.hester@gmail.com>

        * inst/src/api.cpp: Cleanup to stack message parseing
        * inst/unitTests/cpp/exceptions.cpp: Unit tests for cleanup
        * inst/unitTests/runit.exceptions.R: Ditto

2016-11-19  James J Balamuta  <balamut2@illinois.edu>

        * inst/unitTests/runit.environments.R: Added environment find unit tests
        as well as a symbol access test for environment get.
        * inst/unitTests/cpp/Environment.cpp: Idem

2016-11-18  James J Balamuta  <balamut2@illinois.edu>

        * vignettes/Rcpp-extending: Switched to attributes and
          added external class pointer macro notes by MathurinD

2016-11-16  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.8
        * inst/NEWS.Rd: Release 0.12.8
        * vignettes/Rcpp.bib: Release 0.12.8
        * inst/include/Rcpp/config.h: Release 0.12.8

        * README.md: Updated counts for dependents and tests

        * debian/*: Changes for Debian release of 0.12.8

2016-11-15  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Nathan Russell added to Authors

2016-11-14  Jim Hester  <james.f.hester@gmail.com>

        * inst/include/Rcpp/exceptions.h: Improved exception call stack
        * inst/include/Rcpp/routines.h: Ditto
        * inst/src/api.cpp: Ditto

        * R/exections.R: Print and format method for stack straces

        * inst/unitTests/runit.exceptions.R: Unit tests
        * inst/unitTests/cpp/exceptions.cpp: Ditto

2016-11-13  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R (mergeIntoBuildEnv): Correct 'empty' return

2016-11-10  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/date_datetime/newDateVector.h: Added constructor
        using VectorBase<>

2016-11-05  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/date_datetime/newDatetimeVector.h: Added constructor
        to instantiate newDatetimeVector from VectorBase.

2016-11-04  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/macros/dispatch.h: Modify variadic macros
        to not use GNU extensions
        * DESCRIPTION: roll minor version

2016-11-03  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/hash/IndexHash.h: Add casts to eliminate
        signed / unsigned comparison warning
        * inst/include/Rcpp/hash/SelfHash.h: Idem
        * inst/unitTests/cpp/sugar.cpp: Added unit tests for sugar function
        unique()
        * inst/unitTests/runit.sugar.R: Idem

2016-10-30  Dirk Eddelbuettel  <edd@debian.org>

        * src/api.cpp: New capabilities field for new date(time) vectors
        * inst/unitTests/runit.Date.R (test.DatetimeVector.ctor): Differentiate
        in test as case of 'Inf' is handling differently by new and old datetime
        classes (and passed through as is by new ones which is better)
        * inst/unitTests/runit.InternalFunctionCPP11.R: Small cosmetic edit

2016-10-24  Qiang Kou  <qkou@umail.iu.edu>

        * inst/include/Rcpp/sugar/Range.h : fix range sugar ambiguity
        * inst/unitTests/cpp/sugar.cpp: range sugar unit test
        * inst/unitTests/runit.sugar.R: range sugar unit test

2016-10-24  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/vector/MatrixBase.h: Change sugar
        functions eye(), ones(), and zeros() into static methods
        in MatrixBase
        * inst/include/Rcpp/traits/one_type.h: Idem
        * inst/include/Rcpp/traits/traits.h: Idem
        * inst/unitTests/cpp/Matrix.cpp: Idem
        * inst/unitTests/runit.Matrix.R: Idem

2016-10-24  Qiang Kou  <qkou@umail.iu.edu>

        * inst/include/Rcpp/sugar/Range.h: Range sugar uses R_xlen_t as start/end type

2016-10-23  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/matrix/eye.h: New functions
        eye(), ones(), and zeros()
        * inst/include/Rcpp/sugar/matrix/matrix_functions.h: Idem
        * inst/unitTests/cpp/sugar.cpp: Unit tests for new functions
        * inst/unitTests/runit.sugar.R: Idem
        * inst/unitTests/runit.dispatch.R (test.ExpressionVector): Use
        expression rather than parse, correct typo

2016-10-22  Qiang Kou  <qkou@umail.iu.edu>

        * inst/include/Rcpp/hash/IndexHash.h: change hashing function to return unsigned int
        * inst/include/Rcpp/hash/SelfHash.h: Ditto

2016-10-21  Qiang Kou  <qkou@umail.iu.edu>

        * inst/include/Rcpp/barrier.h: Change string_elt/vector_elt to accept R_xlen_t
        * inst/include/Rcpp/routines.h: Ditto
        * src/barrier.cpp: Ditto

2016-10-19  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/date_datetime/Datetime.h (Rcpp): Additional
        operator+ for int argument

2016-10-18  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/date_datetime/Date.h (Rcpp): Add operator double()
        * inst/include/Rcpp/date_datetime/Datetime.h (Rcpp): Ditto

2016-10-17  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/date_datetime/newDatetimeVector.h (Rcpp): Allow
        setting of timezone attribute; default not-set leads to local as in R

2016-10-16  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp.h (RCPP_NEW_DATE_DATETIME_VECTORS): Add a new
        compile-time #define to switch between 'old' (existing) and 'new'
        DateVector and DatimeVector classes. Currently uses 'new' for testing
        plan to switch to proper deprecation schedule.

        * inst/include/Rcpp/date_datetime/date_datetime.h: New header file (and
        directory) regrouping all Date and Datetime headers, scalar and vector

        * inst/include/Rcpp/date_datetime/Date.h: Moved one directory down
        * inst/include/Rcpp/date_datetime/Datetime.h: Ditto
        * inst/include/Rcpp/date_datetime/oldDateVector.h: Moved and renamed
        * inst/include/Rcpp/date_datetime/oldDatetimeVector.h: Ditto

        * inst/include/Rcpp/date_datetime/newDateVector.h: New implementation
        inheriting from NumericVector, still optional
        * inst/include/Rcpp/date_datetime/newDatetimeVector.h: Ditto

2016-09-05  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Roll minor version
        * cleanup: Clean two more file type from vignettes/

2016-09-04  Nathan Russell  <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/rowSums.h: New functions
        rowSums(), colSums(), rowMeans(), and colMeans()
        * inst/include/Rcpp/sugar/functions/functions.h: Idem
        * inst/unitTests/cpp/sugar.cpp: Unit tests for new functions
        * inst/unitTests/runit.sugar.R: Idem

2016-09-04  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.7
        * inst/NEWS.Rd: Release 0.12.7
        * vignettes/Rcpp.bib: Release 0.12.7
        * inst/include/Rcpp/config.h: Release 0.12.7

        * README.md: Updated counts for dependents and tests

        * debian/*: Changes for Debian release of 0.12.7

2016-09-02  Simon Dirmeier <simon.dirmeier@bsse.ethz.ch>

        * src/attributes.cpp: Remove leading underscore in header guard

2016-08-14  James J Balamuta  <balamut2@illinois.edu>

        * inst/examples/FastLM/lmGSL.R: Updated example to use new GSL templates

2016-08-11  Dirk Eddelbuettel  <edd@debian.org>

        * .travis.yml: Switch to using run.sh for Travis CI

2016-08-09  Artem Klevtsov <a.a.klevtsov@gmail.com>

        * inst/include/Rcpp/macros/dispatch.h: Add variadic conditional macro
        when C++11 compiler used
        * ints/include/unitTests/cpp/dispatch.cpp: Add unit tests for
        RCPP_RETURN_VECTOR and RCPP_RETURN_MATRIX macro
        * ints/include/unitTests/runit.dispatch.R: Idem

2016-08-05  James J Balamuta  <balamut2@illinois.edu>

        * inst/examples/FastLM/fastLMviaArmadillo.r: format fix
        * inst/examples/FastLM/lmGSL.R: Updated example to use
        Rcpp attributes instead of cxxfunction
        * inst/examples/FastLM/lmArmadillo.R: Idem
        * inst/examples/functionCallback/newApiExample.r: Idem
        * inst/examples/RcppInline/RcppInlineExample.r: Idem
        * inst/examples/RcppInline/RcppInlineWithLibsExamples.r: Idem
        * inst/examples/RcppInline/UncaughtExceptions.r: Idem
        * inst/examples/RcppInline/external_pointer.r: Idem

2016-08-04  James J Balamuta  <balamut2@illinois.edu>

        * src/attributes.cpp: Correct variable re-declaration
        * inst/examples/RcppGibbs/RcppGibbs.R: Updated example to use Rcpp
        attributes instead of cxxfunction
        * inst/examples/RcppGibbs/timeRNGs.R: Idem

2016-08-03  Dirk Eddelbuettel  <edd@debian.org>

        * .gitattributes: Added to have ChangeLog and NEWS.Rd merge via union

2016-08-02  James J Balamuta  <balamut2@illinois.edu>

        * R/Rcpp.package.skeleton.R: Added autogeneration warning
        * src/attributes.cpp: Fixed invalid C++ Identifiers and modified export
        header to warn against hand edits
        * vignettes/Rcpp-package.Rnw: Updated code generation snippets
        * man/Rcpp.package.skeleton.Rd: Add warning on hand edits to the
        autogenerated RcppExports files.
        * man/compileAttributes.Rd: Idem

2016-08-02 Qiang Kou <qkou@umail.iu.edu>

        * inst/include/Rcpp/String.h: CE_UTF8 as default encoding
        * inst/unitTests/cpp/String.cpp: Update unit test
        * inst/unitTests/runit.String.R: Idem

2016-08-01 Nathan Russell <russell.nr2012@gmail.com>

        * inst/include/Rcpp/vector/Vector.h: Added decreasing option for Vector
        sort
        * inst/include/Rcpp/internal/NAComparator.h: Idem
        * inst/unitTests/cpp/Vector.cpp: Idem
        * inst/unitTests/runit.Vector.R: Idem

2016-07-31 Qiang Kou <qkou@umail.iu.edu>

        * inst/examples/SugarPerformance/sugarBenchmarks.R: Remove usage of Rf_eval
        * inst/include/Rcpp/Environment.h: Idem
        * inst/include/Rcpp/Module.h: Idem
        * inst/include/Rcpp/exceptions.h: Idem
        * inst/include/Rcpp/proxy/FieldProxy.h: Idem
        * inst/include/Rcpp/r_cast.h: Idem
        * inst/unitTests/cpp/language.cpp: Idem
        * src/barrier.cpp: Idem

2016-07-24  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/cpp/rmath.cpp: Added RNG unit tests for sugar variants
        * inst/unitTests/runit.rmath.R: Idem

2016-07-22  James J Balamuta  <balamut2@illinois.edu>

        * inst/unitTests/cpp/rmath.cpp: Added unit tests for Rmath RNGs
        * inst/unitTests/runit.rmath.R: idem
        * inst/include/Rcpp/Environment.h: Added get() & find() that accept
        a symbol
        * inst/include/Rcpp.h: Modified header load order so that Symbol.h
        is now placed before Environment.h

2016-07-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Roll minor release

2016-07-18  Kevin Ushey  <kevin@rstudio.com>

        * inst/include/Rcpp/r/headers.h: Ensure NORET macro is set appropriately

2016-07-18  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.6
        * inst/NEWS.Rd: Release 0.12.6
        * vignettes/Rcpp.bib: Release 0.12.6, RProtoBuf updates
        * inst/include/Rcpp/config.h: Release 0.12.6

        * README.md: Updated counts for dependents and tests

        * debian/*: Changes for Debian release of 0.12.5

2016-07-17  James J Balamuta  <balamut2@illinois.edu>

        * vignettes/Rcpp-quickref.Rnw: Added sections on Rcpp attributes and
        plugins. Facelifts on important notes, inline, environments, and calling
        R functions.

2016-07-16  Daniel C. Dillon  <dcdillon@gmail.com>

        * Added a const_interator typedef to VectorBase

2016-07-15  James J Balamuta  <balamut2@illinois.edu>

        * vignettes/Rcpp-FAQ.Rnw: Added section on default function parameters

2016-07-15  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: Also point to Rcpp-attributes in Question 1

2016-07-13  Dirk Eddelbuettel  <edd@debian.org>

        * NAMESPACE: Add import for glob2rx to please R CMD check
        * man/cppFunction.Rd: line break below 90 columns to please R CMD check

2016-07-11  J.J. Allaire <jj@rstudio.org>

        * R/Attributes.R Add cacheDir argument to sourceCpp to enable caching of
        shared libraries across R sessions
        * src/attributes.cpp Add cacheDir argument to sourceCpp to enable caching of
        shared libraries across R sessions
        * man/sourceCpp.Rd: Document new cacheDir option
        * man/cppFunction.Rd: Idem
        * man/evalFunction.Rd: Idem

2016-07-10  Nathan Russell <russell.nr2012@gmail.com>

        * inst/include/Rcpp/algorithm.h: Accomodate clang compiler

2016-07-03  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Rolling minor version

2016-07-02  Qiang Kou  <qkou@umail.iu.edu>

        * src/attributes.cpp: Replace '.' in package names

2016-06-23  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Rolling minor version

        * inst/include/Rcpp/exceptions.h (Rcpp): Also expose Rf_warningcall()
        within Rcpp namespace (without leading Rf_)

2016-06-20  Qin Wenfeng <mail@qinwenfeng.com>

        * inst/include/Rcpp/exceptions.h: add RCPP_USING_UTF8_ERROR_STRING macro
        to use UTF-8 encoding exception string in R

2016-06-14  Artem Klevtsov <a.a.klevtsov@gmail.com>

        * inst/include/Rcpp/sugar/functions/na_omit.h: Improve na_omit for
        vectors without NA
        * inst/unitTests/cpp/sugar.cpp: Add unit test for the na_omit
        * inst/unitTests/runit.sugar.R: Ditto

2016-06-02  Kirill Müller  <krlmlr@mailbox.org>

        * inst/include/Rcpp/algorithm.h: Use "long long" only if available
        * inst/include/Rcpp/exceptions.h: Annotate stop() with NORET

2016-05-18  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/algorithm.h: New approach for sugar

        * inst/unitTests/cpp/algorithm.cpp: Unit test support
        * inst/unitTests/runit.algorithm.R: Ditto

2016-05-17  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Rolling minor version

2016-05-16  Qiang Kou  <qkou@umail.iu.edu>

        * inst/include/Rcpp/String.h: Correct string replacement
        * inst/unitTests/runit.String.R: Unit test

2016-05-16  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/sugar/functions/max.h: Fixing constness
        * inst/include/Rcpp/sugar/functions/min.h: Ditto

2016-05-15  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/vector/Matrix.h: Correcting ambiguities in
        Vector/Matrix and scalar operations
        * inst/include/Rcpp/sugar/operators/divides.h: Ditto
        * inst/include/Rcpp/sugar/operators/minus.h: Ditto
        * inst/include/Rcpp/sugar/operators/plus.h: Ditto
        * inst/include/Rcpp/sugar/operators/times.h: Ditto

2016-05-14  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.5
        * inst/NEWS.Rd: Release 0.12.5
        * vignettes/Rcpp.bib: Release 0.12.5
        * inst/include/Rcpp/config.h: Release 0.12.5

        * debian/*: Changes for Debian release of 0.12.5

        * vignettes/Rcpp.bib: Updated references

2016-05-13  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Rolled minor version

        * R/compilerCheck.R: Minimal R function to check g++ version sufficiency
        * man/compilerCheck.Rd: Documentation

2016-05-11  Dirk Eddelbuettel  <edd@debian.org>

        * R/Rcpp.package.skeleton.R: Modified to create a package without notes,
        warnings, or error even pkgKitten is not available

        * R/Rcpp.package.skeleton.R (.playWithPerPackageHelpPage): Added new
        helper function to be used when pkgKitten is not available
        * inst/skeleton/manual-page-stub.Rd: Stub for per-package help page used
        when pkgKitten is not available

2016-05-10  Dirk Eddelbuettel  <edd@debian.org>

        * R/Rcpp.package.skeleton.R: Also correct Title: and Description: to
        satisfy R CMD check in R-release and (current) R-devel

2016-05-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/cpp/Matrix.cpp: Made four scalar/matrix tests less
        ambiguous for overloads by using double as scalar

2016-05-06  Dirk Eddelbuettel  <edd@debian.org>

        * R/loadRcppModules.R (loadRcppModules): Add call to .Deprecated
        pointing out that loadModule is preferred
        * man/Rcpp-deprecated.Rd: Added to list deprecated functions
        * man/loadRcppModules-deprecated.Rd: Renamed to -deprecated, added link
        to loadModule which is the preferred method

        * vignettes/Rcpp-modules.Rnw: Updated with respect to loadRcppModules
        deprecation and loadModule being preferred

2016-04-15  Kevin Ushey <kevinushey@gmail.com>

        * src/attributes.cpp: Add a missing 'winslash = "/"'

2016-04-14  J.J. Allaire <jj@rstudio.org>

        * src/attributes.cpp: Correct handling of dependent file paths on
        Windows (use winslash = "/")

2016-04-13  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Rolling minor version and Date

2016-04-11  Ben Goodrich  <goodrich.ben@gmail.com>

        * R/Module.R: Avoid calling as.character() on C++Object to prevent race

2016-04-02  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Rolled to minor version 0.12.4.3
        * inst/include/Rcpp/config.h: Ditto

        * ChangeLog: Added entries for PRs 453 and 454
        * inst/NEWS.Rd: Add two missing \item uses

        * R/Module.R: Rename copy to copyObject to avoid function name collisions
        * inst/unitTests/runit.Module.R: Ditto
        * man/copyObject.Rd: Ditto
        * inst/NEWS.Rd: Ditto
        * NAMESPACE: Ditto

        * inst/unitTests/runit.environments.R: Skip test.environment.child test

2016-03-31  Romain Francois <romain@r-enthusiasts.com>

        * R/Modules.R: New top-level functions copy, destruct and is_destructed
        * NAMESPACE: New functions copy, destruct and is_destructed exported
        * man/copy.Rd: New manual page
        * man/destruct.Rd: Ditto

        * inst/include/Rcpp/module/class.h: Add copy constructortor + destructor
        * inst/include/Rcpp/module/class_Base.h: Ditto
        * src/Module.cpp: Ditto
        * src/Rcpp_init.cpp: Ditto
        * src/internal.h: Ditto

        * inst/include/Rcpp/traits/traits.h: New trait detecting copy contructor
        * inst/include/Rcpp/traits/has_copy_constructor.h: Ditto

        * inst/unitTests/runit.Module.R: Test new copy constructor and destructor
        * inst/unitTests/cpp/Module.cpp: Ditto

2016-03-29  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/String.h: Correct Rcpp::String for Rcpp::Nullable

2016-03-27  Qin Wenfeng  <mail@qinwenfeng.com>

        * R/Attributes.R: Support new R 3.3.0 Windows toolchain

2016-03-26  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Rolled Date and minor Version

2016-03-23  Sergio Marques <sergio.rtmarques@gmail.com>

        * src/api.cpp: Also check a flag __MUSL__ to accomodate Alpine

2016-03-22  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.4
        * inst/NEWS.Rd: Release 0.12.4
        * vignettes/Rcpp.bib: Release 0.12.4
        * inst/include/Rcpp/config.h: Release 0.12.4

        * debian/*: Changes for Debian release of 0.12.4

2016-03-19  Dirk Eddelbuettel  <edd@debian.org>

        * README.md: Use canonical CRAN URL to please R-devel CMD check

2016-03-12  Nathan Russell <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/cbind.h: Undefine MakeBindable macro
        after use

2016-03-12  Nathan Russell <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/cbind.h: New cbind() function
        * inst/include/Rcpp/sugar/functions/functions.h: Idem
        * inst/unitTests/cpp/sugar.cpp: Unit tests for cbind()
        * inst/unitTests/runit.sugar.R: Idem

2016-03-09  Colin Gillespie <csgillespie@gmail.com>

        * vignettes/Rcpp-sugar.Rnw: Correct typos and indentation

2016-03-09  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/stats/random/rlogis.h: Updated Emacs header and
        copyright, aligned indentation
        * inst/include/Rcpp/stats/random/rnbinom.h: Idem
        * inst/include/Rcpp/stats/random/rnbinom_mu.h: Idem
        * inst/include/Rcpp/stats/random/rnchisq.h: Idem
        * inst/include/Rcpp/stats/random/rnorm.h: Idem
        * inst/include/Rcpp/stats/random/rt.h: Idem
        * inst/include/Rcpp/stats/random/runif.h: Idem
        * inst/include/Rcpp/stats/random/rweibull.h: Idem
        * inst/include/Rcpp/stats/random/random.h: Idem
        * inst/include/Rcpp/stats/random/rcauchy.h: Idem
        * inst/include/Rcpp/stats/random/rchisq.h: Idem
        * inst/include/Rcpp/stats/random/rexp.h: Idem
        * inst/include/Rcpp/stats/random/rf.h: Idem
        * inst/include/Rcpp/stats/random/rgeom.h: Idem
        * inst/include/Rcpp/stats/random/rlnorm.h: Idem
        * inst/include/Rcpp/stats/random/rbeta.h: Idem
        * inst/include/Rcpp/stats/random/rbinom.h: Idem
        * inst/include/Rcpp/stats/random/rgamma.h: Idem
        * inst/include/Rcpp/stats/random/rhyper.h: Idem
        * inst/include/Rcpp/stats/random/rpois.h: Idem
        * inst/include/Rcpp/stats/random/rsignrank.h: Idem
        * inst/include/Rcpp/stats/random/rwilcox.h: Idem

2016-03-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/stats/beta.h: Updated Emacs header and copyright
        * inst/include/Rcpp/stats/binom.h: Idem
        * inst/include/Rcpp/stats/cauchy.h: Idem
        * inst/include/Rcpp/stats/chisq.h: Idem
        * inst/include/Rcpp/stats/f.h: Idem
        * inst/include/Rcpp/stats/gamma.h: Idem
        * inst/include/Rcpp/stats/geom.h: Idem
        * inst/include/Rcpp/stats/hyper.h: Idem
        * inst/include/Rcpp/stats/nbeta.h: Idem
        * inst/include/Rcpp/stats/nbinom.h: Idem
        * inst/include/Rcpp/stats/nbinom_mu.h: Idem
        * inst/include/Rcpp/stats/nchisq.h: Idem
        * inst/include/Rcpp/stats/nf.h: Idem
        * inst/include/Rcpp/stats/nt.h: Idem
        * inst/include/Rcpp/stats/pois.h: Idem
        * inst/include/Rcpp/stats/stats.h: Idem
        * inst/include/Rcpp/stats/t.h: Idem
        * inst/include/Rcpp/stats/unif.h: Idem
        * inst/include/Rcpp/stats/dpq/dpq.h: Idem

2016-03-05  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/stats/exp.h: Replaced initial Emacs header line with
        current one, ran M-x untabify, streamlined indentation, update copyright
        * inst/include/Rcpp/stats/lnorm.h: Idem
        * inst/include/Rcpp/stats/logis.h: Idem
        * inst/include/Rcpp/stats/norm.h: Idem
        * inst/include/Rcpp/stats/weibull.h: Idem

2016-03-04  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.Function.R: Switched to '/usr/bin/env r'
        * inst/unitTests/runit.table.R: Idem
        * inst/unitTests/runit.as.R: Idem
        * inst/unitTests/runit.Date.R: Idem
        * inst/unitTests/runit.misc.R: Idem
        * inst/unitTests/runit.Language.R: Idem
        * inst/unitTests/runit.subset.R: Idem
        * inst/unitTests/runit.wrap.R: Idem
        * inst/unitTests/runit.sugar.R: Idem
        * inst/unitTests/runit.na.R: Idem
        * inst/unitTests/runit.String.R: Idem
        * inst/unitTests/runit.Vector.R: Idem
        * inst/unitTests/runit.environments.R: Idem
        * inst/unitTests/runit.Reference.R: Idem
        * inst/unitTests/runit.Matrix.R: Idem
        * inst/unitTests/runit.client.package.R: Idem
        * inst/unitTests/runit.binary.package.R: Idem
        * inst/unitTests/runit.support.R: Idem
        * inst/unitTests/runit.S4.R: Idem
        * inst/unitTests/runit.RObject.R: Idem
        * inst/unitTests/runit.modref.R: Idem
        * inst/unitTests/runit.InternalFunctionCPP11.R: Idem
        * inst/unitTests/runit.attributes.R: Idem
        * inst/unitTests/runit.sugar.var.R: Idem
        * inst/unitTests/runit.Module.R: Idem
        * inst/unitTests/runit.XPTr.R: Idem
        * inst/unitTests/runit.Module.client.package.R: Idem
        * inst/unitTests/runit.stats.R: Idem
        * inst/unitTests/runit.rmath.R: Idem
        * inst/unitTests/runit.DataFrame.R: Idem
        * inst/unitTests/runit.wstring.R: Idem
        * inst/unitTests/runit.InternalFunction.R: Idem

2016-03-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/FastLM/benchmarkLongley.r: Switched to '/usr/bin/env r'
        * inst/examples/FastLM/fastLMviaArmadillo.r: Idem
        * inst/examples/FastLM/fastLMviaGSL.r: Idem
        * inst/examples/FastLM/lmArmadillo.R: Idem
        * inst/examples/FastLM/lmGSL.R: Idem
        * inst/examples/FastLM/benchmark.r: Idem
        * inst/examples/ConvolveBenchmarks/exampleRCode.r: Idem

2016-02-27  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/RcppInline/RcppInlineWithLibsExamples.r: Switched to
        using '/usr/bin/env r', switch to using 'cxxfunction' and RcppGSL plugin

        * inst/examples/RcppInline/external_pointer.r: Switched to '/usr/bin/env r'
        * inst/examples/RcppInline/RcppInlineExample.r: Idem
        * inst/examples/ConvolveBenchmarks/overhead.r: Idem

        * inst/include/Rcpp/Fast.h (Rcpp): Undo two const declarations

2016-02-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/OpenMP/OpenMPandInline.r: Switched to '/usr/bin/env r'
        * inst/examples/RcppInline/RcppSimpleExample.r: Idem
        * inst/examples/RcppInline/RObject.r: Idem
        * inst/examples/RcppInline/UncaughtExceptions.r: Idem

2016-02-21  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/functionCallback/newApiExample.r (vecfunc): Switched to
        using '/usr/bin/env r', switch to using 'cxxfunction'

        * inst/examples/Misc/fibonacci.r: Switched to using '/usr/bin/env r',
        added explicit load of Rcpp package

        * inst/examples/Misc/newFib.r: Switched to using '/usr/bin/env r'
        * inst/examples/Misc/ifelseLooped.r: Idem
        * inst/examples/Misc/piBySimulation.r: Idem
        * inst/examples/SugarPerformance/sugarBenchmarks.r: Idem

2016-02-16  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: Added answer on fixed-size limit of arguments

2016-02-07  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R (sourceCppFunction): Use fully matched seq(along.with=...)

        * vignettes/Rcpp-FAQ.Rnw: Added a table of contents

2016-02-06  James J Balamuta  <balamut2@illinois.edu>

        * vignettes/Rcpp-FAQ.Rnw (Rcpp): Additional material, and corrections,
        for use on OS X

2016-01-30  Qiang Kou  <qkou@umail.iu.edu>

        * inst/include/Rcpp/vector/Subsetter.h: Fix the error under gc
        * inst/unitTests/cpp/Vector.cpp : Add tests
        * inst/unitTests/runit.Vector.R : Idem

2016-01-29  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw (Rcpp): Add new entry about required TeXlive
        installation to build vignettes (issue #422)

2016-01-22  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Mark as 0.12.3.1

2016-01-22  Daniel C. Dillon  <dcdillon@gmail.com>

        * R/Attributes.R: Add plugin for cpp14

2016-01-18  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/Nullable.h: Add isUsable()
        * inst/unitTests/cpp/misc.cpp: Add tests
        * inst/unitTests/runit.misc.R: Idem

2016-01-17  Nathan Russell <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/median.h: New function
        * inst/unitTests/cpp/sugar.cpp: Add tests
        * inst/unitTests/runit.sugar.R: Idem

2016-01-17  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/Nullable.h: Add as() and clone()
        * inst/unitTests/cpp/misc.cpp: Add tests
        * inst/unitTests/runit.misc.R: Idem

2016-01-13  Kirill Mueller  <kirill.mueller@ivt.baug.ethz.ch>

        * inst/include/Rcpp/Nullable.h: Added const support
        * inst/unitTests/cpp/misc.cpp: Added tests for const support

2016-01-10  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.3
        * inst/NEWS.Rd: Release 0.12.3
        * vignettes/Rcpp.bib: Release 0.12.3
        * inst/include/Rcpp/config.h: Release 0.12.3

        * debian/*: Changes for Debian release of 0.12.3

        * vignettes/Rcpp.bib: Updated all CRAN reference to current versions

2016-01-09  Dirk Eddelbuettel  <edd@debian.org>

        * Contributing.md: Added to GitHub repo

        * .Rbuildignore: Ensure Contributing.md is not in R package, also
        removed two old entries

2015-12-29  Joshua Pritikin <jpritikin@pobox.com>

        * inst/include/Rcpp/Module.h: Initialize base class in copy ctor
        * inst/include/Rcpp/macros/interface.h: Idem

2015-12-12  Qiang Kou <qkou@umail.iu.edu>

        * inst/include/Rcpp/String.h: std::hash<Rcpp::String>
        * inst/unitTests/cpp/wrap.cpp: Unit tests
        * inst/unitTests/runit.wrap.R: Unit tests

2015-12-04  Qiang Kou <qkou@umail.iu.edu>

        * inst/include/Rcpp/vector/Matrix.h: Add math operators between matrix
        and scalar
        * inst/unitTests/runit.Matrix.R: Unit tests
        * inst/unitTests/cpp/Matrix.cpp: Unit tests

2015-11-27  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/vector/proxy.h: const_iterators for CharacterVector
        now work analogously to iterators
        * inst/include/Rcpp/vector/const_generic_proxy.h: Idem
        * inst/include/Rcpp/vector/const_string_proxy.h: Idem
        * inst/include/Rcpp/vector/traits.h: Idem

        * inst/unitTests/cpp/Vector.cpp: Tests for above
        * inst/unitTests/runit.Vector.R: Idem

        [ All this was commited on Sep 5 but only merged Nov 27 ]

2015-11-25  JJ Allaire <jj@rstudio.org>

        * src/attributes.cpp: Avoid invalid function names when
        generating C++ interfaces.

2015-11-15  Kazuki Fukui  <kazunoko93@gmail.com>>

        * src/attributes.cpp: Insert extra space around & in interface

2015-11-14  Dirk Eddelbuettel  <edd@debian.org>

        * .travis.yml: Add token for secure Slack & Travis integration

2015-11-14  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.2
        * inst/NEWS.Rd: Release 0.12.2
        * vignettes/Rcpp.bib: Release 0.12.2
        * inst/include/Rcpp/config.h: Release 0.12.2

        * debian/*: Changes for Debian release of 0.12.2

        * vignettes/Rcpp.bib: Updated all CRAN reference to current versions

2015-11-13  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/complex.h: Define a header guard for dplyr to
        prevent errorneous redefinition of operator<<() via dplyr

2015-11-11  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/Matrix.h: Further simplification

2015-11-11  Qiang Kou <qkou@umail.iu.edu>

        * include/Rcpp/complex.h: operator<< for Rcomplex

2015-11-10  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/Matrix.h: Added transpose for character
        matrices as well

        * inst/unitTests/runit.Matrix.R: New unit tests
        * inst/unitTests/cpp/Matrix.cpp: Ditto

2015-11-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/Matrix.h: Matrix transpose is now a free
        function for both INTSXP and REALSXP

        * inst/unitTests/runit.Matrix.R: New unit tests
        * inst/unitTests/cpp/Matrix.cpp: Ditto

2015-11-08  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/Nullable.h: No longer prevent assignment of
        R_NilValue to Nullable<> in function signatures

        * inst/include/Rcpp/vector/Matrix.h: Use showpoint in operator<<()

2015-11-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/Matrix.h: Beginnings of a Matrix transpose

2015-11-06  Kevin Ushey <kevinushey@gmailcom>

        * inst/include/Rcpp/vector/Subsetter.h: Add sugar math operators
        * inst/unitTests/runit.subset.R: Unit tests
        * inst/unitTests/cpp/Subset.cpp: Unit tests
        * inst/NEWS.Rd: NEWS entry

2015-11-01  Qiang Kou <qkou@umail.iu.edu>

        * inst/include/Rcpp/vector/MatrixColumn.h: Fix overflow

2015-11-01  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Roll Version: to 0.12.1.4

2015-10-30  Nathan Russell <russell.nr2012@gmail.com>

        * inst/include/Rcpp/sugar/functions/cummax.h: New sugar function
        * inst/include/Rcpp/sugar/functions/cummin.h: New sugar function
        * inst/include/Rcpp/sugar/functions/cumprod.h: New sugar function
        * inst/unitTests/cpp/sugar.cpp: Unit test support for new functions
        * inst/unitTests/runit.sugar.R: Ditto

2015-10-08  Tianqi Chen <tianqi.tchen@gmail.com>

        * inst/include/Rcpp/api/meat/is.h: Enhance the check for Rcpp Module
        objects (PR #381 fixing #380)

2015-10-01  JJ Allaire <jj@rstudio.org>

        * src/attributes.cpp: Enable export of C++ interface for functions that
        return void

2015-09-28  Dirk Eddelbuettel  <edd@debian.org>

        * inst/NEWS.Rd: GitHub pull requests and issues are now linked

        * src/barrier.cpp: Use SET_STRING_ELT() on LHS (with thanks to Luke)

2015-09-21  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/String.h: Before assigning ensure we received
        exactly one string argument

2015-09-10  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.1
        * inst/NEWS.Rd: Release 0.12.1
        * vignettes/Rcpp.bib: Release 0.12.1
        * inst/include/Rcpp/config.h: Release 0.12.1

        * debian/*: Changes for Debian release of 0.12.1

2015-09-09  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-attributes.Rnw: Less harsh grey border around code
        * vignettes/Rcpp-*.Rnw: Ditto

        * inst/include/Rcpp/String.h: More comparison operators

2015-09-08  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/vector/string_proxy.h: More comparison operators
        * inst/include/Rcpp/vector/const_string_proxy.h: More comparison operators

2015-09-08  Florian Plaza Onate <florian.plaza@jouy.inra.fr>

        * inst/include/Rcpp/Dimension.h: Correct creation and access of large
        matrices
        * inst/include/Rcpp/vector/Matrix.h: Ditto

2015-09-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Nullable.h: New class for objects which may be NULL
        * inst/unitTests/cpp/Vector.cpp: Unit tests for Nullable
        * inst/unitTests/runit.Vector.R: Ditto

2015-09-06  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/String.h: Make strings and string_proxies comparable
        * inst/unitTests/cpp/String.cpp: Unit tests for above
        * inst/unitTests/runit.String.R: Ditto

2015-09-05  Daniel C. Dillon  <dcdillon@gmail.com>

        * inst/include/Rcpp/vector/Matrix.h: Matrix now has appropriate operator<<
        * inst/include/Rcpp/vector/Vector.h: Vector now has appropriate operator<<
        * inst/unitTests/cpp/Vector.cpp: Unit tests for above

2015-09-01  Florian Plaza Onate <florian.plaza@jouy.inra.fr>

        * inst/include/Rcpp/vector/Subsetter.h: Allow logical subsets to be
        assigned to a vector of size 1
        (pull request #349, discussed in issue #345)
        * inst/unitTests/cpp/Subset.cpp: Add unit test for above
        * inst/unitTests/runit.subset.R: Ditto

2015-08-31  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version, Date): Roll Version and Date

2015-08-30  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp.bib: Updated RcppGSL entry

2015-08-29  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp.bib: Add RcppZiggurat entry

        * inst/include/Rcpp/utils/tinyformat.h: Updated to current upstream
        version keeping our local modifications / adaptations (PR #357)

2015-08-29  Qiang Kou <qkou@umail.iu.edu>

        * inst/include/Rcpp/vector/Subsetter.h: Enable logical subsetting on
        both LHS and RHS, eg 'a[b > 3] = b[b > 3]' (pull request #352 addressing
        issue #345)
        * inst/unitTests/cpp/Subset.cpp: Ditto
        * inst/unitTests/runit.subset.R: Unit tests for above

2015-08-26  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/testRcppClass/src/rcpp_module.cpp: Renamed Module
        'World' to 'RcppClassWorld' to avoid multiple modules with same name
        (pull request #351, fixed issue #350)

        * inst/unitTests/testRcppClass/man/Rcpp_class_examples.Rd: Ditto
        * inst/unitTests/testRcppClass/R/load.R: Ditto
        * inst/unitTests/testRcppClass/NAMESPACE: Ditto
        * inst/unitTests/runit.Module.client.package.R: Re-enable test

        * inst/unitTests/testRcppModule/src/rcpp_module.cpp: Renamed Module
        'World' to 'RcppModuleWorld' to avoid multiple modules with same name

        * inst/unitTests/cpp/modref.cpp: Rename 'World' to 'ModRefWorld'
        * inst/unitTests/runit.modref.R (test.modRef): Ditto

        * inst/unitTests/cpp/Module.cpp: Rename 'World' to 'ModuleWorld'
        * inst/unitTests/runit.Module.R (test.Module): Ditto

2015-08-25  Kurt Hornik  <Kurt.Hornik@wu.ac.at>

        * R/loadModule.R: For now=TRUE, always set .botched to FALSE which
        corresponds to the case of the methods package being in the search path
        * inst/include/Rcpp/Reference.h: Call call with the internal Namespace

2015-08-24  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp.bib: Updated R / R Core references

2015-08-23  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/Benchmark/Timer.h: Silence 'g++ -pedantic' by
        replaceing one R_xlen_t by size_t (pull request #348)

2015-08-19  Florian Plaza Onate <florian.plaza@jouy.inra.fr>
        * inst/include/Rcpp/vector/Vector.h: Add 'at' methods which implement
        accessors with bounds cheking (pull request #342, fixes issue #341)
        * inst/include/Rcpp/vector/Matrix.h: Ditto
        * inst/unitTests/cpp/Vector.cpp: Add unit tests for at acessors
        * inst/unitTests/cpp/Matrix.cpp: Ditto
        * inst/unitTests/runit.Vector.R: Ditto
        * inst/unitTests/runit.Matrix.R: Ditto

2015-08-18  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.Module.client.package.R: Disabled for bad
        interaction of Rcpp Modules and R 3.2.2

2015-08-15  Florian Plaza Onate <florian.plaza@jouy.inra.fr>

        * inst/include/Rcpp/vector/converter.h: Correct conversion from const
        char argument (pull request #344, fixes issue #343)

2015-08-14  Florian Plaza Onate <florian.plaza@jouy.inra.fr>

        * inst/include/Rcpp/vector/DimNameProxy.h: Add assignment operator,
        refactor code, update error message formatting (pull request #339)

2015-08-05  Kevin Ushey  <kevinushey@gmail.com>

        * src/api.cpp: use `_WIN32` instead of `WIN32`

2015-08-02  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R (sourceCpp): In no-rebuild-needed case, also set a
        default directory restoration via on.exit() (pull request #335,
        addressing issue #309)

2015-07-24  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.12.0
        * inst/NEWS.Rd: Release 0.12.0
        * vignettes/Rcpp.bib: Release 0.12.0
        * inst/include/Rcpp/config.h: Release 0.12.0

        * debian/*: Changes for Debian release of 0.12.0

2015-07-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Symbol.h: Use Rf_installChar(x) instead of
        Rf_install(CHAR(X)) if R 3.2.0 or later is used

2015-07-07  Qiang Kou <qkou@umaikl.iu.edu>

        * src/include/Rcpp/String.h: Ensure proper initialization of String
        objects from two constructors
        * inst/unitTests/cpp/String.cpp: New unit test
        * inst/unitTests/runit.String.R: Ditto

2015-07-21  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/api/meat/Rcpp_eval.h: don't use 'CDDDR'

2015-07-20  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Rolled minor Date and Version

        * R/Attributes.R: Use explicit 'utils::assignInMyNamespace'

        * R/Rcpp.package.skeleton.R: Use explicit 'utils::package.skeleton'

2015-07-17  JJ Allaire <jj@rstudio.org>

        * Rcpp.Rproj: don't use devtools mode in RStudio (enables the
        Test Package command to invoke the RUnit based test-suite)
        * src/attributes.cpp: Correctly handle signature termination
        characters ('{' or ';') contained in quotes

2015-07-16  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/api/meat/Rcpp_eval.h: Don't use 'R_ToplevelExec';
        ensure Rcpp_eval respects previously established handlers. Capture
        errors + interrupts with R-level 'tryCatch'.
        * inst/NEWS.Rd: Add news entry

2015-07-14  JJ Allaire <jj@rstudio.org>

        * src/attributes.cpp: fix crash on second call to sourceCpp

2015-07-07  Qiang Kou <qkou@umaikl.iu.edu>

        * src/include/Rcpp/String.h: Use Rcpp_PreserveObject and
        Rcpp_ReplaceObject to protect underlying SEXP inside String objects

2015-07-07  Matt P. Dziubinski  <matdzb@gmail.com>

        * inst/include/Rcpp/sugar/functions/var.h: Variance -- changed from
        the unstable formula back to the stable (two-pass) formula, fixed
        support for complex numbers (formula correction).
        * inst/unitTests/runit.sugar.var.R: Added tests for complex variance
        computation, applied simple code refactoring.

2015-07-04  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp.bib: Updated reference to several CRAN packages

2015-07-02  Kevin Ushey  <kevinushey@gmail.com>

        * .clang_format: Added

2015-06-25  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/api/meat/Rcpp_eval.h: reset error after Rcpp_eval
        * inst/unitTests/cpp/Function.cpp: unit tests
        * inst/unitTests/runit.Function.R: unit tests
        * inst/include/Rcpp/Function.h: catch empty error messages
        * inst/include/Rcpp/api/meat/Rcpp_eval.h: protect call

2015-06-24  Qiang Kou <qkou@umaikl.iu.edu>

        * inst/include/Rcpp/String.h: Support encodings
        * src/String.cpp: Ditto
        * inst/unitTests/runit.String.R: Add unit tests

2015-06-18  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R (evalCpp): Add support for plugings argument
        * man/evalCpp.Rd: Document argument

2015-06-07  JJ Allaire <jj@rstudio.org>

        * src/attributes.cpp: Don't load sourceCpp dynamic library if it's
        already been loaded

2015-06-05  Dirk Eddelbuettel  <edd@debian.org>

        * R/Rcpp.package.skeleton.R (Rcpp.package.skeleton): Remove
        `character.only=TRUE` from `requireNamespace()` as it happens to flip
        the boolean value too

2015-06-03  Qiang Kou <qkou@umaikl.iu.edu>

        * inst/include/Rcpp/*: Finish changing R_len_t to R_xlen_t
        * src/*: Ditto

2014-05-27  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/DataFrame.h: Safe DataFram constructor

2015-05-16  Qiang Kou <qkou@umaikl.iu.edu>

        * inst/include/Rcpp/*: Begin changing R_len_t to R_xlen_t
        * src/*: Ditto

2015-05-17  Matt P. Dziubinski  <matdzb@gmail.com>

        * inst/include/Rcpp/platform/compiler.h: Added RCPP_USING_CXX0X_OR_LATER
        * inst/include/Rcpp/sugar/functions/sapply.h: Updated to support lambda functions

2015-05-01  Kevin Ushey  <kevinushey@gmail.com>

        * vignettes/Rcpp-FAQ.Rnw: Notes on installing gfortran

2015-05-01  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.11.6
        * inst/NEWS.Rd: Release 0.11.6
        * inst/include/Rcpp/config.h: Release 0.11.6

        * debian/*: Changes for Debian release of 0.11.6

2015-04-27  JJ Allaire  <jj@rstudio.org>

        * src/Module.cpp: Revert parts of PR291 pertaining to Modules and {BEGIN/END}_RCPP
        * inst/include/Rcpp/api/meat/module/Module.h: Ditto
        * inst/include/Rcpp/InternalFunctionWithStdFunction.h: Ditto
        * inst/include/Rcpp/module/Module_generated_CppFunction.h: Ditto
        * inst/include/Rcpp/module/class.h: Ditto

2014-04-25  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h: update the parameterization of Vector cache
        * inst/include/Rcpp/vector/traits.h: ...
        * inst/include/Rcpp/vector/00_forward_proxy.h: ...
        * inst/unitTests/runit.Vector.R: test for above changes
        * inst/unitTests/cpp/Vector.cpp: ...

2015-04-22  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/utils/tinyformat.h: don't use C++11 features

2015-04-14  Dirk Eddelbuettel  <edd@debian.org>

        * .travis.yml (sudo): Adding 'sudo: required' to force older Travis backend

2014-04-14  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/api/meat/is.h: added is__simple<Rcomplex>
        * inst/include/Rcpp/config.h: not using floating point arithmetic in preprocessor

2015-04-12  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: Also load Rcpp to make cppFunction visible

2014-04-11  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/macros/macros.h: Reworked BEGIN_RCPP and END_RCPP
        * inst/include/Rcpp/*: Removed BEGIN_RCPP and END_RCPP from a few files
        * src/Module.cpp: But added here

2015-04-19  Jonathan Marshall <jmarshall@xbmc.org>

        * inst/include/Rcpp/vector/string_proxy.h: Adds empty() constructor
        * inst/include/Rcpp/vector/const_string_proxy.h: Ditto

2015-03-18  Dmitrii Meleshko  <Dmitrii@MeleshkoDima.none>

        * inst/include/Rcpp/vector/Matrix.h: Added default ctor for 0x0 matrix

2015-03-18  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R:  Revert to use of gcc 4.6.3 with Rtools 3.3

2015-03-16  JJ Allaire  <jj@rstudio.org>

        * src/attributes.cpp: Fix failing local include test (normalize path of
        base source file so comparisons work on Windows).

2015-03-15  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R (.rtoolsPath): Replace trimws() use with a local variant

2015-03-11  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R:  Rtools 3.3 is now located and used for compilation under R 3.2.

2015-03-11  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/RcppCommon.h: Move headers into major/minor protection
        * inst/include/Rcpp/r/headers.h: New file

2015-03-04  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.11.5
        * inst/NEWS.Rd: Release 0.11.5
        * inst/include/Rcpp/config.h: Release 0.11.5

        * debian/*: Changes for Debian release of 0.11.5

2015-03-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/routines.h: Additional application of the
        'attribute_hidden' macro for a number of routines in Rcpp::internal

2015-03-02  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/print.h (Rcpp): New inline function Rcpp::print()
        * inst/include/RcppCommon.h: Include new header

        * src/api.cpp: Commented-out print() in global namespace
        * src/Rcpp_init.cpp: Commented-out registration of print()
        * inst/include/Rcpp/routines.h: Commented-out initialization

2015-03-01  Dirk Eddelbuettel  <edd@debian.org>

        * src/api.cpp: New function print() as a wrapper around Rf_PrintValue()
        * src/Rcpp_init.cpp: Corresponding registration for print()
        * inst/include/Rcpp/routines.h: Corresponding initialization

2015-02-25  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/routines.h: Use the 'attribute_hidden' define from
        the R header R_ext/Visibility.h to protect symbols (cf #264)

        * inst/include/RcppCommon.h: Also include R_ext/Visibility.h

2015-02-24  JJ Allaire  <jj@rstudio.org>

        * src/attributes.cpp: Guard against includes referencing themselves
        (and thus creating an endless loop of include processing); Process
        attributes in included files; Automatically build implementation files
        (*.cc; *.cpp) corresponding to local header files if they exist.

2015-02-20  Lionel Henry  <lionel.hry@gmail.com>

        * inst/include/Rcpp/Function.h New Function constructors that will
        perform function-lookup in an environment or in a namespace.

2015-02-19  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Bump Version: and Date:

2015-02-19  Lionel Henry  <lionel.hry@gmail.com>

        * inst/include/Rcpp/Environment.h Allow new_env() to create an
        environment with a specified parent

2015-02-19  JJ Allaire  <jj@rstudio.org>

        * vignettes/Rcpp-attributes.Rnw: Add note on using inline
        keyword from shared header files.

2015-02-17  JJ Allaire  <jj@rstudio.org>

        * vignettes/Rcpp-attributes.Rnw: Update attributes vignette
        with docs on new features.

2015-02-14  JJ Allaire  <jj@rstudio.org>

        * src/attributes.cpp: Allow includes of local files
        (e.g. #include "foo.hpp") in sourceCpp
        * Rcpp.Rproj: Specify Sweave as Rnw handler for RStudio
        * vignettes/*.Rnw: Add driver magic comment and turn off
        Sweave concordance.
        * vignettes/.gitignore: Ignore artifacts of PDF preview

2015-02-13  Dirk Eddelbuettel  <edd@debian.org>

        * .travis.yml (install): Switch to using ppa:edd/misc to install all the
        R packages needed for the Travis CI run as r-cran-* binary packages

2015-02-13  JJ Allaire  <jj@rstudio.org>

        * src/attributes.cpp: Allow 'R' to come immediately after '***'
        for defining embedded R code chunks in sourceCpp

2015-02-12  JJ Allaire  <jj@rstudio.org>

        * DESCRIPTION: bump version
        * src/attributes.cpp: Add rng parameter to Rcpp::export to
        prevent inclusion of RNGScope in generated code; recognize
        Rtools 3.2

2015-02-06  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/Subsetter.h: compare CHARSXP pointers
        rather than string contents in subsetter

2015-02-03  JJ Allaire  <jj@rstudio.org>

        * src/attributes.cpp: Simplify generated attributes code for
        RNGScope (use RObject and it's destructor rather than SEXP
        protect/unprotect).
        * vignettes/Rcpp-package.Rnw: Update docs on generated code.

2015-02-03  JJ Allaire  <jj@rstudio.org>

        * inst/include/Rcpp/exceptions.h: Add Rcpp::warning function as
        wrapper for Rf_warning

2014-02-03  JJ Allaire  <jj@rstudio.org>

        * inst/include/Rcpp/XPtr.h: Improvements to XPtr including new
        checked_get and release functions and improved behavior (throw
        an exception rather than crash) when a NULL external pointer is
        dereferenced.
        * inst/unitTests/runit.XPTr.R: tests for XPtr improvements.
        * inst/unitTests/cpp/XPtr.cpp: tests for XPtr improvements.

2014-02-03  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R: Include pkg_types.h file in RcppExports.cpp
        if it's present in inst/include or src
        * src/attributes.cpp: Include pkg_types.h file in generated
        C++ interface file if it's present in inst/include or src

2015-02-02  JJ Allaire  <jj@rstudio.org>

        * R/exceptions.R: Evaluate R code within an R_toplevelExec block
        * include/Rcpp/api/meat/Rcpp_eval.h: Evaluate R code within an
        R_toplevelExec block

2015-01-25  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/utils/tinyformat.h: define an error handler for
        tinyformat (using ::Rcpp::stop) to not spill assert

2015-01-20  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.11.4
        * inst/NEWS.Rd: Release 0.11.4
        * inst/include/Rcpp/config.h: Release 0.11.4

        * debian/*: Changes for Debian release of 0.11.4

2015-01-19  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/r/headers.h: move R headers inclusion to own file;
        move sysmacros.h workarounds to here
        * inst/include/RcppCommon.h: idem
        * inst/include/Rcpp/platform/sysmacros.h: idem

2015-01-19  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp.bib: Updated to current package versions

        * vignettes/getCurrentVersionsOfCitedPackages.R: New helper function
        * .Rbuildignore: Added vignettes/getCurrentVersionsOfCitedPackages.R

        * R/unit.tests.R (test): Use requireNamespace() instead of require()
        * R/unit.tests.R (test): Ditto

2015-01-19  Wush Wu <wush978@gmail.com>

        * inst/include/Rcpp/sugar/functions/var.h: Support four vector types
        * inst/unitTests/runit.sugar.var.R: Added corresponding tests

2015-01-16  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/String.h: fix push_front()
        * inst/unitTests/runit.String.R: test
        * inst/unitTests/cpp/String.cpp: test

2015-01-15  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/platform/sysmacros.h: remove leaked macros
        'major', 'minor', 'makedev' from <sys/sysmacros.h>
        * inst/include/RcppCommon.h: ditto
        * inst/unitTests/cpp/Vector.cpp: simple test

2015-01-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/OpenMP/GNUmakefile: Renamed from Makefile because it
        contains GNU make extentions (which we happen to like)
        * inst/examples/ConvolveBenchmarks: Ditto

2015-01-02  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/sugar/functions/setdiff.h: fix for setequals
        * inst/unitTests/cpp/sugar.cpp: unit tests
        * inst/unitTests/runit.sugar.R: unit tests

2015-01-01  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sugar/functions/mean.h: Return type is double, not
        storage type; also added logical vector case; also added integer case
        to correctly deal with NA values

        * inst/unitTests/runit.sugar.R: Added unit tests for new sugar mean()
        * inst/unitTests/cpp/sugar.cpp: C++ side of new unit tests

2014-12-31  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sugar/functions/mean.h: Support int and complex

2014-12-30  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sugar/functions/mean.h: Use two-pass method

2014-12-29  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/macros/macros.h: reformat for legibility

2014-12-11  Yixuan Qiu <yixuan.qiu@cos.name>

        * inst/include/Rcpp/internal/r_vector.h: Internal functions to
        help detect unqualified vector types for sorting, with the help
        of Romain Francois
        * inst/include/Rcpp/vector/Vector.h: Disallow sorting on List,
        RawVector and ExpressionVector, from the discussion with
        Dirk Eddelbuettel and Kevin Ushey

2014-11-30  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/proxy.h: Const iteration correction
        * inst/include/Rcpp/sugar: Ditto in three files

2014-11-25  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/grow.h: Apply additional Shield<> use around tail
        object as suggested by Martin Morgan on the rcpp-devel list

2014-11-24  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/config.h: Release version is still 0.11.3

2014-11-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/config.h: New macro RcppDevVersion to account for
        four-part development versions such as the current 0.11.3.2
        * DESCRIPTION: Version incremented to 0.11.3.2

2014-11-23  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/exceptions.h: Richer formatting for Rcpp::stop
        * inst/include/Rcpp/utils/tinyformat.h: Backend for formattinh
        * inst/unitTests/runit.misc.R: Added new unit test
        * inst/unitTests/cpp/misc.cpp: C++ backend for test

2014-11-19  Dirk Eddelbuettel  <edd@debian.org>

        * .travis.yml: Temporary stop-gap measure of setting CRAN to something
        other than the RStudio CDN which currently has DNS issue

        * inst/include/Rcpp/internal/NAComparator.h: Support sorting of complex
        numbers, thanks to patch by Yixuan Qiu (in PR #202)

2014-11-08  Kevin Ushey  <kevinushey@gmail.com>

        * R/Attributes.R: Fix regular expression used to find source files for
        compileAttributes

2014-11-02  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/RcppTestA: Rename to inst/unitTests/testRcppPackage
        * inst/unitTests/testRcppPackage: Updated throughout

        * inst/include/Rcpp/Rmath.h: As suggested by Kevin, test for R_VERSION
        via #define to conditon on R >= 3.1.2 -- this does not require a hard
        constraint in DESCRIPTION yet on newer R will get R::[dpq]nbinom_mu()

2014-11-01  Dirk Eddelbuettel  <edd@debian.org>

        * src/api.cpp: Do not include execinfo.h on AIX, per r-devel discussion
        with Mike Beddo, and http://sf.net/p/predef/wiki/OperatingSystems/

2014-10-29  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Rmath.h: Comment out R::[dpqr]nbinom_mu functions as
        not declared by R with Rf_* name-mapping prefixes

2014-10-17  Chenliang Xu <luckyrand@gmail.com>

        * R/Attributes: Enable scanning of header files

2014-10-03  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R: Only look for plugins in the package's namespace
        (rather than entire search path)

2014-10-01  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/ListOf.h ListOf<T> inherits relevant proxies
        * inst/unitTests/cpp/ListOf.cpp: Idem
        * inst/unitTests/runit.ListOf.R: Idem

2014-09-29  Dirk Eddelbuettel  <edd@debian.org>

        * debian/*: Changes for Debian release of 0.11.3

        * inst/NEWS.Rd: Removed a double entry

2014-09-27  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.11.3
        * inst/NEWS.Rd: Release 0.11.3
        * inst/include/Rcpp/config.h: Release 0.11.3

        * ChangeLog: Added a few more entries based on commit log
        * inst/NEWS.Rd: Idem

2014-09-26  JJ Allaire <jj@rstudio.org>

        * DESCRIPTION: Bump version to enable checking for dryRun.

2014-09-23  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: Add dryRun parameter to sourceCpp.

2014-09-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Shorten Description: to single paragraph

2014-09-21  Kevin Ushey  <kevinushey@gmail.com>

        * inst/unitTests/runit.environments.R: Use 'checkIdentical' as it's a
        more appropriate expression of intent

2014-09-15  Dirk Eddelbuettel  <edd@debian.org>

        * R/Rcpp.package.skeleton.R: Use more neutral default name, email settings
        * man/Rcpp.package.skeleton.Rd: Document these

2014-09-14  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/testRcppClass/man/Rcpp_class_examples.Rd: Similar
        update to yesterday's update for testRcppModule

2014-09-14  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/Vector.h: Alternate strategy using SFINAE
        * inst/include/Rcpp/traits/traits.h: Idem
        * inst/include/Rcpp/traits/enable_if.h: Idem

2014-09-13  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/Vector.h: Allow logical vectors to be created
        from bools
        * inst/unitTests/runit.Vector.R: Idem
        * inst/unitTests/cpp/Vector.cpp: Idem

2014-09-13  Dirk Eddelbuettel  <edd@debian.org>

        * inst/skeleton/Rcpp_modules_examples.Rd: Added to document modules examples

        * inst/unitTests/testRcppModule/NAMESPACE: Updated for current Modules use
        * inst/unitTests/testRcppModule/R/zzz.R: Updated for current Modules use
        * inst/unitTests/testRcppModule/man/Rcpp_modules_examples.Rd: Also added here

2014-09-10  Dirk Eddelbuettel  <edd@debian.org>

        * R/R/Rcpp.package.skeleton.R: If available, pkgKitten used for skeleton pkg

2014-09-09  Dirk Eddelbuettel  <edd@debian.org>

        * R/unit.tests.R: Fully qualify three functions from RUnit via ::

2014-09-03  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/Environment.h: make new_env a free function

2014-09-02  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/api/meat/proxy.h: Finish meat reintroduction + tests
        * inst/unitTests/runit.wrap.R: Idem
        * inst/unitTests/cpp/wrap.cpp: Idem
        * inst/include/Rcpp/proxy/FieldProxy.h: Idem

2014-09-02  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/Vector.h: Reversing change from Aug 30: the
        Vector ctor from char* and string are used for CharacterVector()

2014-09-02  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: Include LinkingTo in DESCRIPTION fields scanned
        to confirm that C++ dependencies are referenced by package.

2014-09-01  Yixuan Qiu <yixuan.qiu@cos.name>

        * inst/include/Rcpp/vector/Vector.h: fix return value of range eraser

2014-09-01  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/ListOf.h: `size()` member function should
        return `R_len_t` rather than `int`

2014-08-30  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/Environment.h: Add 'new_env' function

2014-08-30  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/Vector.h: Mark two 'from string' ctors as
        deprecated following a suggestion by Yixuan Qiu [reversed on 2014-09-02]

2014-08-18  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: Added a new entry regarding licensing of
        packages stressing that any combined work linking to the GPL-ed R will
        also be under the terms of the GNU General Public License.

2014-08-13  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/api/meat/meat.h: Reintroduce meat
        * inst/include/Rcpp/api/meat/proxy.h: Idem
        * inst/include/Rcpp/proxy/AttributeProxy.h: Idem
        * inst/include/Rcpp/proxy/Binding.h: Idem
        * inst/include/Rcpp/proxy/NamesProxy.h: Idem
        * inst/include/Rcpp/proxy/SlotProxy.h: Idem
        * inst/include/Rcpp/proxy/TagProxy.h: Idem
        * inst/include/Rcpp/proxy/proxy.h: Idem

2014-08-08  Christian Authmann <authmanc@Mathematik.Uni-Marburg.de>

        * inst/unitTests/cpp/InternalFunction.cpp: New unit test support
        * inst/unitTests/cpp/InternalFunctionCPP11.cpp: Idem
        * inst/unitTests/runit.InternalFunction.R: Idem
        * inst/unitTests/runit.InternalFunctionCPP11.R: Idem

2014-08-06  Christian Authmann <authmanc@Mathematik.Uni-Marburg.de>

        * inst/include/Rcpp/InternalFunctionWithStdFunction.h: Extend the
        existing Rcpp::InternalFunction interface to work with std::function,
        conditional on a sufficient C++11 support by the compiler

2014-08-05  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Date.h: Remove a const qualifier which triggers a
        warnings as 'type qualifiers ignored on function return type'

2014-08-03  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: Updated with respect to OS X installations
        requiring Fortran (to e.g. build against RcppArmadillo)

2014-07-29  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/no_init.h: Add no_init for matrices
        * inst/include/Rcpp/vector/Matrix.h: Idem
        * inst/include/Rcpp/vector/Vector.h: Idem
        * inst/unitTests/runit.Matrix.R: Idem
        * inst/unitTests/cpp/Matrix.cpp: Idem

2014-07-29  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/vector/proxy.h: Removed operator bool() cast as
        discussed by Christian Authmann on rcpp-devel

2014-07-28  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/generated/InternalFunction__ctors.h: Updated from
        corrected creator script

2014-07-25  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/Benchmark/Timer.h: Added new static method
        get_timers() to return a vector of timers useful for multithreaded
        contexts; also removed two unused old member functions (cf #157)

2014-07-14  Kevin Ushey  <kevinushey@gmail.com>

        * inst/unitTests/runit.Matrix.R: DimNames Proxy
        * inst/unitTests/cpp/Matrix.cpp: Idem
        * inst/include/Rcpp/vector/Matrix.h: Idem
        * inst/include/Rcpp/vector/DimNameProxy.h: Idem

2014-07-12  Kevin Ushey  <kevinushey@gmail.com>

        * R/Attributes.R: Strip version in .parseLinkingTo

2014-07-12  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/generated/InternalFunction__ctors.h: Regenerated
        with tighter whitespace and updated header information from updated
        generator script in corresponding rcpp-scripts repo
        * inst/include/Rcpp/module/Module_generated_CppFunction.h: Idem
        * inst/include/Rcpp/module/Module_generated_CppMethod.h: Idem
        * inst/include/Rcpp/module/Module_generated_Pointer_CppMethod.h: Idem
        * inst/include/Rcpp/module/Module_generated_Pointer_method.h: Idem
        * inst/include/Rcpp/module/Module_generated_function.h: Idem
        * inst/include/Rcpp/module/Module_generated_get_signature.h: Idem
        * inst/include/Rcpp/module/Module_generated_method.h: Idem

2014-07-09  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/Language.h: OUT -> RESULT_TYPE
        * inst/include/Rcpp/generated/InternalFunction__ctors.h: Idem
        * inst/include/Rcpp/module/Module_generated_CppFunction.h: Idem
        * inst/include/Rcpp/module/Module_generated_CppMethod.h: Idem
        * inst/include/Rcpp/module/Module_generated_Pointer_CppMethod.h: Idem
        * inst/include/Rcpp/module/Module_generated_Pointer_method.h: Idem
        * inst/include/Rcpp/module/Module_generated_function.h: Idem
        * inst/include/Rcpp/module/Module_generated_get_signature.h: Idem
        * inst/include/Rcpp/module/Module_generated_method.h: Idem
        * inst/include/Rcpp/module/get_return_type.h: Idem
        * inst/include/Rcpp/sugar/block/SugarBlock_1.h: Idem
        * inst/include/Rcpp/sugar/block/SugarBlock_2.h: Idem
        * inst/include/Rcpp/sugar/block/SugarBlock_3.h: Idem
        * inst/include/Rcpp/sugar/block/SugarMath.h: Idem
        * inst/include/Rcpp/sugar/functions/complex.h: Idem

2014-07-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/InternalFunction.h: Add missing update(SEXP) method
        per GitHub Pull Request #152, with thanks to Omar Andres Zapata Mesa
        * inst/THANKS: Updated

2014-07-04  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-unitTests.Rnw: Commented-out copy of results to /tmp

2014-06-29  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: fix setwd problem when sourceCpp used a
        relative path and included an R code chunk

2014-06-20  Dirk Eddelbuettel  <edd@debian.org>

        * include/Rcpp/sugar/functions/ifelse.h: Applied pull request #150 by
        Romain to have operator{} return the correct NA type

2014-06-11  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/macros/macros.h: No longer include
        macros/preprocessor_generated.h which was deprecated as of Rcpp 0.10.5
        * inst/include/Rcpp/macros/preprocessor_generated.h: Removed

2014-06-08  Dirk Eddelbuettel  <edd@debian.org>

        * cleanup: Do not remove 'build/Rcpp.pdf', thanks to hint by Kurt / CRAN

2014-06-06  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.11.2
        * inst/NEWS.Rd: Release 0.11.2
        * inst/include/Rcpp/config.h: Release 0.11.2
        * debian/*: Similarly updated for new release to Debian

        * tests/doRUnit.R: Additional check added for release version case

2014-06-05  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: Use -std=c++0x for cpp11 plugin on Windows if R <= 3.0

2014-05-28  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/vector_from_string.h: Protect result of
        Rf_mkString

2014-05-24  Dirk Eddelbuettel  <edd@debian.org>

        * .Rbuildignore: Add .dir-locals.el

2014-05-23  Dirk Eddelbuettel  <edd@debian.org>

        * R/Module.R (new_dummyObject): Remove erraneous quotes

        * .dir-locals.el: Setting tab-width to 8

2014-05-18  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/Vector.h: Safer casting to fix #146
        * inst/include/Rcpp/Environment.h: Idem
        * inst/include/Rcpp/api/meat/Environment.h: Idem
        * inst/include/Rcpp/vector/Vector.h: Idem

        * .dir-locals.el: Added for project-local Emacs settings

2014-05-10  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R (compileAttributes): Read Imports: as well

2014-05-07  Kevin Ushey  <kevinushey@gmail.com>

        * R/Attributes.R (.plugins[["cpp11"]]): Set USE_CXX1X to more
          reasonable non-empty value

2014-05-06  Kevin Ushey  <kevinushey@gmail.com>

        * R/Attributes.R (.plugins[["cpp11"]]): Set USE_CXX1X to non-empty
          value

2014-04-30  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R: Add plugins for C++0x and C++1y

2014-04-30  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: Use USE_CXX1X for cpp11 plugin when R >= 3.1

2014-04-02  Dirk Eddelbuettel  <edd@debian.org>

        * tests/doRUnit.R: Better RUnit error report with thanks to Murray

2014-03-18  JJ Allaire <jj@rstudio.org>

        * man/cppFunction.Rd: Correct package header file example to use .h

2014-03-14  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/DataFrame.h: Add missing return in Impl method

2014-03-13  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.11.1
        * inst/NEWS.Rd: Release 0.11.1
        * inst/include/Rcpp/config.h: Release 0.11.1
        * debian/*: Similarly updated for new release to Debian

2014-03-09  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/const_string_proxy.h: Workaround for issue
        with constructing proxies from CHARSXPs

2014-03-08  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/proxy/proxy.h: Make sure proxies know about the
        const char* wrap shortcut

2014-03-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/proxy/Binding.h: Remove spurious ';' [g++ -pedantic]
        * inst/include/Rcpp/proxy/ProtectedProxy.h: Idem
        * inst/include/Rcpp/proxy/TagProxy.h: Idem
        * inst/include/Rcpp/proxy/AttributeProxy.h: Idem

2014-03-05  Kevin Ushey <kevinushey@gmail.com>

        * inst/include/Rcpp/proxy/FieldProxy.h: bandaid for protection issue
        in operator= of FieldProxy
        * R/unit.tests.R: modify Rcpp:::test so we can run tests with
        gctorture(TRUE)

2014-03-03  Kevin Ushey <kevinushey@gmail.com>

        * inst/include/Rcpp/proxy/SlotProxy.h: Add missing const_SlotProxy ctor
        definition

2014-02-24  Kevin Ushey  <kevinushey@gmail.com>

        * R/Rcpp.package.skeleton.R: make sure we add loadModule
        to NAMESPACE when module is TRUE

2014-02-23  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/DataFrame.h: better nrows behavior

2014-02-17  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/traits/un_pointer.h: fix bug in un_pointer for object<T>

2014-02-17  Kevin Ushey <kevinushey@gmail.com>

        * src/attributes.cpp: Fix attributes behavior with
        ::create, and also add an option for a default constructor
        (e.g. NumericVector v = NumericVector(10)) gives a default
        value of 'numeric(10)' at the R level). Also make NAs
        keep their type when exposed to R.

2014-02-16  JJ Allaire <jj@rstudio.org>

        * src/attributes.cpp Replace (incorrect) call to
        Rcpp::internal::jumpToTop with Rf_onintr

2014-02-07  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/Reference.h: Add default ctor

2014-02-03  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/vector/Vector.h: Enable conversion from
        Rcpp vectors to RObject

2014-02-02  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.11.0
        * inst/NEWS.Rd: Release 0.11.0
        * inst/include/Rcpp/config.h: Release 0.11.0
        * debian/*: Similarly updated for new release to Debian

2014-02-02  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R: Use placeholder for .Call to avoid warning

2014-02-01  Dirk Eddelbuettel  <edd@debian.org>

        * tests/doRUnit.R: Simplified following pattern in RProtoBuf

        * vignettes/Rcpp-unitTests.Rnw: Remove a now superfluous global var

        * vignettes/Rcpp.bib: Updated references to current packages

2014-02-01  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R: Embedded R code chunks in sourceCpp can
        now be disabled

2014-01-31  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: Render code with background boxen
        * vignettes/Rcpp-package.Rnw: Idem
        * vignettes/Rcpp-modules.Rnw: Idem
        * vignettes/Rcpp-extending.Rnw: Idem
        * vignettes/Rcpp-sugar.Rnw: Idem

        * vignettes/Rcpp-attributes.Rnw: Switched to highlight driver

        * inst/include/Rcpp/Benchmark/Timer.h: Reverted back to using
        iterators via use of anonymous namespace for accessors

        * inst/announce/ANNOUNCE-0.11.0.txt: Updated

2014-01-31  Dirk Eddelbuettel  <edd@debian.org>

        * man/Rcpp.package.skeleton.Rd: Also updated

2014-01-31  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R: Embedded R code chunks in sourceCpp are now
        executed within the working directory of the C++ source file.

2014-01-30  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-package.Rnw: Updates for upcoming release

2014-01-28  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: Some updates for upcoming release

2014-01-25  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Benchmark/Timer.h: Simplified -- Rcpp Gallery
        example using it was not building any longer under g++

2014-01-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/announce/ANNOUNCE-0.11.0.txt: Added for next release

2014-01-21  Dirk Eddelbuettel  <edd@debian.org>

        * R/Rcpp.package.skeleton.R: Update skeleton package to add proper
        Imports: to DESCRIPTION, and importFrom() to NAMESPACE

2014-01-19  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/api/meat/Vector.h: Add missing UNPROTECT in
        push_back_name__impl

2014-01-18  Kevin Ushey  <kevinushey@gmail.com>

        * inst/unitTests/runit.S4.R: Add a test for ctor from slot proxy
        * inst/unitTests/cpp/S4.cpp: Add a test for ctor from slot proxy
        * inst/include/Rcpp/vector/Vector.h: Add missing r_cast to vector
        ctor from proxy

2014-01-18  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: More restrictive matching of C++ file extensions
        for compileAttributes.

2014-01-18  Kevin Ushey  <kevinushey@gmail.com>

        * inst/unitTests/cpp/Matrix.cpp: Add unit test
        * inst/unitTests/runit.Matrix.R: Add unit test
        * inst/include/Rcpp/api/meat/Matrix.h: Bug fix in operator=

2014-01-17  Dirk Eddelbuettel  <edd@debian.org>

        * R/RcppLdpath.R (RcppCxxFlags): Restore function to supply values
        for include files for packages not yet converted to LinkingTo:

2014-01-16  JJ Allaire <jj@rstudio.org>

        * inst/include/Rcpp/macros/macros.h: Use Rf_onintr rather than
        non-public Rf_jump_to_toplevel
        * inst/include/Rcpp/DateVector.h: Fix GreedyVector compilation error
        * inst/include/Rcpp/DatetimeVector.h: Fix GreedyVector compilation error

2014-01-15  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/exceptions.h: Move stop() into Rcpp namespace

2014-01-03  JJ Allaire <jj@rstudio.org>

        * .gitignore: Added src/<object-files>, *.Rproj, and .Rproj.user
        * inst/include/Rcpp/Interrupt.h: New checkUserInterrupt function
        that provides a C++ friendly implementation of R_CheckUserInterrupt
        * inst/include/RcppCommon.h: Include Rcpp/Interrupts.h
        * inst/include/macros/macros.h: Check for interrupts in END_RCPP
        * src/attributes.cpp: Handle interrupted-error in attribute
        function envelope.

2013-12-31  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp.bib: Updated CRAN package references

2013-12-20  Kevin Ushey  <kevinushey@gmail.com>

        * inst/include/Rcpp/sugar/tools/mapcompare.h: Use a union for
        type punning, to avoid compiler warning on aliasing. Also
        switch to uint64_t to enforce 64bit comparison.
        * inst/include/Rcpp/RObject.h: Add missing *this return for
        RObject_impl::operator=

2013-12-20  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/RObject.h: Applied fix by Kevin Ushey (#88)
        * inst/include/Rcpp/vector/Vector.h: Ditto (#89)

2013-12-01  Kevin Ushey  <kevinushey@gmail.com>

        * R/Rcpp.package.skeleton.R: Fixed bug relating to user-supplied
        functions in 'list' argument
        * inst/unitTests/runit.Rcpp.package.skeleton.R: Added unit tests

2013-11-30  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-FAQ.Rnw: Updated and corrected in several spots

2013-11-22  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/stats/nt.h: Correct expansion of (d|q|p)nt()
        * inst/unitTests/runit.stats.R: Added unit tests for t dist with ncp
        * inst/unitTests/cpp/stats.cpp: C++ side of expamded unit tests

2013-11-05  Dirk Eddelbuettel  <edd@debian.org>

        * .travis.yml: Added to support continuous integration on github

2013-10-28 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/protection/Armor.h : Armor::operator SEXP has to be const
        for it to work properly with wrap.

2013-10-27  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.10.6
        * inst/NEWS.Rd: Release 0.10.6
        * inst/include/Rcpp/config.h: Release 0.10.5
        * debian/*: Similarly updated for new release to Debian

2013-10-17  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: sourceCpp now correctly binds to Rtools 3.0 and 3.1

2013-10-16  Dirk Eddelbuettel  <edd@debian.org>

        * R/Rcpp.package.skeleton.R (Rcpp.package.skeleton): Deprecate
        namespace argument which package.skeleton() no longer uses
        * man/Rcpp.package.skeleton.Rd: Updated documentation accordingly

2013-10-16 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/api/meat/is.h : added missing implementation for
        is<Language> and is<DottedPair>

2013-10-14 Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/protection/protection.h: added
        Shield/Shelter/Armor
        * DESCRIPTION: bump to version 0.10.5.3

2013-10-12  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Depends): Rolled Depends: on R to "R (>= 3.0.0)" as
        required by the vignette building code (with thanks to Uwe Ligges)

2013-10-08  Dirk Eddelbuettel  <edd@debian.org>

        * NAMESPACE: Export LdFlags as well as RcppLdFlags
        * man/RcppLdFlags.Rd: Updated

2013-10-06  John M Chambers  <jmc@r-project.org>

        * R/exposeClass.R: avoid warning from unclosed file()

2013-10-06  John M Chambers  <jmc@r-project.org>

        * NAMESPACE: change classModule to exposeClass
        * R/classModule.R: delete
        * man/classModule.Rd: delete
        * R/exposeClass.R: add
        * man/exposeClass.Rd: add
        * man/setRcppClass.Rd: update, clarify, recommend exposeClass()

2013-10-03  John M Chambers  <jmc@r-project.org>

        * R/classModule.R: new function to write module file for class
        * man/classModule.Rd: documentation for new function classModule()
        * NAMESPACE: export classModule
        * R/loadModule.R: clean up an error message
        * R/RcppClass.R: defaults for module consistent w. classModule()
        * man/setRcppClass.Rd: add defaults, explain need for saveAs

2013-10-02  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/traits/is_na.h: More fixes thanks to Thomas Tse

2013-10-01  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/api/meat/is.h: Applied patch by Thomas Tse to
        provide missing Character(Vector|Matrix)

        * DESCRIPTION: Bump to development release 0.10.5.1

2013-09-28  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.10.5
        * inst/NEWS.Rd: Release 0.10.5
        * inst/include/Rcpp/config.h: Release 0.10.5
        * debian/*: Similarly updated for new release to Debian

        * vignettes/Rcpp-unitTests.Rnw: Switched to Charter font just like
        the other eight vignettes

2013-09-28 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/module/Module_generated_CppMethod.h : more code bloat
        to handle flexible semantics for passing parameters in methods
        * include/Rcpp/module/Module_generated_Pointer_CppMethod.h : same
        * inst/unitTests/cpp/Module.cpp: testing the above
        * unitTests/runit.Module.R: testing

2013-09-27  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-unitTests.Rnw: Re-activated vignette
        * DESCRIPTION: Version number bumped to 0.10.4.6

2013-09-27 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/module/Module_generated_CppFunction.h : regenerated to
        use input_parameter traits for more flexible parameter passing strategy
        * unitTests/cpp/Module.cpp : more testing
        * unitTests/runit.Module.R : more testing

2013-09-22  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sugar/functions/diff.h: Declare set_previous
        const and add a missing traits:: prefix before is_na

        * inst/unitTests/cpp/sugar.cpp: Unit test for diff() of int. vector
        * inst/unitTests/runit.sugar.R: Invoke new test

2013-09-21  Dirk Eddelbuettel  <edd@debian.org>

        * vignettes/Rcpp-modules.Rnw: Remove vignette-local compilations
        which again caused problems for the Windows builds at R-Forge and
        win-builder. Unit tests comprise the same functionality and pass.

        * vignettes/Rcpp-attributes.Rnw: Refresh look by using Bitstream
        Charter, and microtype package (cf http://www.khirevich.com/latex)
        * vignettes/Rcpp-extending.Rnw: Idem
        * vignettes/Rcpp-FAQ.Rnw: Idem
        * vignettes/Rcpp-modules.Rnw: Idem
        * vignettes/Rcpp-package.Rnw: Idem
        * vignettes/Rcpp-quickref.Rnw: Idem
        * vignettes/Rcpp-sugar.Rnw: Idem

2013-09-20  Dirk Eddelbuettel  <edd@debian.org>

        * R/Module.R: More ':::' cleanups to make R CMD check happy
        * R/RcppClass.R: Ditto

        * NAMESPACE: Some new exports related to this

        * man/setRcppClass.Rd: Document loadRcppClass()
        * man/Rcpp-internal.Rd: Added in order to document
        cpp_object_initializer() and cpp_object_dummy()

2013-09-19  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/longlong.h: Unbreak long long by making it (as
        before) conditional on g++ (or clang) as well as C++11. The condition
        can be OR'ed with another suitably-defined variable, but the default
        has to be off as CRAN compliance has to remain the standard

2013-09-19  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/longlong.h: isolate all handling of long long
        in a separate file which we might choose not to include by default

        * include/Rcpp/traits/r_sexptype_traits.h : unsigned int wrapped as
        REALSXP long standing feature request from Murray.
        * R/Attributes.R : Added the helper demangle and sizeof functions
        * man/demangle.Rd : Documentation for demangle and sizeof
        * include/Rcpp/platform/compiler.h : less restritive support of long
        long types. But still behind a test for gcc and a test for the
        availability of the type, and the __extension__. -pedantic does not
        warn about it

2013-09-18  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R: Don't search the inline package as a fallback when
        loading plugins for the the Rcpp::plugins attribute

2013-09-18  Romain Francois <romain@r-enthusiasts.com>

        * vignettes/Rcpp-package.Rnw: Updating the vignette. Setting
        attributes to TRUE by default.
        * R/Rcpp.package.skeleton.R: Setting attributes to TRUE by
        default. This is what we should encourage people to use.
        * include/Rcpp/as.h: add as<char> specialization
        * include/Rcpp/sugar/functions/diff.h : rework the implementation of
        diff so that it works even when we don't know the previous value
        * unitTests/runit.sugar.R :
        * unitTests/cpp/sugar.cpp :
        * include/Rcpp/sugar/functions/range.h : factored out of minmax.h
        * include/Rcpp/sugar/functions/min.h : factored out of minmax.h
        * include/Rcpp/sugar/functions/max.h : factored out of minmax.h
        * TODO : 3 less items

2013-09-17  JJ Allaire  <jj@rstudio.org>

        * R/Attributes.R: Call inlineCxxPlugin and Rcpp.plugin.maker without
        qualification rather than with ':::'

2013-09-17  Dirk Eddelbuettel  <edd@debian.org>

        * NAMESPACE: Export RcppLdFlags which is often used to build Rcpp
        * man/RcppLdFlags.Rd: Added required manual page
        * R/Attributes.R: Call RcppLdFlags() via '::' instead of ':::'
        * R/SHLIB.R: Ditto
        * R/inline.R: Ditto

        * vignettes/Rcpp-FAQ.Rnw: Add %\VignetteEngine{highlight::highlight}
        * vignettes/Rcpp-attributes.Rnw: Idem
        * vignettes/Rcpp-extending.Rnw: Idem
        * vignettes/Rcpp-modules.Rnw: Idem
        * vignettes/Rcpp-package.Rnw: Idem
        * vignettes/Rcpp-quickref.Rnw: Idem
        * vignettes/Rcpp-sugar.Rnw: Idem

        * vignettes/Rcpp-package.Rnw: Altered to make use of highlight
        package; also no longer build embedded demo package (which upsets R
        CMD check under R-devel)

2013-09-16  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R : Remove calls to non-exported functions from the tools package

2013-09-16  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/internal/Exporter.h : Specific handling of containers
        (std::vector, std::deque, and std::list so that we use their faster
        range constructor when we can, and so let the STL optimize how data
        is copied
        * include/Rcpp/api/meat/export.h : Implementation of the above
        * include/Rcpp/vector/Vector.h : added Vector( const char* ) ctor
        * DESCRIPTION : bump to 0.10.4.5 (for RcppExtras)

2013-09-15  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/InputParameter.h (Rcpp): Add 'const' case

        * inst/unitTests/cpp/Vector.cpp: New unit tests for std::vector
        conversions, using both int and double arguments
        * inst/unitTests/runit.Vector.R: R complement of these tests

2013-09-15  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/InputParameter.h : added the traits::input_parameter
        trait to add another layer of abstration.
        * include/Rcpp/macros/module.h : taking advantage of input_parameter
        to specialize how to work with module objects
        * src/attributes.cpp : using traits::input_parameter<T> instead of
        InputParameter<T>

2013-09-14  Dirk Eddelbuettel  <edd@debian.org>

        * src/attributes.cpp : Precede closing '>' by space to avoid '>>'
        * inst/include/Rcpp/platform/compiler.h: Further refine #if test for
        'long long' by conditioning __LP64__ on also using clang/llvm

        * src/attributes.cpp : Precede closing '>' by space to avoid '>>'

2013-09-13  Romain Francois <romain@r-enthusiasts.com>

        * src/api.cpp : added "long long" to the capabilities function.
        * include/Rcpp/platform/compiler.h : demangling is definitely
        available on all mac versions using gcc. No point is testing for OSX
        version.
        * include/Rcpp/InputParameter.h : extra layer of abstraction to allow
        for custom handling of references etc ... used in RcppArmadillo
        * src/attributes.cpp : using InputParameter
        * DESCRIPTION: bump to 0.10.4.4

2013-09-12  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/platform/compiler.h : patch submitted by Murray for
        better support of long long type.
        * include/Rcpp/platform/compiler.h : gcc 4.2.1 has tr1/unordered_map
        and tr1/unordered_set. Previous test was for gcc 4.4.0 for some
        reason

2013-08-31  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/*: Moved all vignettes to vignettes/*
        * vignettes/*: Minor updates to some vignettes

2013-08-22  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/traits/is_primitive.h : new trait to identify if a
        type is primitive, this is a shortcut of using r_type_traits and
        compare it to r_type_primitive_tag
        * include/Rcpp/traits/r_type_traits.h : new tag r_type_pair_tag to
        handle wrapping map<KEY, VALUE> where KEY can be converted to String
        and VALUE can wrap itself
        * include/Rcpp/internal/wrap.h : handling map<KEY, VALUE> and vector<T>
        where T is a class handled by modules
        * include/Rcpp/api/meat/wrap.h : implementations to handle map<KEY,
        VALUE>
        * unitTests/cpp/wrap.cpp : more tests for map<KEY, VALUE> with KEY
        not a string
        * unitTests/runit.wrap.R : more tests for map<KEY, VALUE> with KEY
        not a string

        * include/Rcpp/internal/export.h : added export_range__dispatch for
        the r_type_generic_tag tag. Meaning we can now use as< vector<T> >
        where T is not a primitive
        * include/Rcpp/api/meat/export.h : implementation in meat because it needs as

2013-08-01  Romain Francois <romain@r-enthusiasts.com>

        * unitTests/cpp/wstring.cpp: fix to re-enable wstring test suite.
        * unitTests/runit.wstring.R: re-enable the wstring test suite.

2013-07-31  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Bump development version to 0.10.4.3

        * inst/doc/Makefile: Rejigged pdf builds in another attempt at
        pleasing whatever runs the builds on r-forge. L'espoir fait vivre.

2013-07-25  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/sugar/functions/is_na.h : added is_na for DateVector and
        DatetimeVector
        * include/Rcpp/Date.h : added is_na method
        * include/Rcpp/Datetime.h : added is_na method
        * unitTests/cpp/dates.cpp : removed the ignoreme useless parameters
        * unitTests/runit.Date.R : idem
        * src/attributes.cpp: collecting functions in a FunctionMap. Will use this
        for dispatching

2013-07-24  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/traits/is_module_object.h: trait class that identifies
        at compile time if a given type is a type exposed by a module,
        i.e. if we used the RCPP_EXPOSED_AS macro
        * include/Rcpp/is.h: able to identify if an object is of a given type
        exposed by a module (supports references and pointers too).
        * src/Module.cpp: implementation of is_module_object_internal that
        checks if an object is of a given typeid, used by is<T> where T is
        module exposed

2013-07-23  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/as.h: support as<T*> and as<const T*> where T is a class
        exposed by modules
        * include/Rcpp/macros/module.h: idem
        * include/Rcpp/traits/un_pointer.h: handle the object<T> case
        * include/Rcpp/traits/r_type_traits.h: adding traits to help the with
        as<T*> and as<const T*>
        * unitTests/runit.Module.R: testing as<T*> and as<const T*>
        * unitTests/cpp/Module.cpp: idem
        * src/attributes.cpp: take advantage of a more flexible as<>. The
        Type class gains a full_name() method that shows const-ness and
        reference-ness

2013-07-17  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/instantiation.h: added the DoubleVector alias
        to NumericVector
        * include/Rcpp/is.h: added is template function

2013-07-11  Dirk Eddelbuettel  <edd@debian.org>

        * R/Attributes.R: Add an OpenMP plugin

2013-07-03  Romain Francois <romain@r-enthusiasts.com>

        * unitTests/runit.modref.R: using sourceCpp
        * unitTests/runit.Module.R: using sourceCpp
        * unitTests/runit.Vector.R: no more uses of inline
        * unitTests/runTests.R: we don't need inline no more for testing
        * doc/unitTests/Rcpp-unitTests.R: idem

2013-07-02  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/Vector.h: fill__dispatch was mispelled (as
        fill_dispatch) for the non trivial case, so it did not work
        * unitTests/runit.Matrix.R: using sourceCpp
        * unitTests/runit.misc.R: using sourceCpp
        * unitTests/runit.wrap.R: using sourceCpp
        * unitTests/runit.support.R: using sourceCpp
        * unitTests/runit.rmath.R: using sourceCpp
        * unitTests/runit.RObject.R: using sourceCpp
        * unitTests/runit.stats.R: using sourceCpp
        * unitTests/runit.XPTr.R: using sourceCpp
        * unitTests/runit.Vector.R: testing List( int, IntegerVector ) which
        eventually uses fill__dispatch
        * include/Rcpp/traits/r_type_traits.h: support for as<T&> and as<const T&>
        when T is module exposed
        * include/Rcpp/as.h: as<T&> and as<const T&> when T is module exposed
        * include/Rcpp/module/Module_generated_CppFunction.h: removed the
        remove_const_and_reference since as<T&> and as<const T&> is supported
        * src/attributes.cpp: automatically populating the environment with
        the content of a module, rather than make the module object available
        in the environment

2013-07-01  Romain Francois <romain@r-enthusiasts.com>

        * R/unit.test.R: added helper function Rcpp:::unit_test_setup to avoid
        some boiler plate code in unit test files. See e.g. runit.Function.R for
        an example
        * unitTests/runit.as.R: using sourceCpp
        * unitTests/runit.Function.R: using sourceCpp
        * unitTests/runit.DataFrame.R: remove dependency on datasets

2013-06-25  Dirk Eddelbuettel  <edd@debian.org>

        * src/api.cpp: Also test for #defined(__sun) when checking for system
        lacking a valid backtrace() function for stack traces

2013-06-25  Romain Francois <romain@r-enthusiasts.com>

        * DESCRIPTION : devel version 0.10.4.1
        * src/Module.cpp : bring a simplified version of RCPP_FUNCTION 1 .. 4
        * unitTests/runit.macros.R : removed, as RCPP_FUNCTION ... are deprecated
        * include/Rcpp/macros/preprocessor_generated.h : deprecating RCPP_FUNCTION_... macros

2013-06-24  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/platform/compiler.h: Note the useful wiki page
        http://sourceforge.net/p/predef/wiki/Home with #defines for OSs,
        compilers, libraries and more

2013-06-23  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.10.4
        * inst/NEWS.Rd: Release 0.10.4
        * inst/include/Rcpp/config.h: Release 0.10.4
        * debian/*: Similarly updated for new release to Debian

2013-06-19  Romain Francois <romain@r-enthusiasts.com>

        * inst/NEWS.Rd: Document planned depreciation of old RCPP_FUNCION_*
        macros which are redundant thanks to Rcpp Modules and Rcpp Attributes

        * include/Rcpp/vector/string_proxy.h : added operator
        string_proxy::operator==( const string_proxy& ) so that me may
        compare x[i] and y[i] (x and y being CharacterVector)

        * include/Rcpp/module/Module_generated_Pointer_CppMethod.h : remove
        const and reference to OUT type in several places, that was causing
        problems e.g.  on making the Rcpp-modules vignette

        * include/Rcpp/module/Module_generated_CppMethod.h : idem

2013-06-18  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/module/Module_generated_CppFunction.h : using
        BEGIN_RCPP / END_RCPP as suggested by Ben North on Rcpp-devel. This
        should reduce cross dll exceptions issues on windows.

2013-06-14  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/stats/random/runif.h : removed unused max variable
        * include/Rcpp/stats/random/rf.h : removed unused n1 and n2 variables

2013-06-13  Romain Francois <romain@r-enthusiasts.com>

        * src/Module.cpp: small buglet in macro. Reported on Rcpp-devel

2013-06-12  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Makefile: Force serial build of vignettes in yet another
        effort to not let R-Forge fail when trying to rebuild them

2013-06-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp.bib: Updated entries

        * inst/doc/Rcpp-introduction.Rnw: Added pointer to 'Rcpp Attributes'
        vignette, as well as to 'Rcpp Sugar' and 'Rcpp Modules' vignettes.
        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Idem

2013-06-06  Romain Francois <romain@r-enthusiasts.com>

        * unitTests/cpp/Vector.cpp : more unit tests for erase
        * unitTests/runit.Vector.R : more unit tests for erase

2013-06-05  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/api/meat/Vector.h : fixed Vector<>::erase(iterator,
        iterator) and correct return value of erase
        * unitTests/cpp/Vector.cpp : added regression test for the above fix
        * unitTests/runit.Vector.R : added regression test for the above fix
        * include/Rcpp/module/class.h : removed useless typedef

2013-05-31  Romain Francois <romain@r-enthusiasts.com>

        * unitTests/runit.sugar.R : new test for is_infinite and is_nan
        * unitTests/cpp/sugar.cpp : new test for is_infinite and is_nan
        * include/Rcpp/sugar/functions/is_infinite.h : new function
        is_infinite
        * include/Rcpp/traits/is_infinite.h : new function is_infinite
        * include/Rcpp/sugar/functions/is_nan.h : new function is_nan
        * include/Rcpp/traits/is_nan.h : new function is_nan

2013-05-30  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/sugar/functions/all.h : bug fixed for the NA=false
        case
        * include/Rcpp/sugar/functions/is_na.h : header
        * include/Rcpp/sugar/functions/is_finite.h : added sugar is_finite
        function
        * include/Rcpp/traits/is_finite.h : added is_finite trait
        * unitTests/runit.sugar.R : added test for is_finite
        * unitTests/cpp/S4.cpp : new cpp file to host S4 unit tests
        * unitTests/runit.S4.R : rework unit tests to use attributes
        * unitTests/runit.Reference.R : unit tests for Rcpp::Reference
        * unitTests/cpp/Reference.cpp : unit tests c++ code

2013-05-26  Dirk Eddelbuettel  <edd@debian.org>

        * src/api.cpp: Minor tweak for internal formatting

2013-05-24  J.J. Allaire <jj@rstudio.org>

        * R/Attributes.R: Disallow compilation for files that don't have
        extensions supported by R CMD SHLIB

2013-05-21  J.J. Allaire <jj@rstudio.org>

        * R/Attributes.R: Lookup plugins in inline package if they aren't
        found within the Rcpp package
        * man/pluginsAttribute.Rd: Documentation updates.

2013-05-17  J.J. Allaire <jj@rstudio.org>

        * src/attributes.cpp: prevent gc problems with RNGScope destructor
        in attributes generated functions; don't include package header
        file in generated cpp exports file
        * src/api.cpp: use unsigned long for RNG scope counter

2013-04-28  Dirk Eddelbuettel  <edd@debian.org>

        * src/api.cpp (Rcpp): No longer use Rd_format(Real|Complex) which is
        a very verboten R internal; formatting to string is now very bare
        bones

2013-04-27  Dirk Eddelbuettel  <edd@debian.org>

        * src/Makevars: Improved use as well as a new possible overrride of
        /usr/bin/install_name_tool on OS X, once again contributed by Simon

2013-04-16  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/sugar/functions/na_omit.h : new function na_omit to
        remove missing values from a vector.
        * src/attributes.cpp : portability fix (from Martyn Plummer)
        * include/Rcpp/api/meat/Vector.h : portability fix (from Martyn
        Plummer)

2013-04-14  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/traits/is_na.h: complex version did not work.
        added default for VECSXP and EXPRSXP versions

2013-04-02  Dirk Eddelbuettel  <edd@debian.org>

        * src/Date.cpp: Corrected operator-() for Date and Datetime objects
        to behave more inline with C++ standard

        * inst/include/Rcpp/Date.h: operator-() for Dates now returns a
        double as the date itself is fractional double since epoch

        * inst/unitTests/cpp/dates.cpp: New file with C++ portion of tests
        factored out from R unit test file
        * inst/unitTests/runit.Date.R: Rewritten for use with new C++ tests

2013-04-02 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/generated/DataFrame_generated.h : DateFrame::create
        uses List::create and then feeds to the DataFrame constructor, which
        seems to work better than the previous approach of calling back to the
        data.frame function in R
        * include/Rcpp/DataFrame.h : private function from_list, to help
        the new implementation of DataFrame::create
        * src/api.cpp : impl of DataFrame::from_list

2013-03-31  Dirk Eddelbuettel  <edd@debian.org>

        * debian/control (Build-Depends): Modified for Debian-only rebuilds
        under (rc version of upcoming) R 3.0.0 release
        * debian/changelog: Entry for Debian build 0.10.3-2

2013-03-29  Dirk Eddelbuettel  <edd@debian.org>

        * src/api.cpp (Rcpp): Re-enable coerce_to_string<>() for real and
        complex types with Poor Man's Versions (TM) of Rf_EncodeReal and
        Rf_EncodeComplex which the Powers That Be disallow from being used

2013-03-27 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/MatrixRow.h : removed unintended printed
        messaged (reported on Rcpp-devel by Michaeal Love)

2013-03-23  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.10.3
        * inst/NEWS.Rd: Release 0.10.3
        * inst/include/Rcpp/config.h: Release 0.10.3
        * debian/*: Similarly updated for new release to Debian

2013-03-21  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.wstring.R (test.as_vector_wstring): replace
        the "€" symbol with its unicode equivalent "\u20ac"

2013-03-20  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp.bib: Updated versions for several CRAN packages

        * inst/CITATION: Add information about forthcoming book

2013-03-20 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/traits/is_wide_string.h : fixes to re-enable wrap(
        vector<char> ) and wrap( vector<wchar_t> ), needed to support package
        httpuv
        * include/Rcpp/internal/wrap.h : same

2013-03-19  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/config.h: Define RCPP_USE_NEW_PRESERVE_RELEASE
        with default value of 0 to enable/disable new preserve/release code

        * src/api.cpp: Bracket the new Rcpp object preserve / release code
        with the new variable RCPP_USE_NEW_PRESERVE_RELEASE and fall back
        to R behaviour if not set

2013-03-12 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/Module.h: added virtual destructor to CppProperty

2013-03-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/platform/compiler.h: Improved g++ version
        detection with thanks to Yan Zhou

2013-02-28 JJ Allaire <jj@rstudio.org>

        * src/attributes.cpp: standalone roxygen chunks (e.g. to document
        a class) are now transposed into RcppExports.R

2013-02-27 JJ Allaire <jj@rstudio.org>

        * R/Rcpp.package.skeleton.R: eliminated spurious empty hello world
        function definition in Rcpp.package.skeleton

2013-02-24 JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: add global package include file to RcppExports.cpp
        if it exists; handle Rcpp module definitions in sourceCpp
        * src/attributes.cpp: handle Rcpp module definitions in sourceCpp
        * man/sourceCpp.Rd: documentation updates

2013-02-20  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/platform/compiler.h: As deteced by Gong-Yi Liao,
        we need to test for __LONG_LONG_MAX__ (defined in limits.h) and not
        LONG_LONG_MAX (defined climits which we do not include)

2013-02-19 Romain Francois <romain@r-enthusiasts.com>

        * src/api.cpp : more debugging
        * include/RcppCommon.h : move sexp_to_name here. Used in some debugging
        * include/Rcpp/vector/MatrixRow.h : fix const version of operator[]
        * include/Rcpp/vector/Vector.h : more debugging
        * include/Rcpp/internal/wrap.h : more debugging. more dispatch.

2013-02-18 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/string_proxy.h : only declare operator+=
        * include/Rcpp/String.h : define string_proxy::operator+=, now that
        String is defined.

2013-02-15 JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: Merge existing values of build related
        environment variables for sourceCpp

2013-02-12 Romain Francois <romain@r-enthusiasts.com>

        * src/api.cpp : More careful about RCPP_PROTECTION_STACK init

2013-02-08 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/as.h: re-enable as<std::string>(CharacterVector[int])
2013-02-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/THANKS: Adding Ben North for the help / bug report on iterators

2013-02-05 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/string_proxy.h : more wstring support
        * include/Rcpp/XPtr.h : more debugging. removed delete_finalizer
        which is no longer used

2013-02-05 JJ Allaire <jj@rstudio.org>

        * src/attributes.cpp : ensure that line comments invalidate block
        comments when parsing for attributes

2013-02-04 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/traits/r_type_traits.h : make the
        r_type_pairstring_string_tag tag more general, handling wstring as
        well as string
        * include/Rcpp/internal/wrap.h : using make_charsexp, a more generic
        version of charsexp_from_wstring.
        * include/Rcpp/as.h : more support fot wstring
        * include/Rcpp/internal/wrap.h : rework the support of wstring
        * include/Rcpp/internal/export.h : added as_string_elt to rework the
        support of wstring
        * include/Rcpp/traits/char_type.h : new trait to help the wstring
        support
        * include/Rcpp/String.h : added some support for wstring
        * include/Rcpp/vector/string_proxy.h : adapt to add wstring support
        * unitTests/runit.wstring.R : unit tests for wstring support
        * unitTests/cpp/wstring.cpp : unit tests for wstring support

2013-02-03 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/traits/wrap_type_traits.h : support for wrap( wstring )
        * include/Rcpp/internal/export.h : exporting wstring and containers
        of wstring
        * include/Rcpp/internal/wrap.h : support for wrap( wstring ) and
        containers of wstring
        * include/RcppCommon.h : definition of charsexp_from_wstring
        * src/api.cpp: implementation of charsexp_from_wstring

2013-02-02 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/MatrixRow.h: correct operator++(int) and
        operator--(int)
        * include/Rcpp/internal/Proxy_Iterator.h: correct operators ++ and --
        * include/Rcpp/sugar/Range.h: correct operators ++ and --
        * include/Rcpp/sugar/tools/iterator.h: correct operators ++ and --
        * include/Rcpp/vector/MatrixBase.h : correct operators ++ and --
        * include/Rcpp/vector/VectorBase.h : correct operators ++ and --
        * unitTests/cpp/Vector.cpp: new unit tests
        * unitTests/runit.Vector.R: new unit tests
        * src/api.cpp: comment dropTrailing0 which is not used anymore
        * include/Rcpp/as.h: support for as<wstring>
        * include/Rcpp/internal/export.h: more support for wstring

2013-01-15  Dirk Eddelbuettel  <edd@debian.org>

        * src/api.cpp (Rcpp): Commented-out coerce_to_string() for real and
        complex arguments as R-devel (as of today) dislikes use of non-API
        functions Rf_EncodeComplex’, ‘Rf_EncodeReal’, ‘Rf_formatComplex’

        * .Rbuildignore: Added inst/include/Rcpp/preprocessor and
        sugar/functions/impl which are currently empty directories

        * src/Timer.cpp (Rcpp): Avoid a 'long long' warning from a const

2014-01-15  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: don't add source directory as an include path for
        sourceCpp; fix duplicate inclusion of Rcpp directory
        * R/RcppLdpath.R: don't quote paths on windows

2014-01-14  JJ Allaire <jj@rstudio.org>

        * DESCRIPTION: bump version to 0.10.2.3
        * R/Attributes.R: handle build paths with spaces on windows
        * R/RcppLdpath.R: handle build paths with spaces on windows
        * R/tools.R: handle build paths with spaces on windows
        * src/Timer.cpp: fix OSX build (remove __MACH__ define check)
        * R/: set svn eol-style native for source files
        * src/: set svn eol-style native for source files
        * inst/include/: set svn eol-style native for source files

2014-01-13  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: use plugin includes in cppFunction; stop with
        explicit error on Windows then the Rcpl libPath or sourceCpp target
        file contains spaces in it's path; add source file directory as an
        include path for sourceCpp; special handling for sourceCpp include
        paths on windows
        * man/pluginsAttribute.Rd: clarify which fields of plugin are
        used by sourceCpp

2014-01-12  JJ Allaire <jj@rstudio.org>

        * DESCRIPTION: bump version to 0.10.2.2
        * NAMESPACE: add registerPlugin function
        * R/Attributes.R: add registerPlugin function; add plugins parameter
        to cppFunction
        * man/cppFunction.Rd: documentation updates
        * man/pluginsAttribute.Rd: documentation updates
        * man/registerPlugin: documentation updates

2014-01-11  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: initial support for Rcpp::plugins attribute; add
        built-in cpp11 plugin
        * src/attributes.cpp: initial support for Rcpp::plugins attribute

2014-01-04  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: null check on pkginfo depends field

2013-01-02  Dirk Eddelbuettel  <edd@debian.org>

        * src/Timer.cpp (Rcpp): Applied refinement of previously applied
        patch re *BSD builds, see http://bugs.debian.org/697032 for more

2012-12-30  Dirk Eddelbuettel  <edd@debian.org>

        * src/Timer.cpp (Rcpp): Added defined() tests for more *BSD family
        members as the build also failed with the FreeBSD Kernel on Debian

2012-12-27  Dirk Eddelbuettel  <edd@debian.org>

        * src/Timer.cpp (Rcpp): Applied patch kindly supplied by Rainer
        Hurling to support compilation on FreeBSD

2012-12-26  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: return invisibly from void functions
        * src/attributes.cpp: return invisibly from void functions

2012-12-21 Romain Francois <romain@r-enthusiasts.com>

        * NAMESPACE : remove C++ObjectS3 and C++ClassRepresentation classes
        * R/00_classes.R: remove unused S4 classes
        * src/internal.h: added Rcpp_PreserveObject, Rcpp_ReleaseObject and
        Rcpp_ReplaceObject as replacements to R_ versions. The back end of the Rcpp_
        version is a list (generic vector) instead of a linked list and
        is faster
        * src/Module.cpp: more debugging
        * src/barrier.cpp: added get_Rcpp_protection_stack used in the new
        stack system for protecting/releasing objects in Rcpp
        * src/api.cpp: implemetation of Rcpp_PreserveObject, Rcpp_ReleaseObject
        and Rcpp_ReplaceObject. RObject::setSEXP now uses the new system.
        The RObject(SEXP) constructor now directly uses Rcpp_PreserveObject
        More debugging for the RObject class
        Changes in api classes to better use the new protection system
        * unitTests/cpp/language.cpp: hosting unit test in sourceCpp form
        * unitTests/runit.Language.R: update unit tests
        * unitTests/runit.Module.client.package.R: remove code that has been
        commented for ages
        * include/Rcpp/DottedPair.h: better use of the RObject constructor
        * include/Rcpp/vector/Vector.h: better use of the RObject constructor
        * include/Rcpp/vector/Matrix.h: Using update_matrix instead of the virtual
        update which has been removed.
        * include/Rcpp/Module.h : more careful about types and constructors
        * include/Rcpp/XPtr.h: more debugging
        * include/Rcpp/macros/debug.h: more debugging macros
        * include/Rcpp/module/class_Base.h: using classes instead of SEXP
        * include/Rcpp/module/class.h: using classes instead of SEXP
        * include/Rcpp/generated/Language__ctors.h : using  update_language_object
        instead of the virtual update which has been removed.
        * include/Rcpp/api/meat/Vector.h : using update_vector instead of the
        virtual update that has been removed, more debugging
        * include/Rcpp/api/meat/Matrix.h : more debugging, using update_matrix
        instead of the virtual update which has been removed
        * include/Rcpp/Language.h : added update_language_object to
        replace update which was virtual
        * include/Rcpp/RObject.h : only keep declarations here

2012-12-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.10.2
        * inst/NEWS.Rd: Release 0.10.2
        * inst/include/Rcpp/config.h: Release 0.10.2
        * debian/*: Similarly updated for new release to Debian

        * inst/doc/unitTests/Rcpp-unitTests.R: added one more variable so
        that unitTest vignette can be built against new sourceCpp based files

2012-12-15 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/exceptions.h: added exception_to_r_condition
        * exceptions.cpp: new implementation of forward_exception_to_r that
        directly calls stop rather than a function in Rcpp
        * R/exceptions.R: remove code rendered useless
        * src/Rcpp_init.c: less exports
        * src/api.cpp: less going back to the R side

2012-12-14 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/sugar/functions/clamp.h: clamp was pretty wrong
        * unitTests/runit.sugar.R: new unit test for clamp
        * unitTests/cpp/sugar.cpp: new unit test for clamp

2012-12-12  JJ Allaire <jj@rstudio.org>

        * src/Attributes.R: always generate new dynlib file for rebuild=TRUE
        * src/attributes.cpp: set svn:eol-style to native; always generate
        new dynlib file for rebuild=TRUE; don't declare attributes constant
        strings extern

2012-12-12 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/Symbol.h: c_str becomes const and added
        Symbol::operator==(const char* )

2012-12-11  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: always print output when shared library is not
        created
        * src/attributes.cpp: consolidate attributes into single file
        * src/Attributes.cpp: consolidate attributes into single file
        * src/AttributesGen.h: consolidate attributes into single file
        * src/AttributesGen.cpp: consolidate attributes into single file
        * src/AttributesParser.h: consolidate attributes into single file
        * src/AttributesParser.cpp: consolidate attributes into single file
        * src/AttributesTypes.h: consolidate attributes into single file
        * src/AttributesUtil.h: consolidate attributes into single file
        * inst/NEWS.Rd: additional notes on changes to attributes
        * inst/doc/Rcpp-attributes/Rcpp-attributes.Rnw: update for changes to
        attributes in 0.10.2

2012-12-11 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/String.h: missing operator +=( const StringProxy& )
        * include/Rcpp/sugar/functions/strings/strings.h : string sugar functions
        * include/Rcpp/sugar/functions/strings/collapse.h : collapse
        function, implementing paste( . , collapse = "" )
        * include/Rcpp/complex.h: operator==( Rcomplex, Rcomplex )
        * src/api.cpp: implementation of operator==(Rcomplex, Rcomplex)
        * include/Rcpp/vector/Vector.h: added const version of operator[](string)

2012-12-10  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: warn when depends attribute is not matched with
        required entries in package description; add Rtools to PATH for
        duration of sourceCpp
        * src/Attributes.cpp: warn when depends attribute is not matched with
        required entries in package description
        * src/AttributesGen.cpp: prune unnecessary includes from RcppExports
        * src/Timer.cpp: fix timer build issues on windows

2012-12-10 Romain Francois <romain@r-enthusiasts.com>

        * src/api.cpp: import r_cast.cpp, coerce.cpp, RcppCommon.cpp
        and debugging.cpp content
        * include/platform/compiler.h: put here compiler specific deduction things
        * src/internal.h: new header to host function declarations for
        routines that are not exported into Rcpp.h
        * src/Rcpp_init.c: export capabilities (renamed rcpp_capabilities)
        * include/Rcpp/traits/traits.h: master file for all traits includes
        * include/Rcpp/macros/macros.h: master file for all macros includes
        * include/Rcpp/DataFrame.h: just have declaration for DataFrame
        * include/Rcpp/Benchmark/Timer.h: move it into the Rcpp:: namespace
        * include/Rcpp/cache.h: clean
        * include/Rcpp/Reference.h : field was declared const and should not
        be.  added a ConstFieldProxy class for read only use

2012-12-09 Romain Francois <romain@r-enthusiasts.com>

        * src/api.cpp: merge many .cpp files here to reduce compile time
        * src/barrier.cpp: merge with cache.cpp to reduce compile time
        * include/Rcpp/exceptions.h: drop forward_uncaught_exceptions_to_r
        * src/exceptions.cpp: drop forward_uncaught_exceptions_to_r
        * src/Date.cpp: merge all Date related files

2012-12-08 Romain Francois <romain@r-enthusiasts.com>

        * src/Timer.cpp: implementation of Timer
        * include/Rcpp/Benchmark/Timer.h: internal performance timer, based on
        the code from the microbenchmark package
        * include/Rcpp/api/meat/Matrix.h: move more in Matrix meat
        * src/Date.cpp: import the code from posixt.cpp

2012-12-07  JJ Allaire <jj@rstudio.org>

        * src/AttributesGen.cpp: use __ prefix for variables in generated
        code; add RNGScope for attribute exported functions.

2012-12-07 Romain Francois <romain@r-enthusiasts.com>

        * src/random.cpp: instantiations of random generators here
        * include/Rcpp/stats/random/random.h: only have declarations of
        random generators here. Rework the Generator template so that it
        inherits RNGScope to provide automatic calls to GetRNGstate and
        PutRNGstate

2012-12-06  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: revert DOS newlines; use new shared library name
        for each rebuild in sourceCpp
        * src/Attributes.cpp: revert DOS newlines; define RCPP_NO_SUGAR;
        use new shared library name for each rebuild in sourceCpp
        * src/AttributesGen.cpp: revert DOS newlines; convert 'try-error'
        to exception for C++ interfaces
        * src/AttributesGen.h: 'try-error' to exception for C++ interfaces
        * src/AttributesParser.cpp: revert DOS newlines; define RCPP_NO_SUGAR
        * src/RcppCommon.cpp: conversion from exeption to 'try-error'
        * include/Rcpp/exceptions.h: conversion from exeption to 'try-error'
        * include/Rcpp/preprocessor.h: add END_RCPP_RETURN_ERROR macro
        to convert exceptions to 'try-error' objects
        * include/Rcpp/iostream/Rstreambuf.h: revert DOS newlines
        * DESCRIPTION: bump version to 0.10.1.5

2012-12-06  Dirk Eddelbuettel  <edd@debian.org>

        * src/exceptions.cpp: Added include of cstdlib to compile

2012-12-06 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/api/meat/Environment.h: meat for Environment
        * src/exceptions.cpp: include config so that it knows that Rcpp can
        demangle
        * unitTests/runit.environments.R: using sourceCpp
        * src/Environment.cpp: less includes
        * src/Evaluator.cpp: less includes

2012-12-05 Romain Francois <romain@r-enthusiasts.com>

        * src/cache.cpp: added get_cache
        * include/Rcpp/hash/IndexHash.h: use a cached integer vector for the
        hash table payload. The cache vector increases as needed.
        * include/Rcpp/iostream/Rostream.h: make Rostream a template
        * include/Rcpp/iostream/Rstreambuf.h: make Rstreambuf a template
        * src/AttributesGen.cpp : include exceptions.h which was included
        implicitely by Rostream.h before
        * include/Rcpp/macros/debug.h : factor out the debugging macros
        * include/Rcpp/api/meat/RObject.h : only declare templates that use
        as and wrap. they are implemented later in the meat directory
        * include/Rcpp/api/meat/meat.h: directory containing implementations
        of templates using as and wrap
        * include/RcppCommon.h: removed unused test_named
        * src/RcppCommon.cpp: removed unused test_named
        * src/r_cast.cpp: less includes
        * src/posixt.cpp: less includes

2012-12-05  JJ Allaire <jj@rstudio.org>

        * src/Attributes.R: direct hookup of external ptr in sourceCpp
        * src/Attributes.cpp: use code generation for compileAttributes;
        direct hookup of external ptr in sourceCpp
        * src/AttributesGen.cpp: use code generation for compileAttributes;
        direct hookup of external ptr in sourceCpp
        * src/AttributesGen.h: use code generation for compileAttributes;
        direct hookup of external ptr in sourceCpp
        * src/Module.cpp: fix typo in GetCppCallable
        * include/Rcpp/iostream/Rstreambuf.h: add cstdio include
        * DESCRIPTION: bump version to 0.10.1.4

2012-12-04  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/hash/hash.h: Added include inttypes.h for intptr_t

2012-12-04  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: use simple code generation for sourceCpp
        * src/Attributes.cpp: move generators into their own source file;
        use simple code generation for sourceCpp
        * src/AttributesGen.cpp: move generators into their own source file;
        add C++ default argument parsing
        * src/AttributesGen.h: move generators into their own source file
        * src/AttributesParser.cpp: move generators into their own source file
        * src/AttributesParser.h: move generators into their own source file
        * src/AttributesTypes.h: new header for attributes types
        * src/AttributesUtil.h: new header for attributes utilities

2012-12-04 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/hash/hash.h: new implementation of IndexHash, based on
        Simon's fastmatch package
        * include/Rcpp/sugar/functions/match.h: more efficient version of match
        using new IndexHash
        * include/Rcpp/sugar/functions/unique.h: more efficient version of
        unique and in using IndexHash
        * include/Rcpp/sugar/functions/duplicated.h: more efficient version
        of duplicated and in using IndexHash
        * include/Rcpp/sugar/functions/self_match.h: more efficient version
        of self_match and in using IndexHash
        * include/Rcpp/vector/Vector.h: more efficiently create Vector from
        sugar expression that are already vectors, i.e. grab the SEXP

2012-12-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/RcppCommon.h: Applied patch kindly contributed by Yan
        Zhou which provides a number of more refined definition for support
        of both the C++11 standard and different compilers
        * inst/include/Rcpp/internal/wrap.h: Idem
        * inst/include/Rcpp/sugar/sugar.h: Idem
        * inst/include/Rcpp/traits/comparator_type.h: Idem
        * inst/include/Rcpp/vector/Vector.h: Idem
        * inst/unitTests/runit.wrap.R: Idem
        * src/RcppCommon.cpp: Idem

        * DESCRIPTION: Increase minor dev. version once more

2012-12-03  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: added function to check whether R development
        tools are currently installed

2012-12-03 Romain Francois <romain@r-enthusiasts.com>

        * src/Module.cpp: move BEGIN_RCPP/END_RCPP to Module__invoke
        * src/coerce.cpp: added coerce_to_string implementations
        * include/RcppCommon.h : nicer formatting for RCPP_DEBUG_*, now up to
        RCPP_DEBUG_5
        * include/Rcpp/vector/Vector.h: debugging
        * include/Rcpp/String.h: The String class
        * include/Rcpp/as.h: support for String
        * include/Rcpp/vector/converter.h : support for String
        * include/Rcpp/vector/string_proxy.h: support for String
        * include/Rcpp/internal/wrap.h : support for String
        * include/Rcpp/internal/r_coerce.h: support for String
        * include/Rcpp/sugar/functions/sapply.h: debugging
        * include/Rcpp/traits/wrap_type_traits.h: support for String
        * include/Rcpp/traits/r_type_traits.h: support for String
        * unitTests/cpp/String.cpp : unit tests for String
        * unitTests/runit.String.R: unit test for String
        * include/Rcpp/sugar/sets.h: support for String

2012-12-01  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/RcppCommon.h: Applied patch by Yan Zhou to add support
        for clang++ with libc++, and Intel's icpc when std=c++11

2012-11-29 Romain Francois <romain@r-enthusiasts.com>

        * unitTests/runit.DataFrame.R: using sourceCpp
        * include/Rcpp/vector/Matrix.h: fix yet another const correctness issue

2012-11-27  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/iostream/Rostream.h: Check before deleting buf

2012-11-26  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.10.1
        * inst/NEWS.Rd: Release 0.10.1
        * inst/include/Rcpp/config.h: Release 0.10.1
        * debian/*: Similarly updated for new release to Debian

        * DESCRIPTION: Added paragraph about Rcpp attributes
        * debian/control: Idem

2012-11-26 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/Module.h: comment out the unused and unuseable
        converter overload.
        * include/Rcpp/sugar/functions/pmin.h: be consistent about how the
        pmin_op helper struct is defined (always a struct).
        * include/Rcpp/sugar/functions/pmax.h: same for pmax
        * include/Rcpp/stats/random/rbeta.h: fixed constructor issue
        * unitTests/runit.sugar.R: rework to use sourceCpp instead of inline
        * include/Rcpp/vector/Vector.h: added ctor to deal with
        SingleLogicalResult
        * include/Rcpp/vector/Matrix.h: another const correctness fix

2012-11-25  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: use echo = TRUE for sourceCpp R code chunks
        * src/Module.cpp: BEGIN_RCPP/END_RCPP in InternalFunction_invoke
        * inst/doc/Rcpp-attributes/Rcpp-attributes.Rnw: add documentation
        on correct semantics for signaling error conditions

2012-11-24  JJ Allaire <jj@rstudio.org>

        * inst/doc/Rcpp-attributes/Rcpp-attributes.Rnw: expand discussion
        of binary compatibility issues.

2012-11-23 Romain Francois <romain@r-enthusiasts.com>

        * src/AttributesParser.cpp : attempt to fix build issue on r-forge
        * include/Rcpp/DataFrame.h: nrows() method
        * include/Rcpp/vector/RangeIndexer.h: now derives from VectorBase so
        that we can use it in sugar.

2012-11-22  JJ Allaire <jj@rstudio.org>

        * include/exceptions.h: new exception constructor / stop function
        * src/exceptions.cpp: new exception constructor / stop function
        * include/RcppCommon.h: new exception constructor / stop function

2012-11-22 Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/iostream.h: use delete rdbuf() as recommended by
        Martyn Plummer
        * include/Rcpp/sugar/functions/self_match.h: self_match, giving a
        functionality similar to match( x, unique(x) )
        * src/coerce.cpp: added coercion to STRSXP
        * include/Rcpp/internal/r_coerce.h : added r_coerce<.,STRPSXP>
        * include/Rcpp/sugar/functions/table.h: sugar table
        * include/Rcpp/sugar/functions/duplicated.h: sugar duplicated

2012-11-21  JJ Allaire <jj@rstudio.org>

        * R/Rcpp.package.skeleton.R: add 'attributes' and 'cpp_files'
        parameters to Rcpp.pacakge.skeleton
        * inst/skeleton/rcpp_hello_world_attributes.cpp: version of hello world
        that uses attributes
        * man/Rcpp.package.skeleton.Rd: doc updates
        * inst/doc/Rcpp-attributes/Rcpp-attributes.Rnw: doc updates
        * DESCRIPTION: bump version to 0.10.0.3

2012-11-21  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/Misc/piBySimulation.r: New simple example using Rcpp
        attributes in a 'compute pi by simulation in R and C++' exercise
        * inst/examples/Misc/piSugar.cpp: Corresponding C++ variant

2012-11-21  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/iostream/Rostream.h: Fix warning given by -Wreorder
        * include/Rcpp/sugar/functions/mapply/mapply_3.h: more flexible
        * include/Rcpp/vector/Vector.h: More efficient assign_object, which
        is used in the assignment operator
        * include/Rcpp/sugar/functions/clamp.h: added clamp function

2012-11-20  JJ Allaire <jj@rstudio.org>

        * src/Attributes.cpp: ensure dynlib cache state is always updated
        * inst/doc/Rcpp-attributes/Rcpp-attributes.Rnw: elaborate further
        on exporting C++ interfaces from packages

2012-11-20  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/iostream/Rostream.h: change order of initiaization in
        ctor. was making solaris compiler unhappy
        * include/Rcpp/stats/random/rnorm.h: not using function pointer
        generators, as this generates (anachronisms) warning on
        solaris. Also, this version is more efficient since there is no need
        to dereference the function pointer

2012-11-19  JJ Allaire <jj@rstudio.org>

        * src/AttributesParser.h: support for argument default values
        * src/AttributesParser.cpp: support for argument default values
        * src/Attributes.cpp: support for argument default values
        * man/exportAttribute.Rd: documentation updates
        * man/compileAttributes.Rd: documentation updates
        * man/sourceCpp.Rd: documentation updates
        * inst/doc/Rcpp-attributes/Rcpp-attributes.Rnw: add documentation
        on changes to attributes in 0.10.1

2012-11-18  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: sourceCpp embedded R code; print warning if no
        export attributes are found in source file
        * src/AttributesParser.h: sourceCpp embedded R code
        * src/AttributesParser.cpp: sourceCpp embedded R code; new scheme
        for mixing user and generated C++ headers
        * src/Attributes.cpp: sourceCpp embedded R code; include <Rcpp.h>
        above generated modules
        * man/sourceCpp.Rd: documentation updates
        * man/interfacesAttribute.Rd: documentation updates

2012-11-18  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/converter.h: allow CharacterVector::create(
        NA_STRING )
        * include/Rcpp/sugar/functions/mapply/mapply_2.h: more cases in mapply

2012-11-17  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-modules/Rcpp-modules.Rnw: Change free function name
        'range' to 'uniformRange' to protect it from getting clobbered by the
        new sugar function range.

2012-11-17  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/internal/wrap_end.h: have calls to wrap as late as
        possible so that they "see" all (potentially user defined) overloads
        of wrap.
        * include/Rcpp/internal/SEXP_Iterator.h: directly iterate over SEXP.
        const iterator for List and ExpressionVector

2012-11-16  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/Vector.h : added static methods Vector::is_na
        and Vector::get_na
        * include/Rcpp/sugar/functions/setdiff.h: initial version of setdiff
        and intersect
        * include/Rcpp/vector/MatrixColumn.h: dealing with const-ness
        * include/Rcpp/vector/MatrixRow.h: dealing with const-ness
        * include/Rcpp/vector/traits.h: dealing with const-ness
        * include/Rcpp/vector/proxy.h: dealing with const-ness
        * include/Rcpp/vector/MatrixBase.h: dealing with const-ness
        * include/Rcpp/vector/Vector.h: dealing with const-ness

2012-11-15  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/sugar/logical/SingleLogicalResult.h : apply patch
        suggested by Karl Millar
        * R/Attributes.R: new R function areMacrosDefined
        * man/evalCpp.Rd: documentation update
        * include/Rcpp/sugar/functions/match.h : generic version of match
        * include/Rcpp/sugar/tools/iterator.h: help iterator that helps
        writing match in terms of stl algorithms.
        * include/Rcpp/vector/Vector.h: class no_init that can be used to create
        an uninitialized vector. e.g. IntegerVector out = no_init(10) ;
        * include/Rcpp/sugar/functions/unique.h: sugar version of %in% using
        unordered_set
        * include/Rcpp/sugar/functions/minmax.h: min, max, and range

2012-11-14  JJ Allaire <jj@rstudio.org>

        * src/Attributes.cpp: create sourceCpp context list using single
        statement

2012-11-14  Dirk Eddelbuettel  <edd@debian.org>

        * inst/announce/ANNOUNCE-0.10.0.txt: Fix typo spotted by Martin
        Morgan in announcement mail

2012-11-14  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/internal/wrap.h: fix for wrap( std::complex<double> )
        * include/Rcpp/module/class_Base.h: factored out from Module.h
        * R/00_classes.R: the C++Class gains the parents slot to hold information
        about parent classes of the class
        * src/Module.cpp : The CppClass constructor fills the parents slot of C++Class

2012-11-13  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.10.0
        * inst/NEWS: Release 0.10.0
        * inst/include/Rcpp/config.h: Release 0.10.0
        * debian/*: Similarly updated for new release to Debian

2012-11-13  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/as.h: as<enum>
        * include/Rcpp/internal/wrap.h : wrap( enum )
        * include/Rcpp/traits/wrap_type_traits.h: trait to help wrap( enum )
        * include/Rcpp/traits/r_type_traits.h: trait to help as<enum>
        * include/Rcpp/module/macros.h: macros RCPP_EXPOSED_ENUM to help as/wrap
        of enums

2012-11-12  Dirk Eddelbuettel  <edd@debian.org>

        * inst/announce/ANNOUNCE-0.10.0.txt: Announcement draft

2012-11-12  JJ Allaire <jj@rstudio.org>

        * inst/doc/Rcpp-attributes/*: New vignette

2012-11-12  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/vector/Vector.h : adding const_iterator and associated
        begin() and end() methods
        * include/Rcpp/vector/Matrix.h : idem

2012-11-11  JJ Allaire <jj@rstudio.org>

        * src/Attributes.cpp: fully qualify _ in generated code

2012-11-11  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/iostream/Rstreambuf.h: implementing sync() so that
        flush works
        * src/Rstreambuf.cpp: implementation
        * src/Rostream.cpp : added Rcerr that forwards to REprintf

2012-11-10  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: ensure function definitions are never stale
        * src/Attributes.cpp: add optional hook for inclusion of package types
        * examples/Attributes/Export.cpp: example use of Rcpp::export
        * examples/Attributes/Depends.cpp: example use of Rcpp::depends
        * examples/Attributes/sourceCpp.R: example use of sourceCpp()
        * examples/Attributes/cppFunction.R: example use of cppFunction()

2012-11-09  Romain Francois <romain@r-enthusiasts.com>

        * R/Attributes.R: Passing verbose from evalCpp to cppFunction
        * include/RcppCommon.h: include <limits> instead of <limits.h>
        * include/Rcpp/vector/CharacterVectorExtractionIterator.h: iterator
        class to quickly iterate over the content of a CharacterVector. The
        content that is iterated over is to be considered read-only.

2012-11-08  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: special sourceCpp handling for file within the src
        directory of a package; use .h as suffix for generated headers
        * src/Attributes.cpp: add information on arguments to Rcpp module;
        use inline rather than static linkage for generated C++ shims;
        generated headers: add header guard and use .h suffix;
        * man/cppFunction.Rd: update documentation
        * man/sourceCpp.Rd: update documentation
        * man/evalCpp.Rd: update documentation
        * man/exportAttribute.Rd: update documentation
        * man/interfacesAttribute.Rd: update documentation


2012-11-08  Romain Francois <romain@r-enthusiasts.com>

        * R/Module.R: Module functions taking no arguments don't get the ellipsis
        anymore in their formals
        * src/Module.cpp: passing up the number of arguments of the function
        * R/Attributes.R: added evalCpp
        * man/evalCpp.Rd: documentation for evalCpp

2012-11-07  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: derive depends from package LinkingTo; change
        sourceCpp plugin parameter to depends and respect Rcpp::interfaces
        generated include files
        * src/Attributes.cpp: validate exported C++ functions before calling;
        use static rather than inline for stubs to avoid call-site bloat;
        improved error message when package hpp already exists; import Rcpp
        namespace into package shim namespace
        * src/AttributesParser.h: add signature and isHidden methods
        * src/AttributesParser.cpp: add signature and isHidden methods
        * src/exceptions.cpp: add function_not_exported exception
        * include/Rcpp/exceptions.h: add function_not_exported exception
        * man/cppFunction.Rd: update documentation
        * man/sourceCpp.Rd: update documentation
        * man/compileAttributes.Rd: update documentation
        * man/dependsAttribute.Rd: update documentation
        * man/exportAttribute.Rd: update documentation
        * man/interfacesAttribute.Rd: update documentation

2012-11-07  Romain Francois <romain@r-enthusiasts.com>

        * src/Language.cpp: Language gains a fast_eval method, without the whole try/catch
        * src/barrier.cpp: function char_nocheck to avoid the check in using CHAR
        * include/Rcpp/sugar/functions/unique.h: sugar unique and sort_unique
        using unordered_set (perhaps we could use it from c++11).

2012-11-06  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: tweak whitespace in verbose mode
        * src/AttributesParser.h: support for interfaces attribute
        * src/AttributesParser.cpp: support for interfaces attribute
        * src/Attributes.cpp: support for interfaces attribute; refactor
        code generators; use single module for exports; return list of
        updated files from compileAttributes
        * src/Module.cpp: add package parameter to GetCppCallable
        * include/Rcpp/Module.h: add package parameter to GetCppCallable
        * man/compileAttributes.Rd: documentation updates

2012-11-05  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/Module.h: added class CppInheritedProperty to handle
        inherited properties
        * include/Rcpp/module/class.h: implemented inheritance of properties

2012-11-05  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: use modules for attribute code generation
        * src/Attributes.cpp: use modules for attribute code generation
        * src/AttributesParser.h: use modules for attribute code generation
        * src/AttributesParser.cpp: use modules for attribute code generation

2012-11-04  Dirk Eddelbuettel  <edd@debian.org>

        * tests/doRUnit.R: In "development releases" (such as 0.9.15.5) we
        now default to setting the required CRAN-test-workaround-kludge
        "RunAllRcppTests" to "yes" as a default -- but not for actual
        releases (with versions such as 0.9.15)

2012-11-04  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/module/CppFunction.h: fixed module bug (virtual function
        was not defined)

2012-11-03  JJ Allaire <jj@rstudio.org>

        * Use CLINK_CPPFLAGS rather than PKG_CXXFLAGS for LinkingTo
        include directories (identical behavior to inline)

2012-11-03  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/sugar/functions/which_min.h : sugar which.min
        * include/Rcpp/sugar/functions/which_max.h : sugar which.max
        * include/Rcpp/module/Module.h : added get_function_ptr which returns
        the pointer of the target function as a DL_FUNC

2012-11-02  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.rmath.R: More tests added

2012-11-02  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/module/CppFunction.h : factored CppFunction in its own
        file and added the get_function_ptr virtual method. added
        documentation
        * include/Rcpp/module/Module_generated_CppFunction.h: implementation
        of get_function_ptr in classes that derive CppFunction
        * src/Module.cpp: s/get_function_ptr/get_function/
        * include/Rcpp/module/Module.h : factored out and documented.
        s/get_function_ptr/get_function/

2012-11-01  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.rmath.R: New unit test file added

2012-11-01  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: change 'envir' param to 'env' for consistency with
        the interface of loadModule
        * man/sourceCpp.Rd: documentation updates
        * man/cppFunction.Rd: documentation updates

2012-11-01  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/sugar/logical/or.h : implementing x | y where x and y
        are Logical sugar expressions
        * include/Rcpp/sugar/logical/and.h : implementing x & y where x and y
        are Logical sugar expressions

2012-10-31  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: add cppFunction for inline-style definitions;
        change 'local' param to (more clear and explicit) 'envir' param;
        change 'show.output' param to 'showOutput'; add parameter to
        onBuild hook to indicate if the source was from a 'code' parameter
        * src/Attributes.cpp: factored parser into it's own file
        * src/AttributesParser.h: attributes parser header
        * src/AttributesParser.cpp: attributes parser implementation
        * man/sourceCpp.Rd: documentation updates
        * man/compileAttributes.Rd: documentation updates
        * man/cppFunction.Rd: documentation for cppFunction
        * NAMESPACE: export for cppFunction

2012-10-31  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/module/class.h: factored out of Module.h which started to
        be too big. class_ gains a derives<Parent>( "Parent" ) for so that the
        class inherits method that were exposed by its parent.
        * include/Rcpp/Module.h: template class CppInheritedMethod for
        implementing inherited method
        * src/Module.cpp: get_class_pointer implementation

2012-10-30  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Rmath.h: Finalised adding Rmath functions

2012-10-30  JJ Allaire <jj@rstudio.org>

        * R/Attributes.R: new functions sourceCpp and compileAttributes that
        use C++11 style attributes (embedded in comments) to perform
        automatic generation of boilerplate marshaling code
        * src/Attributes.cpp: support functions for attribute handling
        * include/Rcpp/exceptions.h: file io exception classes
        * man/sourceCpp.Rd: documentation for sourceCpp
        * man/compileAttributes.Rd: documentation for compileAttributes
        * man/exportAttriute.Rd: documentation for export attribute
        * man/dependsAttribute.Rd: documentation for depends attribute
        * NAMESPACE: exports for sourceCpp and compileAttributes

2012-10-30  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/as.h: new bare_as to simplify uses of as
        * include/Rcpp/module/Module_generated_Factory.h: using bare_as
        * R/Module.R: promoting the show method
        * src/Attributes.cpp: remove g++ warning (int != size_t)

2012-10-29  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Rmath.h: More Rmath functions

2012-10-29  Romain Francois <romain@r-enthusiasts.com>

        * R/Module.R: Taking care of a check warning
        * include/Rcpp/module/macros.h: adding RCPP_EXPOSED_CLASS_NODECL
        * include/Rcpp/Module.h: introducing converter to facilitate
        conversion between classes.
        * R/Module.R: Methods registered internally with converter will
        generate the appropriate "as" S4 method.

2012-10-28  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Rmath.h: Beginnings of a namespave 'R' around
        Rmath functions so that Rcpp users can call the (scalar) functions
        R::pnorm() which helps with adapting or integrating programs writting
        outside of Rcpp

2012-10-27  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/module/macros.h: Add forward declaration of class
        to macro 'RCPP_EXPOSED_CLASS'

2012-10-25  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/internal/wrap.h: wrapping module object with the help
        of the RCPP_EXPOSED_CLASS
        * include/Rcpp/module/macros.h: improving the macros so that wrap and
        as are covered
        * include/Rcpp/traits/wrap_type_traits.h: wrapping module objects
        * include/Rcpp/module/Module_generated_class_factory.h : factories
        are alternatives to constructors. For now, we can expose as factories
        any free function that returns a pointer to the target class
        * include/Rcpp/module/Module_generated_Factory.h : factories
        * include/Rcpp/Module.h: exposing factories

2012-10-24  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/traits/is_pointer.h: traits to identify if a type is a
        pointer
        * include/Rcpp/traits/un_pointer.h: traits to remove a pointer
        * include/Rcpp/module/Module_generated_get_return_type.h : handle
        pointer return types
        * include/Rcpp/config.h: define RCPP_HAS_DEMANGLING for MAC OS <=
        10.7 (up to Lion)
        * include/Rcpp/module/macros.h: new file that contains macro to help
        with modules
        * include/Rcpp/traits/r_type_traits.h : new tag to allow as<T> where
        T is some class exposed in a module
        * include/Rcpp/as.h : implementation of as<T> in that case

2012-10-23  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/internal/wrap.h: new function module_wrap used
        internally by modules
        * include/Rcpp/module/Module_generated_CppMethod.h: using module_wrap
        and simplified the code (removing 35% of the generated code now
        rendered useless)
        * include/Rcpp/module/Module_generated_PointerCppMethod.h: using
        module_wrap and simplified the code
        * include/Rcpp/traits/module_wrap_traits.h : new file. helping
        implementation of module_wrap

        * R/00_classes.R: C++OverloadedMethods gets the field "nargs" to
        capture the number of arguments

        * R/01_show.R: cleanup

        * R/Module.R: handle the case where a method has no argument. In that
        case, the ellipsis does not end up in the formals

        * include/Rcpp/Module.h: exposing nargs in C++OverloadedMethods

2012-10-22  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/as.h: support for as<> for module objects
        * include/Rcpp/Module.h: idem
        * include/Rcpp/traits/r_type_traits.h: idem
        * src/Module.cpp: idem

2012-10-21  Romain Francois <romain@r-enthusiasts.com>

        * include/Rcpp/traits/wrap_type_traits.h: support for wrapping module objects
        * include/Rcpp/internal/wrap.h : idem
        * include/Rcpp/Module.h: idem

2012-10-13  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.15
        * inst/NEWS: Release 0.9.15
        * inst/include/Rcpp/config.h: Release 0.9.15
        * debian/*: Similarly updated for new release to Debian

2012-10-08  Dirk Eddelbuettel  <edd@debian.org>

        * src/exceptions.cpp: Additional PROTECT for parsing exception
        messages before returning them to R, from a suggestion by Ben North

2012-10-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.Date.R: Added a few more tests

2012-10-06  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Date.h: Dates are now represented as doubles,
        also added accessor functions for double and retained int

        * src/Date.cpp: Convert from SEXP to double, added constructor from
        double and added checks for 'finite' representation before converting
        to 'struct tm' adding support for NA, NaN and Inf

        * src/DateVector.cpp: Instantiate Date types as double

        * src/Datetime.cpp: Also added support for NA, NaN and Inf values

        * inst/unitTests/runit.Date.R: A few additional tests

2012-10-05  Dirk Eddelbuettel  <edd@debian.org>

        * src/exceptions.cpp: Applied patch by Martin Morgan which untangles
        the clang includes driven by version, and uses direct tests for
        presence of the header file
        * inst/include/RcppCommon.h: No longer define CLANG version meta
        variables as we can directly include the relevant header

2012-09-30  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.14
        * inst/NEWS: Release 0.9.14
        * inst/include/Rcpp/config.h: Release 0.9.14
        * debian/*: Similarly updated for new release to Debian

2012-09-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.sugarOps.R: More sugar Ops unit tests

2012-09-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.sugarOps.R: (Incomplete) beginnings of new
        unit test file for sugar operations on vectors and matrices

2012-09-07  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/functions/sign.h: Sign gets a SEXP operator

2012-09-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sugar/functions/math.h: Added new sugar
        function trunc(), round() and signif()
        * inst/unitTests/runit.sugar.R: Added unit tests for these

2012-09-01  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Makefile: The 'all' target is now empty to prevent
        autobuilders such as R-Forge from falling over

2012-07-23  Dirk Eddelbuettel  <edd@debian.org>

        * R/bib.R: Trim the trailing ".bib" from the generated bibtex
        filename as Windows adds one anyway leading to two and an error

2012-07-21  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Module.h (Rcpp): Corrected typo / incomplete
        reference in finalizer use

2012-07-06  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/config.h: In order to not attempt to include
        exception_defines.h if on OS X (as the clang runtime may not have
        predictable access to g++ headers providing these), do not define
        RCPP_HAS_DEMANGLING which is used in src/exceptions.cpp

2012-06-28  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.13
        * inst/NEWS: Release 0.9.13
        * inst/include/Rcpp/config.h: Release 0.9.13
        * debian/*: Similarly updated for new release to Debian

        * tests/doRUnit.R: Updated, added (by default commented-out) setting
        to enforce all tests to run, added standard copyright headers noting
        heritage off work by Martin Maechler and Gregor Gorjanc

        * inst/unitTests/runTests.R: Only check environment variable to run
        all tests if it is not already set (to cooperate with doRUnit.R)

2012-06-27  Dirk Eddelbuettel  <edd@debian.org>

        * src/Environment.cpp: Default ctor initializes its RObject with
        R_GlobalEnv; SEXP constructor does not use a default arg as it tests
        * inst/include/Rcpp/Environment.h: Corresponding change

        * inst/include/RcppCommon.h: #define(s) for before/after clang++ 3.0

        * src/exceptions.cpp: Added support for clang++ (>= 3.0) which (just
        like g++ 4.6 or later) needs bits/exceptions_defines

        * inst/unitTests/runit.modref.R: re-activated
        * inst/unitTests/runit.Module.client.package.R: re-activated core

        * inst/unitTests/runit.modref.R: Run only if RunAllCppTests var set
        * inst/unitTests/runit.Module.client.package.R: Idem
        * inst/unitTests/runit.support.R: Idem
        * inst/unitTests/runit.rcout.R: Idem
        * inst/unitTests/runit.environments.R: Idem
        * inst/unitTests/runit.Language.R: Idem
        * inst/unitTests/runit.Function.R: Idem

2012-06-23  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.12
        * inst/NEWS: Release 0.9.12
        * inst/include/Rcpp/config.h: Release 0.9.12
        * debian/*: Similarly updated for new release to Debian

        * src/Environment.cpp: Remove empty constructor which is redundant
        since fix in rev3592 with default SEXP value of R_GlobalEnv
        * inst/include/Rcpp/Environment.h: Idem

        * inst/unitTests/runTests.R (allTests): Command-line flag --allTests
        sets an environment variable indicating that all tests should run

        * inst/unitTests/runit.Module.R: Run only if RunAllCppTests var set
        * inst/unitTests/runit.Module.client.package.R: Idem
        * inst/unitTests/runit.client.package.R: Idem
        * inst/unitTests/runit.XPtr.R: Idem
        * inst/unitTests/runit.macros.R: Idem

        * inst/doc/unitTests/Rcpp-unitTests.R: Ensure Rcpp-unitTests
        vignette is built with RunAllCppTests flag set

        * cleanup: Also clean in inst/unitTests/testRcppClass/src

        * DESCRIPTION: Set Maintainer: to edd@debian.org as CRAN prefers to
        receive upload email from the same address the Maintainer field

2012-06-22  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.11
        * inst/NEWS: Release 0.9.11
        * inst/include/Rcpp/config.h: Release 0.9.11
        * debian/*: Similarly updated for new release to Debian

        * DESCRIPTION: Increased Depends to R (>= 2.15.1)

2012-06-21  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-modules/Rcpp-modules.Rnw: Updated to reflect use
        under R 2.15.1
        * inst/skeleton/zzz.R: Idem

2012-06-20  Dirk Eddelbuettel  <edd@debian.org>

        * R/loadRcppModules.R: Use lib.loc= argument on packageDescription()
        as suggested by Kurt, and fetch libname from enclosing environment

        * DESCRIPTION: Typo and grammar fixes with thanks to Kurt and Doug

2012-05-25  Dirk Eddelbuettel  <edd@debian.org>

        * inst/skeleton/zzz.R: Added new 'evalqOnLoad()' call for R-devel,
        currently commented out

2012-05-24  Dirk Eddelbuettel  <edd@debian.org>

        * inst/skeleton/Num.cpp: Added to Rcpp.package.skeleton(); will be
        added when module=TRUE in call
        * inst/skeleton/stdVector.cpp: Idem

        * inst/unitTests/testRcppModule/src/rcpp_module.cpp: added more
        comments, added copyright header, corrected output of example
        functions by not escaping "backslash-n" twice
        * inst/unitTests/testRcppModule/src/stdVector.cpp: added some
        comments, added copyright header
        * inst/unitTests/testRcppModule/src/Num.cpp: Idem

        * inst/unitTests/runit.Module.client.package.R: Added four simple
        tests for Rcpp Modules

        * inst/doc/Rcpp-modules/Rcpp-modules.Rnw: Some extensions and
        clarifications added

2012-05-13  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/iostream/Rostream.h: Added Rstreambuf.h include
        as per rcpp-devel discussion with Alexey Stukalov

2012-05-09  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Expanded R CMD SHLIB discussion
        after suggested changes from SC8ren HC8jsgaard; also expanded compiler
        section a little mentioning clang/clang++ and icc.

2012-05-02  Dirk Eddelbuettel  <edd@debian.org>

        * src/Environment.cpp: Move one default argument to Environment.h
        * src/Function.cpp: Move one default argument to Function.h
        * inst/THANKS: Thanks to Anirban Mukherjee for these two changes

2012-04-28  John M Chambers  <jmc@r-project.org>

        * R/RcppClass.R: use globalVariables() from R 2.15.1 (with exists()
        test to no break older versions) to declare C++ fields and methods
        * inst/unitTests/testRcppClass/R/load.R: test use

2012-04-22  Dirk Eddelbuettel  <edd@debian.org>

        * src/debugging.cpp: Expanded 'if defined()' test to included Cygwin
        thanks to a patch submitted by Dario Buttari

2012-04-19  Dirk Eddelbuettel  <edd@debian.org>

        * src/Evaluator.cpp: errorOccuredSym never used and commented out

2012-04-18  John M Chambers  <jmc@r-project.org>

        * R/RcppClass.R: New version of setRcppClass, allowing R classes to
        extend C++ classes used via Rcpp modules
        * R/loadModule.R: New function, replaces uses of .onLoad()
        * man/*: Added/updated corresponding documentation

2012-04-07  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h: bug fix. reported on Rcpp-devel
        http://comments.gmane.org/gmane.comp.lang.r.rcpp/3292

2012-03-29  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.Vector.R: unit test for containsElementNamed

2012-03-29  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h: Vector<> gains the
        containsElementNamed method to test for presence of named element

2012-03-24  Romain Francois  <romain@r-enthusiasts.com>

        * src/cache.cpp: Using a single Rcpp_cache, stored in the Rcpp
        namespace

        * src/Evaluator.cpp: Using tryCatch instead of rcpp_tryCatch, no more
        using .Internal; but still define rcpp_TryCatch for backwards compat.

2012-03-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Added short subsection on how to
        test a package from the command-line, expanding a patch by Glenn
        Lawyer in response to an initial rcpp-devel post by Dirk

2012-02-16  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.10
        * inst/NEWS: Release 0.9.10
        * inst/include/Rcpp/config.h: Release 0.9.10
        * debian/*: Similarly updated for new release to Debian

2012-02-16  Douglas Bates  <bates@stat.wisc.edu>

        * src/Evaluator.cpp: PROTECT the expr argument to Evaluator::Run.
        Reorganize code.

2011-12-15  Douglas Bates  <bates@stat.wisc.edu>

        * src/Evaluator.cpp: Avoid Rf_install inside an R API call

2012-02-12  Dirk Eddelbuettel  <edd@debian.org>

        * R/excections.R: Revert to previous use with .Internal
        * R/tools.R: Add branch for R 2.15.0 which can use
        assingInMyNamespace; else still use unlockBinding

2012-02-12  Dirk Eddelbuettel  <edd@debian.org>

        * Rcpp-introduction.Rnw: Small wording fix thanks to Pat Burns

2012-02-06  Romain Francois  <romain@r-enthusiasts.com>

        * R/exceptions.R: one less .Internal call
        * src/Evaluator.cpp: one less .Internal call

2012-02-03  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/Extractor.h: remove use of Fast in Extractor

        * inst/include/Rcpp/sugar/functions/mapply/mapply.h: new sugar
        function, similar to sapply, but with 2 or 3 (for now) input vectors

2012-02-01  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/iostream/Rostream.h: no need to include Rcpp.h
        here

        * inst/include/RcppCommon.h: include Rostream.h here, instead of ...

        * inst/include/Rcpp.h: ... here (needed for RcppArmadillo)

2012-01-29  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/diff.h: custom implementation of diff for the
        REALSXP case, skipping unnecessary NA tests

2012-01-24  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: New FAQ entry on passing a single
        option to g++, based on a rcpp-devel question by Whit Armstrong.

2012-01-15  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h: fixing IntegerVector(int,int),
        reported by Gregor Kastner on rcpp-devel
        * inst/unitTests/runit.Vector.R: regression test for the above

2011-12-25  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.9
        * inst/NEWS: Release 0.9.9
        * inst/include/Rcpp/config.h: Release 0.9.9
        * debian/*: Similarly updated for new release to Debian

2011-12-24  Dirk Eddelbuettel  <edd@debian.org>

        * Reverting the 'int64' changes listed below (during the period from
          Oct-31 to Nov-07) which adversely affect packages using Rcpp
          We will re-apply the 'int64' changes in a way which should
          cooperate more easily with 'long' and 'unsigned long'
          This covered svn revisions 3264 to 3308.

        * DESCRIPTION: Remove (for now) Depends: on int64
        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Ditto for int64_t example

        * inst/unitTests/runit.Module.client.package.R: On Windows,
        deactivate 'test.Module.package'

        * inst/unitTests/runit.client.package.R: On Windows, deactivate
        'test.client.packageA' test

2011-12-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runTests.R: unit tests output 'fallback' directory
        changed to '..' and files are now in top-level of $pkg.Rcheck/

2011-12-21  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.8
        * inst/NEWS: Release 0.9.8
        * inst/include/Rcpp/config.h: Release 0.9.8
        * debian/*: Similarly updated for new release to Debian

2011-12-20  Dirk Eddelbuettel  <edd@debian.org>

        * inst/skeleton/zzz.R (.onLoad): correct order of arguments

2011-12-18  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/FastLM/lmArmadillo.R: Link with -llapack when using
        external Armadillo library (but RcppArmadillo makes all this easier)

2011-12-18  Romain Francois  <romain@r-enthusiasts.com>

        * inst/doc/*: Fixes to various vignettes for new version of highlight

2011-12-16  Douglas Bates  <bates@stat.wisc.edu>

        * inst/unitTests/runit.stats.R: Correct cut+paste typo in qbinom

        * inst/include/Rcpp/XPtr.h: Check for XPtr type constructing from SEXP

2011-12-12  John M Chambers  <jmc@r-project.org>

        * R/RcppClass.R: Added setRcppClass for classes extending C++ classes
        * man/setRcppClass.Rd: Added corresponding documentation
        * NAMESPACE: Added corresponding exports entry

2011-11-13  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/stats/f.h: Correct call to not require ncp parameter

        * inst/unitTests/runit.stats.R: Add unit tests for pf(), pnf(),
        pchisq(), pnchisq() and pcauchy()

2011-11-07  Romain Francois  <romain@r-enthusiasts.com>

        * include/Rcpp/internal/wrap.h: implemented wrap_dispatch_importer__impl
        for int64 and uint64, needed for RProtoBuf

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Add int64_t usage example

2011-11-06  Romain Francois  <romain@r-enthusiasts.com>

        * include/Rcpp/modules/Module_generated_Pointer_method.h: added code to deal
        with const free "methods", e.g. OUT foo( const Class*, ...) in modules
        Before const_method could only deal with actual const methods of the class,
        e.g. OUT Class::foo( ... ) const
        * include/Rcpp/modules/Module_generated_Pointer_CppMethod.h: idem
        * include/Rcpp/as.h: deal with as<int64_t> and as<uint64_t>
        * include/Rcpp/internal/export.h : deal with as< some_container<int64_t> >
        and as< some_container<uint64_t> > where some_container is some container
        that has iterators, e.g. std::vector

2011-10-31  Romain Francois  <romain@r-enthusiasts.com>

        * include/Rcpp/int64/int64_lite.h: handling int64_t and uint64_t types,
        based on the int64 package
        * include/Rcpp/internal/wrap.h: new dispatch layers to handle int64_t,
        uint64_t and containers of these
        * DESCRIPTION: new depending on int64

2011-10-28  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/iostream/Rostream.h (Rcpp): Added tentative patch
        for operator<< also contributed by Jelmer Ypma -- but kept commented
        out for now

2011-10-25  Dirk Eddelbuettel  <edd@debian.org>

        * src/Rostream.cpp: Patch by Jelmer Ypma which adds a new device
        'Rcout' not unlike std::cout but uses Rprintf internally
        * src/Rstreambuf.cpp: Idem
        * include/include/Rcpp/iostream/Rostream.h: Idem
        * include/include/Rcpp/iostream/Rstreambuf.h: Idem
        * include/include/Rcpp.h:  Include new headers

        * inst/unitTests/runit.rcout.R: Added simple unit test

2011-09-29  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.7
        * inst/NEWS: Release 0.9.7
        * inst/include/Rcpp/config.h: Release 0.9.7
        * debian/*: Similarly updated for new release to Debian

        * inst/include/Rcpp/sugar/block/SugarBlock_1.h: Apply second path by
        Martyn Plummer to permit compilation on Solaris
        * inst/include/Rcpp/sugar/block/SugarBlock_2.h: Idem
        * inst/include/Rcpp/sugar/block/SugarBlock_3.h: Idem
        * inst/include/Rcpp/sugar/matrix/outer.h: Idem
        * inst/include/Rcpp/vector/LazyVector.h: Idem
        * inst/unitTests/testRcppModule/src/stdVector.cpp: Idem

2011-09-24  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Extractor.h: Apply patch by Martyn Plummer to
        help with compilation on Solaris
        * inst/include/Rcpp/sugar/block/Vectorized_Math.h: Idem
        * inst/include/Rcpp/sugar/functions/math.h: Idem

        * inst/include/Rcpp/sugar/block/SugarBlock_2.h: Also applied path by
        Martyn Plummer, but with additional #ifdef layer for SunPro Compiler
        * inst/include/Rcpp/vector/LazyVector.h: Idem

2011-08-26  Douglas Bates  <bates@stat.wisc.edu>

        * inst/examples/OpenMP/OpenMPandInline.r: Added another variant
        using import_transform for the Rcpp Vector class.

2011-08-26  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/*h: Removed exception specifiers in function headers
        * src/*cpp: Corresponding changes in implementations

        * inst/examples/OpenMP/OpenMPandInline.r: Added two std::transform()
        variants as suggested in rcpp-devel email by Davor Cubranic

2011-08-25  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/OpenMP/OpenMPandInline.r: Added new example for
        OpenMP via inline, comparing simple loops with plain Rcpp and sugar

2011-08-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/Misc/ifelseLooped.r: Added new example based on blog
        post today, and a StackOverflow ansers---and which shows how Rcpp can
        accelerate loops that may be difficult to vectorise due to dependencies

        * inst/examples/Misc/: New directory for small examples regrouping
        the new example as well as the fibonacci example added in Rcpp 0.9.6

2011-08-17  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Added a short section including an
        example on the issue raised by Murray wherein 64 bit 'long' integer
        types can be cast with loss to numeric types without error or warning.

2011-07-28  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.Function.R: new unit test for accessing a
        non-exported function from a namespace

2011-07-26  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.6
        * inst/NEWS: Release 0.9.6
        * inst/include/Rcpp/config.h: Release 0.9.6
        * debian/*: Similarly updated for new release to Debian

2011-07-24  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/Fibonacci/fib.r: New example showing how to compute a
        Fibonacci sequence using Rcpp and compare it to R and byte-compiled R

2011-07-14  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/RcppGibbs/RcppGibbs.R: New example RcppGibbs,
        extending Sanjog Misra's Rcpp illustration of Darren Wilkinson's
        comparison of MCMC Gibbs Sampler implementations;
        * inst/examples/RcppGibbs/timeRNGs.R: added short timing on Normal
        and Gaussian RNG draws between Rcpp and GSL as R's rgamma() is seen
        to be significantly slower

2011-07-13  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/traits/is_eigen_base.h: helper traits to
        facilitate implementation of the RcppEigen package. The is_eigen_base
        traits identifies if a class derives from EigenBase using SFINAE

        * inst/include/Rcpp/internal/wrap.h: new layer of dispatch to help
        RcppEigen

2011-07-07  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/XPtr.h: The XPtr class template gains a second
        template parameter allowing the developper to supply his/her own
        finalizer instead of the default one that calls delete

2011-07-05  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.5
        * inst/NEWS: Release 0.9.5
        * inst/include/Rcpp/config.h: Release 0.9.5
        * debian/*: Similarly updated for new release to Debian

2011-07-02  Dirk Eddelbuettel  <edd@debian.org>

        * cleanup: Also clean in examples/OpenMP/

2011-06-09  Dirk Eddelbuettel  <edd@debian.org>

        * inst/skeleton/zzz.R (.onLoad): Force load of methods package before
        calling loadRcppModules() to make 'R CMD check' happier

2011-06-06  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h : init becomes protected to fix the bug
        reported by Doug Bates on Rcpp-devel.

2011-05-31  Romain Francois  <romain@r-enthusiasts.com>

        * R/loadRcppModules.R: New argument "direct" in loadRcppModules

        * R/tools.R: New unexported function forceAssignInNamespace

2011-05-29  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/stats/random/rlnorm.h: Repaired accidental header
        guard from 'norm' to 'lnorm' so that the file really gets included,
        make several calls to standard library 'exp()' explicit as '::exp()'
        and fixed a cut-and-paste typo

2011-05-24  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/internal/wrap.h: For arguments of type const char *,
        wrap now checks for NULL arguments before calling Rf_mkString()
        * unitTests/runit.wrap.R: Added unit test for this

2011-05-14  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-quickref/Rcpp-quickref.Rnw: Corrected an error in STL
        example and added two more STL examples

2011-04-27  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/OpenMP/piWithInterrupts.cpp: Beginnings of new
        contributed example on OpenMP as well as user interrupt handling

2011-04-26  Romain Francois  <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/functions/mean.h: new sugar function: mean

        * inst/include/Rcpp/sugar/functions/var.h: new sugar function: var

        * inst/include/Rcpp/sugar/functions/sd.h: new sugar function: sd

2011-04-19  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: New example setting row and column
        names for matrices

2011-04-16  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: New example using Rcpp.plugin.maker

2011-04-12  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.4
        * inst/NEWS: Release 0.9.4
        * inst/include/Rcpp/config.h: Release 0.9.4
        * debian/*: Similarly updated for new release to Debian

2011-04-12  Romain Francois  <romain@r-enthusiasts.com>

        * inst/unitTests/testRcppModules/src/stdVector.cpp: compiler
        disambiguation

        * src/r_cast.cpp: use a callback to R's "as.character" instead of
        calling Rf_coerceVector, which did not work as expected for factors

2011-04-11  Romain Francois  <romain@r-enthusiasts.com>

        * R/loadRcppModules.R: New R function "loadRcppModules" that looks
        for the "RcppModules" field in the DESCRIPTION file, loads and
        populates the modules into the package NAMESPACE

        * man/loadRcppModules.Rd: documentation

        * inst/unitTests/testRcppModule: using loadRcppModules

2011-04-11  Dirk Eddelbuettel  <edd@debian.org>

        * inst/man/Rcpp-package.Rd: Added JSS reference in \references{}

        * inst/doc/*: Added JSS reference to vignettes

2011-04-09  Dirk Eddelbuettel  <edd@debian.org>

        * inst/CITATION: Finalized using JSS data on volume, number, pages

2011-04-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-quickref/Rcpp-quickref.Rnw: Add patch by Christian
        pointing out need for Rcpp:: namespace qualifier, and hint for Rcpp-FAQ

2011-04-05  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Added OS X entry for min. sufficient
        versions of OS X itself and Xode based on Simon's post to rcpp-devel

2011-04-05  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.3
        * inst/NEWS: Release 0.9.3
        * inst/include/Rcpp/config.h: Release 0.9.3
        * debian/*: Similarly updated for new release to Debian

2011-04-05  Romain Francois  <romain@r-enthusiasts.com>

        * R/01_show.R: set of cosmetic changes to the show method for C++
        classes

        * inst/include/Rcpp/Module.h: fixed module bug by not using
        singletons of the class_ template

2011-04-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-introduction.Rnw: Updated to forthcoming JSS paper

        * inst/CITATION: Added citation() support using forthcoming paper

        * inst/doc/Makefile: Trying make parallel builds possible by not calling
        'clean' in the 'all' target; thanks to Brian Ripley for the heads-up

2011-04-02  Dirk Eddelbuettel  <edd@debian.org>

        * cleanup: Also clean in inst/unitTest/testRcppModule/src/

        * inst/include/RcppCommon.h: Define new variable for g++ < 4.6.0
        * src/exceptions.cpp: Include <exception_defines.h> up to g++-4.5 only

        * inst/unitTests/testRcppModule/src/stdVector.cpp: Use #ifdef not #if

        * inst/include/Rcpp/module/Module_generated_ctor_signature.h: Add a
        bit of null-op code to suppress a 'unused parameter' warning in the
        initial (and non-templated) ctor_signature() function

2011-03-21  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/testRcppModule/src/stdVector.cpp: Protect push_back
        declaration by #ifdef as it conflicts with -std=c++0x use for g++-4.5

2011-03-17  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/RcppCommon.h: Condition the typedef for 'long long'
        of rcpp_long_long_type on the (still experimental) support for C++0x
        which can be enabled with the non-portable g++ flag '-std=c++0x';
        adding a test for C++0x support suppresses a new warning with g++ about
        long long being part of C++98; thanks to Kurt Hornik for raising this

2011-03-10  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/grow.h: Applied another patch kindly supplied by
        Murray which fixes another clang/llvm and C++ conformance issue by
        re-ordering declarations as unqualified names must be declared before
        they are used, even when used within templates.

2011-02-28  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Makefile: Call R and Rscript relative to R_HOME/bin

2011-02-23  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.2
        * inst/NEWS: Release 0.9.2
        * inst/include/Rcpp/config.h: Release 0.9.2
        * debian/*: Similarly updated for new release to Debian

        * inst/include/RcppCommon.h: Apply patch by Alexey Stukalov to enable
        basic Intel Compiler support without Cxx0x or TR1 features

        * inst/THANKS: Added some Thank You! to Baptiste, Alexey and Ken

        * inst/include/Rcpp/Module.h: Minor reworking of module loading
        macro to get rid of one g++ warning

2011-02-22  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.Module.client.package.R: Add a test for OS X
        10.5.* or older and do not execute the test here as g++ 4.2.1 balks
        at some of the Rcpp modules code. Thanks to Simon Urbankek for
        pinning this down and Baptiste Auguie for additonal testing.

2011-02-20  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Added RcppArmadillo example

2011-02-19  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Added three more setup-related
        questions in the first section following another rcpp-devel question

2011-02-14  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.1
        * inst/NEWS: Release 0.9.1
        * inst/include/Rcpp/config.h: Release 0.9.1
        * debian/*: Similarly updated for new release to Debian

2011-02-13  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Module.h: Cache return of Rf_install("Module") in
        a static helper function used by the LOAD_RCPP_MODULE macro

2011-02-11  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Added two more examples

2011-02-10  Douglas Bates  <bates@stat.wisc.edu>

        * inst/include/Rcpp/XPtr.h: Replace calls to EXTPTR_PTR with
        R_ExternalPtrAddr.  The distinction is important when R is
        compiled with PROTECTCHECK enabled.

2011-02-01  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h: extra PROTECT'ion in several places

2011-01-25  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/DataFrame_generated.h: Assign Rf_install() result
        to local SEXP (by modifying generator script creating the file)
        * inst/include/Rcpp/DataFrame.h: Assign Rf_install() result to local SEXP
        * inst/include/Rcpp/DottedPair.h: idem
        * inst/include/Rcpp/grow.h: idem
        * inst/include/Rcpp/Module.h: idem
        * inst/include/Rcpp/vector/eval_methods.h: idem
        * inst/include/Rcpp/vector/Vector.h: idem

2011-01-25  Douglas Bates  <bates@stat.wisc.edu>

        * src/exceptions.cpp: Assign Rf_install() result to local SEXP
        * src/Evaluator.cpp: idem
        * src/Reference.cpp: idem
        * src/S4.cpp: idem

        * inst/include/Rcpp/Date.h: Use predefined symbol.

2011-01-22  Dirk Eddelbuettel  <edd@debian.org>

        * src/cache.cpp: Assign Rf_install() result to local SEXP
        * src/Environment.cpp: idem
        * src/Evaluator.cpp: idem
        * src/Function.cpp: idem
        * src/Function.cpp: idem
        * src/RObject.cpp: idem
        * src/Symbol.cpp: idem

        * inst/doc/Rcpp.bib: Added SoDA (some time ago)

2011-01-13  Douglas Bates  <bates@stat.wisc.edu>

        * src/Reference.cpp: Protect the value being set in Reference::FieldProxy::set

2011-01-11  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/string_proxy.h: fix implicit conversion to int,
        reported by Daniel Sabanes Bove on Rcpp-devel

        * inst/unitTests/runit.vector.R: unit test for the above fix

2011-01-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp.bib: Updated a number of CRAN versions

2011-01-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/config.h (RCPP_VERSION): Set to 0.9.0, at last.

2011-01-06  Douglas Bates  <bates@stat.wisc.edu>

        * R/zzz.R (.onLoad): Don't call init_Rcpp_cache here.

        * src/Rcpp_init.c: Don't register init_Rcpp_cache.  It should only
        be called once and it is called in the C function R_init_Rcpp.

        * NAMESPACE: Use registered symbols instead of relisting them.
        Registration allows for checking the number of arguments.

2011-01-04  Dirk Eddelbuettel  <edd@debian.org>

        * src/debugging.cpp: Treat the *BSD flavours like Windows and offer
        file and line number but not stack trace (for lack of execinfo)

        * src/Makevars: Replace implicit variable $^ with explicit list

2011-01-02  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-quickref/Rcpp-quickref.Rnw: Applied patch with
        additional documentation by Christian Gunning

2010-12-23  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/RObject.h: New internal class SEXPstack to handle
        garbage collection. Presumably more efficient than R_PreserveObject
        and R_ReleaseObject

        * inst/include/Rcpp/sugar/operators/times.h: More efficient operator*
        for REALSXP sugar expressions, avoiding unnecessary NA tests.

        * inst/include/Rcpp/sugar/operators/divides.h: More efficient
        operator/ for REALSXP sugar expressions, avoiding unnecessary NA
        tests.

        * inst/include/Rcpp/sugar/operators/minus.h: More efficient operator- for
        REALSXP sugar expressions, avoiding unnecessary NA tests.

2010-12-22  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/operators/plus.h: More efficient operator+
        for REALSXP sugar expressions, avoiding unnecessary NA tests.

2010-12-22  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.Vector.R: Applied patch by Christian Gunning
        to add more tests for complex-typed vectors

2010-12-20  Dirk Eddelbuettel  <edd@debian.org>

        * R/inline.R (Rcpp.plugin.maker): Reverse order in PKG_LIBS

2010-12-19  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.9.0

        * debian/*: Similarly updated for new release to Debian

2010-12-18  Dirk Eddelbuettel  <edd@debian.org>

        * inst/announce/ANNOUNCE-0.9.0.txt: Started announcement post

        * inst/unitTests/runit.Date.R: Added new unit tests for date and
        datetime from string

2010-12-17  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Datetime.h: correct default format to use %OS for
        fractional seconds and not the popular typo %OS (i.e. ooh, not zero)

        * src/Datetime.cpp: add missing as.POSIXct() after strptime for
        constructor from string as we then use the constructor from double

        * src/Date.cpp: add missing as.Date() after strptime for constructor
        from string as we then use the constructor from int

2010-12-13  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/string_proxy.h: List::Proxy did not
        convert bool correctly, reported on Rcpp-devel by Daniel SabanC)s
        BovC) <daniel.sabanesbove@ifspm.uzh.ch>

2010-12-12  Romain Francois <romain@r-enthusiasts.com>

        * R/SHLIB.R: new unexported R function SHLIB, small wrapper around
        R CMD SHLIB

        * inst/include/Rcpp/sprintf.h: returning a std::string to avoid leaks

2010-12-10  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/sprintf.h: Use vsnprintf() instead

2010-12-10  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/barrier.h: faster versions (crossing the write
        barrier) for string_elt, etc ...(to be used only internally)

        * src/barrier.cpp: implementation of the above

2010-12-09  John M Chambers  <jmc@r-project.org>

        * src/Module.cpp: Rcpp/src/exceptions.cpp,
        Rcpp/src/Rcpp_init.c, etc. add a not_initialized exception and a
        dummy_pointer to identify such objects, throw exc. back to R

2010-12-07  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/matrix.h: Matrix gains a nested ::Sub
        typedef

2010-12-05  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/module/Module_generated_class_constructor.h: the
        default constructor was always considered valid because of the use of
        &yes instead of &yes_arity<0>

        * R/Rcpp.package.skeleton.R: Rcpp.package.skeleton( "foo",
        example_code = FALSE) did not work properly. Rcpp.package.skeleton
        gains some arguments

2010-12-05  Dirk Eddelbuettel  <edd@debian.org>

        * src/Date.cpp: Add 1900 to tm.year after mktime00() call as we now
        no longer assume the field is '1900-less'
        * src/Date.cpp: Define new static const variable baseYear as 1900
        and use throughout

        * inst/unitTests/runit.Date.R (test.Date.getFunctions): Added unit
        tests for the get* functions of the Date class

        * R/bib.R (bib): Correct expression for default Rcpp bibtex file

2010-12-04  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Date.h: Remove addition of 1900 in getYear()

2010-12-04  Romain Francois <romain@r-enthusiasts.com>

        * inst/doc/Rcpp-quickref/Rcpp-quickref.Rnw: documentation patch by
        Christian Gunnning <xian@unm.edu>

        * inst/include/Rcpp/vector/matrix.h: fix SubMatrix. Bug reported by
        Christian Gunnning <xian@unm.edu> on Rcpp-devel

        * inst/include/Rcpp/vector/SubMatrix.h: factored out of matrix.h

        * inst/include/Rcpp/sprintf.h: new sprintf template to format strings

2010-12-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runit.RObject.R: fix 'inherits' test added today

        * inst/include/Rcpp/module/Module_generated_Constructor.h: Applied
        patch by Tama Ma <pingnang@phys.ethz.ch> for up to seven args in ctor
        * inst/include/Rcpp/module/Module_generated_class_constructor.h: Idem
        * inst/include/Rcpp/module/Module_generated_ctor_signature.h: Idem

2010-12-03  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/RObject.h : new inline method inherits that
        checks if an object inherits from a given class (wrapper around
        Rf_inherits)

        * inst/unitTests/runit.RObject.R: unit test for the above

2010-12-02  Douglas Bates  <bates@stat.wisc.edu>

        * inst/include/Rcpp/generated/Function__operator.h,
          inst/include/Rcpp/Function.h: operator() becomes const.

2010-11-29  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h: trying to please suncc after
        CRAN checks

        * R/Module.R: protect the module$refClassGenerators <- generators
        line against the case where there are no classes (triggered a
        problem with the parser package)

2010-11-27  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.8.9

        * debian/*: Similarly updated for new release to Debian

2010-11-26  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h: List::create( _["foo"] ) sets
        the SEXP to R_MissingArg, usueful for formal arguments
        specifications, simpler form than List::create( _["foo"] =
        R_MissingArg )

        * inst/include/Rcpp/macros/unroll.h: helper macro RCPP_UNROLL_LOOP

        * inst/include/Rcpp/vector/MatrixColumn.h: added
        MatrixColumn::operator=( MatrixColumn& ) otherwise it gets
        synthetized by the compiler

        * inst/include/Rcpp/vector/MatrixRow.h: same for MatrixRow

        * inst/include/Rcpp/vector/Matrix.h: added Matrix( SubMatrix ) and
        Matrix::operator=( SubMatrix )

2010-11-25  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/module/Module_generated_function.h: new .function
        with formal argument specification

        * inst/include/Rcpp/module/Module_generated_CppFunction.h: helper
        classes for the above

        * R/Module.R: using the formal argument specification if available

        * R/populate.R: new R function populate to dump the contents of a
        module into an environment or a namespace

        * man/populate.Rd: documentation for populate

2010-11-24  Romain Francois <romain@r-enthusiasts.com>

        * R/00_classes.R: formals<- method for C++Function that allows to set
        default arguments, etc .. to a C++ function

2010-11-23  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Makefile: Call Rscript with --vanilla to skip user settings

2010-11-23  Romain Francois <romain@r-enthusiasts.com>

        * R/00_classes.R: C++Class gains a docstring slot to host self
        documentation

        * R/Module.R: calling an exposed C++ more efficiently by using the xp
        directly rather than traversing the map internally

        * R/00_classes.R: C++Function gains a docstring slot to host self
        documentation of the internal function. And a "signature" slot to
        host the C++ signature of the function

        * R/01_show.R: updated show( C++Function ) to display the docstring
        and the signature. updated show( C++Class ) to display the docstring.

        * inst/include/Rcpp/module/Module_generated_CppFunction.h: self
        documentation for exposed C++ functions and extraction of the
        signature

        * inst/include/Rcpp/module/Module_generated_function.h: idem

2010-11-22  Romain Francois <romain@r-enthusiasts.com>

        * R/00_classes.R: C++OverloadedMethods gains an "info" class methods,
        factored out from Module.R

        * R/01_show.R: more information printed in show( C++Class )

        * inst/include/Rcpp/Module/Module_generated_get_signature.h:
        templates to grab method signatures

        * inst/include/Rcpp/Module.h: CppMethod gains a signature method that
        returns the signature of the method.

        * R/00_classes.R: C++OverloadedMethods gains a "signatures" field
        that contains the signature of each overload

        * R/Module.R: registered method gain an automatically generated self
        description that contains the method(s) signature(s) and the
        docstring that is declared in .method

        * inst/include/Rcpp/Module/Module_generated_CppMethod.h: implement
        signature

        * inst/include/Rcpp/Module/Module_generated_Pointer_CppMethod.h: idem

2010-11-21  Romain Francois <romain@r-enthusiasts.com>

        * R/Module.R: internal version of cpp_hasDefaultConstructor

        * src/Module.cpp: implementation (Class__has_default_constructor)

        * inst/include/Rcpp/Module.h: support (class_.has_default_constructor)

        * inst/include/Rcpp/module/Module_generated_class_constructor.h: new interface
        for exposing constructors, the init_ disappears and the template arguments
        are directly applied to the .constructor function

        * inst/include/Rcpp/module/Module_generated_Constructor.h: removed init_*

        * inst/include/Rcpp/module/Module_generated_method.h: .method gains a docstring
        argument to allow self documentation of exposed methods

        * inst/include/Rcpp/module/Module_generated_PointerMethod.h: idem

        * R/Module.R: grab method docstrings

2010-11-20  John M Chambers  <jmc@r-project.org>

        * R/Module.R: now checks for the existence of a default constructor
        for a C++ class and generates a suitable $initialize() method accordingly.

2010-11-20  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/MatrixRow.h: added missing return *this ;

        * R/Module.R: dispatch based on void-ness of the methods. For example
        if all methods are known to be void, etc ...

        * R/00_classes.R: more information in the C++OverloadedMethods ref
        class

        * src/Module.cpp: new .External CppMethod__invoke_void and
        CppMethod__invoke_notvoid that are used when we know for sure that
        all overloaded methods are void, or not void

        * inst/include/Rcpp/Module.h: class_ gains invoke_void and
        invoke_notvoid to support the changes above

2010-11-18  Douglas Bates  <bates@stat.wisc.edu>

        * inst/include/Rcpp/module/Module_generated_[class_]Constructor.h:
        allow up to 6 arguments to .constructor

2010-11-18  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/Module.h: rework the class_ template to allow
        overloaded methods

        * R/00_classes.R: The C++Method class disappears and the
        C++OverloadedMethods enters. a "C++OverloadedMethods" object points
        to a set of overloaded C++ methods that all share the same name.

        * R/Module.R: adapt some of the code to cope with changes above

2010-11-17  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/as_vector.h: added the as_vector function
        that turns a sugar matrix expression into a vector of the appropriate
        type

        * inst/include/Rcpp/vector/Matrix.h: new SubMatrix class

2010-11-13  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/Module.h: expose constructors as the
        "cpp_constructor" field of "C++ClassRepresentation" and the
        "constructors" slot of "C++Class"

2010-11-07  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/operators/minus.h: fixed
        Minus_Vector_Primitive<RTYPE,false,T>

        * inst/unitTests/runit.sugar.R: new test for the above

2010-11-05  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/Module.h: exposing multiple constructors in modules

        * src/Module.cpp: The mangled class name is now "Rcpp_" plus the
        class name. The previous version used the address of the external
        pointer to the module, which was not constant.

2010-11-04  Douglas Bates  <bates@stat.wisc.edu>

        * inst/include/Rcpp/module/Module_generated_Constructor.h: remove
        redundant 'return's.

2010-11-04  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/Module.h: experimental way to specify which
        constructor to use in classes exposed by modules. This is still too
        restrictive as it only allows one constructor.

        * inst/include/Rcpp/sugar/block/SugarMath.h: extend the SUGAR_MATH_1
        macro so that we can apply functions (e.g. sqrt) directly on SEXP

2010-11-01  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Release 0.8.8

        * debian/*: Similarly updated for new release to Debian

2010-10-30  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/RcppCommon.h: New define IS_GCC_450_OR_LATER
        * inst/include/Rcpp/Extractor.h: Do not enable Rcpp::Fast if g++
        4.5.0 or later is used -- we need to figure out what upsets it

2010-10-23  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/MatrixRow.h: Faster row indexing

        * inst/include/Rcpp/vector/Matrix.h: added use of _ to get columns
        and rows of a matrix. For example if x is a NumericMatrix, x(_,i)
        returns the same as x.column(i) and x(i,_) returns the same as
        x.row(i)

        * inst/unitTests/runit.Matrix.R: unit tests for the above

        * inst/include/Rcpp/sugar/functions/sum.h: the sugar version of sum
        now takes care of missing values correctly

        * inst/include/Rcpp/sugar/functions/cumsum.h: sugar version of cumsum

2010-10-21  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/MatrixColumn.h: Fixed indexing
        bug (mismatch between number of rows and number of columns

        * inst/unitTests/runit.Matrix.R: test fix above based on the
        R-help/Rcpp-devel thread:
        http://article.gmane.org/gmane.comp.lang.r.rcpp/851

        * inst/include/Rcpp/vector/MatrixColumn.h: Column gains a operator=
        taking a sugar expression. Faster indexing (caching the pointer
        instead of calling nrow many times)

        * inst/include/Rcpp/vector/Matrix.h: first pass at making matrix
        indexing faster

2010-10-21  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/Module.h: Reorder instantiation for class_

2010-10-20  Dirk Eddelbuettel  <edd@debian.org>

        * include/Rcpp/XPtr.h: Applied patch by Karl Millar
        * include/Rcpp/vector/Vector.h: Idem

2010-10-19  Dirk Eddelbuettel  <edd@debian.org>

        * src/posixt.cpp: Correct POSIXct, POSIXt ordering for R 2.12.0

 2010-10-14  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION (Version): Release 0.8.7

        * debian/*: Similarly updated for new release to Debian

2010-10-10  Romain Francois <romain@r-enthusiasts.com>

        * tests/doRUnit.R: workaround to disable tests on windows 64 until we can
          figure out what upsets R CMD check.

        * R/Module.R: expose the finalizer

2010-10-07  John M Chambers  <jmc@r-project.org>

        * R/Module.R: modify cpp_refMethods to substitute the .External
        directly with the method and class pointers.

2010-10-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/Rcpp/stats/random/r*: Added comment reminding users
        read up on Section 6.3 of "Writing R Extensions" and the need to
        call GetRNGstate() and PutRNGstate() when using R's RNGs

2010-09-30  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/MatrixRow.h: Matrix row inherits
        VectorBase so that it becomes a sugar expression, so that we can do
        something like this:
          NumericMatrix x( ... ) ;
          NumericVector x0 = x.row(0) ;

        * inst/include/Rcpp/vector/MatrixColumn.h: idem for columns

        * cleanup: run make clean in the inst/doc directory to install
        the fake vignettes

2010-09-27  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/traits/is_sugar_expression.h: new trait class
        to recognize sugar expressions

        * inst/include/Rcpp/vector/Vector.h: operator=( sugar expression)
        no longer allocate unnecessary memory.

2010-09-26  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rpp/Fast.h: new helper class Rcpp::Fast that allows
        faster indexing of Vector

        * inst/include/Rcpp/sugar/operators/plus.h: port to operator+ the same
        improvements than in operator*

2010-09-25  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/routines.h: declare routines that are registered

        * src/Rcpp_init.c: register routines

        * R/*.R: use registration information in many .Call and .External
        functions to speed things up

        * inst/include/Rcpp/RangeIndexer.h: experimenting with loop unrolling

2010-09-24  John M Chambers  <jmc@r-project.org>

        * R/Module.R: modify cpp_fields to substitute the .Call
        directly with the field and class pointers; supplements the
        changes entered by Romain on 9-22. (svn rev 2165, 2141)

        * src/Rcpp_init.c: set up registration of .Call's (rev 2167)

2010-09-24  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/Range.h : Range gains some
        operators (++,--,n etc ...)

        * inst/examples/ConvolveBenchmarks/convolve3_cpp.cpp: using the new
        Range operators

        * inst/include/Rcpp/sugar/operators/times.h: speed improvements. Not
        using pointer to member functions seems to be beneficial.

        * inst/include/Rcpp/sugar/nona/nona.h: sugar function that wraps a
        sugar expression in an object that pretends it does not contain any
        missing values. This allows many sugar functions and operators to use
        their fast versions when we know that the object does not contain
        missing values.

2010-09-22  Romain Francois <romain@r-enthusiasts.com>

        * R/Module.R: set [[ and [[<- as regular methods too, which restores
        previous behavior

2010-09-17  Romain Francois <romain@r-enthusiasts.com>

        * src/Reference.cpp: new objects are created via a callback to R's
        new function, as R_do_new_object did always return the same
        environment

        * R/00_classes.R: new ref class C++Method to represent C++ methods
        and holding their external pointers directly (same idea as C++Field)

        * inst/include/Rcpp/Module.h: internal support for
        C++Method (template class S4_CppMethod)

2010-09-17  John M Chambers  <jmc@r-project.org>

        * R/00_classes.R, R/02_completion.R, et al.: use of environment
        underlying the reference classes removes need for slots in
        C++Object class (svn rev's 2133, 2134)


2010-09-16  Romain Francois <romain@r-enthusiasts.com>

        * R/00_classes.R: moving classes definition here

        * inst/Rcpp/Module.h: added C++ class S4_field that builds S4 objects
        of class C++Field. Build the list of fields as part of the creation
        of the C++Class objects

        * src/Module.cpp: .Call functions CppField__get and CppField__set to
        get/set values of an object's field using external pointers
        directly (no std::map lookup internally)

        * R/Module.R: (unexported) functions .getField and .setField that
        call CppField__get and CppField__set

        * inst/include/Rcpp/Reference.h: skeleton for a Rcpp::Reference class
        that will help dealing with reference classes on the C++ side

        * src/Reference.cpp: implementation (needs update)

2010-09-16  John M Chambers  <jmc@r-project.org>

        * R/Module.R, tests/modRef.R: un-generic of new(); return a
        generator object for C++ classes. Use environment as superclass.


2010-09-15  Romain Francois <romain@r-enthusiasts.com>

        * DESCRIPTION: added the declaration MinimumSvnRev to control which
        version of R-devel we need so that Rcpp fully works, currently set to
        52905

        * R/zzz.R: check the svn revision of R against the declared
        MinimumSvnRev requirement and print a message if necessary (this will
        only stay for the interim period while we develop 0.8.7 so that we
        all are on the same page.

        * inst/include/Rcpp/Module.h: added methods to class_Base :
        methods_arity and methods_voidness to query the number of arguments
        of methods of a class and if the method is void

        * R/Module.R: implement referenceMethods (from methods) for 'C++Class'

2010-09-11  Dirk Eddelbuettel  <edd@debian.org>

        * src/Date.cpp: Add include of unistd.h to make Solaris happy

2010-09-09  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.8.6

        * debian/*: Similarly updated for new release to Debian

2010-09-08  Dirk Eddelbuettel  <edd@debian.org>

        * inst/include/RcppCommon.h: Also include typeinfo header file

2010-09-08  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/Module.h : added class_Base::property_names
        method to grab the names of all fields (properties)

        * src/Module.cpp : added R access (.Call) function
        CppClass__properties to grab the names of the fields (property) from
        the XP of a class

        * inst/include/Rcpp/Module.h : added class_Base::property_is_readonly
        method to query if a property is read only

        * src/Module.cpp : added R access (.Call) function
        CppClass__property_is_readonly to query if a class property is read
        only

        * inst/include/Rcpp/Module.h : added class_Base::property_class
        method to grab the C++ class of a property

        * src/Module.cpp : added R access (.Call) function
        CppClass__property_class to grab the C++ class of a property

2010-09-06  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/ConvolveBenchmarks/exampleRCode.r: Rewritten /
        simplified using the rbenchmark::benchmark() function

        * DESCRIPTION: Added Suggests: on rbenchmark package

2010-09-04  Dirk Eddelbuettel  <edd@debian.org>

        * inst/examples/ConvolveBenchmarks/exampleRCode.r: Some cosmetics

        * inst/examples/ConvolveBenchmarks/convolve3_cpp.cpp: Remove one
        unneccessary loop to set values to zero (which the ctor does for us)

2010-09-03  Dirk Eddelbuettel  <edd@debian.org>

        * inst/doc/Rcpp-extending/Rcpp-extending.Rnw: Add highlight definitions
        * inst/doc/Rcpp-FAQ/Rcpp-FAQ.Rnw: Idem
        * inst/doc/Rcpp-package/Rcpp-package.Rnw: Idem

2010-09-02  Dirk Eddelbuettel  <edd@debian.org>

        * src/msvcmath.cpp: Undo unmotivated msvc patch
        * inst/include/Rcpp/msvc/: Idem
        * inst/include/Rcpp/XPtr.h: Idem
        * inst/include/RcppCommon.h: Idem
        * src/Date.cpp: Idem

        * DESCRIPTION: Added Suggests: on highlight package

2010-08-20  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/complex.h : binary operators for Rcomplex : +,-,*,/

2010-08-15  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/SugarBlock.h: more control of the NA behavior
        in SUGAR_BLOCK_2. SUGAR_BLOCK_2 will now propagate the NA, and the new
        SUGAR_BLOCK_2_NA will use a fixed NA (can be true or false). This can be
        useful if the function that is sugar'ed never generates NA.

        * inst/include/Rcpp/sugar/undoRmath.h : undo the macros done by Rmath.h

2010-08-13  Douglas Bates  <bates@stat.wisc.edu>

        * include/Rcpp.h: undo more defines from Rmath.h

2010-08-13  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/complex.h: simplify complex sugar functions
        Re, Im, Conj, Mod

        * inst/include/Rcpp/sugar/complex.h: new sugar functions operating on
        complex expressions: exp, log, sqrt, cos, sin, tan, acos, asin, atan,
        acosh, asinh, atanh, cosh, sinh, tanh

        * inst/unitTests/runit.sugar.R: added regression test for complex functions
        which did not handle NA properly before

        * DESCRIPTION: no longer requireing GNU make as we dont use it anymore

        * src/Makevars: removed the use of ifeq (which was the last thing requiring
        GNU make)

2010-08-12  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/math.h: replace previous versions of floor,
        abs, exp, ceil, ceiling with versions generated by the SUGAR_MATH_1
        macro

2010-08-11  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/vector.h: Vector gains constructor
        taking size and function pointers, acting as generators :

           Vector( const int& siz, stored_type (*gen)(void), bool seed = true )

           template <typename U1>
           Vector( const int& siz, stored_type (*gen)(U1), const U1& u1,
                   bool seed = true)

           template <typename U1, typename U2>
           Vector( const int& siz, stored_type (*gen)(U1,U2), const U1& u1,
                   const U2& u2, bool seed = true)

        so that for example :

           NumericVector( 10, norm_rand )

        generates a N(0,1) vector of size 10

        * inst/include/Rcpp/stats/random/rlnorm.h: Added rlnorm and rlnorm_
        * inst/include/Rcpp/stats/random/rgamma.h: Added rgamma and rgamma_
        * inst/include/Rcpp/stats/random/rt.h: Added rt and rt_
        * inst/include/Rcpp/stats/random/rbinom.h: Added rbinom and rbinom_
        * inst/include/Rcpp/stats/random/rnchisq.h: Added rnchisq and rnchisq_
        * inst/include/Rcpp/stats/random/rgeom.h: Added rgeom and rgeom_
        * inst/include/Rcpp/stats/random/rhyper.h: Added rhyper and rhyper_
        * inst/include/Rcpp/stats/random/rnbinom_mu.h: Added rnbinom_mu and rnbinom_mu_
        * inst/include/Rcpp/stats/random/rnbinom.h: Added rnbinom and rnbinom_
        * inst/include/Rcpp/stats/random/rpois.h: Added rpois and rpois_
        * inst/include/Rcpp/stats/random/rweibull.h: Added rweibull and rweibull_
        * inst/include/Rcpp/stats/random/rlogis.h: Added rlogis and rlogis_
        * inst/include/Rcpp/stats/random/rwilcox.h: Added rwilcox and rwilcox_
        * inst/include/Rcpp/stats/random/rsignrank.h: Added rsignrank and rsignrank_

        * inst/include/Rcpp/stats/random/rnorm.h: some optimization
        * inst/include/Rcpp/stats/random/rf.h: calculate n2/n1 just once
        * inst/include/Rcpp/sugar/SugarBlock.h : templates and macros to facilitate
        generation of sugar functions that take one or two double parameters

        * inst/include/Rcpp/sugar/math.h: using SugarBlock to generate new
        sugar functions:
                (1 parameter) : gamma, lgamma, digamma, trigamma, tetragamma,
                pentagamma, expm1, log1p, factorial, lfactorial,
                cos, acosh, atan, cos, cosh, log, log10, sqrt, sin, sinh, tan, tanh

                (2 parameter) : choose, lchoose, beta, lbeta, psigamma

2010-08-10  Douglas Bates  <bates@stat.wisc.edu>

        * include/Rcpp/stats/nbinom[_mu].h: Replace conflicting data member name
        'size' by 'siz'

2010-08-10  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/stats/random/rnorm.h: Added rnorm and rnorm_

        * inst/include/Rcpp/stats/random/runif.h: Added runif and runif_

        * inst/include/Rcpp/stats/random/rbeta.h: Added rbeta and rbeta_

        * inst/include/Rcpp/stats/random/rcauchy.h: Added rcauchy and rcauchy_

        * inst/include/Rcpp/stats/random/rchisq.h: Added rchisq and rchisq_

        * inst/include/Rcpp/stats/random/rexp.h: Added rexp and rexp_

        * inst/include/Rcpp/stats/random/rf.h: Added rf and rf_

        * inst/include/Rcpp/stats/stats.h : fixed name clash reported on Rcpp-devel
        http://permalink.gmane.org/gmane.comp.lang.r.rcpp/610

2010-08-09  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/stats/lnorm.h: Added d-p-q (lnorm|weibull|logis|f)
        generated by the script

        * inst/include/Rcpp/vector/Vector.h: further dispatch to allow generators
        to be passed to constructors of Vector

        * inst/include/Rcpp/traits/has_iterator.h: new SFINAE detection of
        generators

        * inst/include/Rcpp/Generator.h : base template class for generators

2010-08-06  Douglas Bates  <bates@stat.wisc.edu>

        * unitTests/runit.stats.R: Corrected instances of numeric
        arguments passed as integers, deleted tests for binomial with
        fixed parameter values.

2010-08-06  Romain Francois <romain@r-enthusiasts.com>

        * ../scripts/stats.R: R script to generate the template code for dpq functions

        * include/Rcpp/stats/unif.h: Added d-p-q unif and tests

        * include/Rcpp/stats/gamma.h: Added d-p-q gamma and tests

        * include/Rcpp/stats/chisq.h: Added d-p-q chisq

2010-08-05  Douglas Bates  <bates@stat.wisc.edu>

        * include/Rcpp/stats/beta.h: Added d-p-q beta and tests

        * include/Rcpp/stats/binom.h: Added pbinom and qbinom,
        and tests of same in runit.stats.R

        * include/Rcpp/stats/pois.h: Added ppois and qpois (plus
        tests in runit.stats.R).

        * include/Rcpp/stats/norm.h: Added pnorm and qnorm and
        corresponding tests in unitTests/runit.stats.R

2010-08-05  Dirk Eddelbuettel  <deddelbuettel@wtchi-stat-l2.wolve.com>

        * inst/include/Rcpp/stats/norm.h: Added dnorm sugar function
        * inst/include/Rcpp/stats/t.h: Added dt, pt, qt sugar functions
        * inst/include/unitTests/runit.stats.R: Added corresponding tests

2010-08-05  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/functions/seq_along.h: added seq(int,int) to
        mimic the R syntax : seq( 0, 5 )

        * inst/include/Rcpp/sugar/Range.h: fixed compiler confusion

        * inst/include/Rcpp/stats: new sugar functions Rcpp::stats::dpois and
        Rcpp::stats::dbinom inspired by Richard Chandler post on Rcpp-devel:
        http://lists.r-forge.r-project.org/pipermail/rcpp-devel/2010-August/000940.html

        * inst/include/Rcpp/sugar/sum.h: preliminary version of Rcpp::sum (does not
        deal with NA properly yet)

2010-08-04  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/: rework sugar matrix so that operator()(int,int)
        is always used instead of operator[](int)

        * inst/include/Rcpp/sugar/matrix/outer.h: new implementation based on
        LazyVector, so that the value from the vector expression is only
        retrieved once

2010-08-02  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/XPtr.h: give default values to tag and prot in XPtr ctor

2010-07-30  Romain Francois <romain@r-enthusiasts.com>

        * inst/doc/Rcpp-quickref/* : new vignette Rcpp-quickref: quick reference guide
        to Rcpp API

2010-07-28  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/exp.h: adapt to stricter standards on solaris/suncc

2010-07-25  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.8.5

        * debian/*: Similarly updated for new release to Debian

2010-07-17  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/vector/Vector.h: faster lhs use of names, only
        using callback to R if necessary. (discovered while profiling
        RProtoBuf)

        * inst/include/Rcpp/RObject.h : faster lhs and rhs use of
        RObject::slot, using R API functions R_do_slot and R_do_slot_assign

2010-07-16  Dirk Eddelbuettel  <edd@debian.org>

        * src/Date.cpp: Small fix which may make Solaris/SunStudio happy

2010-07-16  Romain Francois <romain@r-enthusiasts.com>

        * man/Rcpp-package.Rd : removed old content and point to the
        Rcpp-package vignette for current guidelines.

        * DESCRIPTION: Updated to mention sugar and modules

2010-07-10  Romain Francois <romain@r-enthusiasts.com>

        * src/Makevars: Remove last call to $shell by turning C++0x
        detection off (and into a switch users can edit) which should
        make builds more stable
        * src/Makevars.win: Idem
        * src/cxx0x/cxx0x.R: Detection script deprecated for now

2010-07-10  Romain Francois <romain@r-enthusiasts.com>

        * man/CppClass-class.Rd: changed use of \linkS4Class to suppress a
        warning with the development version of R
        * man/CppObject-class.Rd: idem

2010-07-09  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.8.4

        * debian/*: Similarly updated for new release to Debian

2010-07-09  Romain Francois <romain@r-enthusiasts.com>

        * src/RObject.cpp: adapt the SlotProxy class to deal with the special
        case of the .Data slot (slot<- changes the internal SEXP)

        * R/Module.R: the C++Class now inherits from "character", to facilitate
        S4 method dispatch

        * src/Module.cpp: The CppClass ctor sets the .Data of the C++Class object
        to an obfuscated name to avoid class names clashes at the R level.

2010-07-08  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/functions/head.h: new sugar function : head
        * inst/include/Rcpp/sugar/functions/tail.h: new sugar function : tail

        * inst/include/Rcpp/sugar/functions/tail.h: new sugar function : diag

2010-07-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/README: Updated and now pointing to all the other documentation

2010-07-07  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/functions/rep.h: version of rep that takes a
        primitive as the first argument

2010-07-07  Dirk Eddelbuettel  <edd@debian.org>

        * inst/unitTests/runTests.R: Reverted to running all tests now that
        tests are reorganised using the one-compile-per-function scheme which
        significantly speeds up running of the numerous unit tests

2010-07-06  Dirk Eddelbuettel  <edd@debian.org>

        * src/Date.cpp: Imported mktime() from R (which is due to Arthur Olson)

2010-07-06  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/functions/ifelse.h: using compile time dispatch
        based on the NA-ness of the condition type. ifelse handles primitive
        arguments on the lhs, rhs or both

        * inst/include/Rcpp/sugar/functions/rev.h: new sugar function: rev

2010-07-05  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/RcppCommon.h : no more using variadic macros in
        RCPP_DEBUG

        * inst/include/Rcpp/vector/Matrix.h: move ncol, nrow, rows and cols
        in Matrix (used to be in Vector)

        * inst/include/Rcpp/traits/matrix_interface.h: new SFINAE helper to
        detect matrix interface (helps matrix sugar expressions)

2010-07-03  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/traits/result_of.h : also deal with functions
        taking two arguments (useful for e.g. outer)

        * inst/include/Rcpp/vector/MatrixBase.h : new CRTP base class
        for Matrix to facilitate sugar syntax on matrices.

        * inst/include/Rcpp/sugar/matrix/outer.h : new sugar function: outer
        * inst/include/Rcpp/sugar/matrix/row.h: new sugar function: row
        * inst/include/Rcpp/sugar/matrix/col.h: new sugar function: col
        * inst/include/Rcpp/sugar/matrix/lower_tri.h: new sugar function: lower_tri
        * inst/include/Rcpp/sugar/matrix/upper_tri.h: new sugar function: upper_tri

        * inst/include/Rcpp/sugar/functions/rep.h: new sugar function : rep
        * inst/include/Rcpp/sugar/functions/rep_len.h: new sugar function : rep_len
        * inst/include/Rcpp/sugar/functions/rep_each.h: new sugar function : rep_each

2010-07-02  Dirk Eddelbuettel  <edd@debian.org>

        * src/RcppStringVector: Now uses std::vector<std::string>
        * inst/include/classic/RcppStringVector.h: Idem

        * inst/unitTests/runit.List.R: Added simple test for RcppStringVector

2010-07-01  Dirk Eddelbuettel  <edd@debian.org>

        * src/RcppDateVector: Index argument is int here as well
        * src/RcppDatetimeVector: Idem
        * inst/include/classic/RcppDateVector.h: Idem
        * inst/include/classic/RcppDatetimeVector.h: Idem

        * inst/unitTests/runit.List.R: Added simple test for RcppList

2010-06-30  Dirk Eddelbuettel  <edd@debian.org>

        * src/DateVector: Index argument is int; throw declared
        * src/DatetimeVector: Idem
        * inst/include/Rcpp/DateVector.h: Idem
        * inst/include/Rcpp/DatetimeVector.h: Idem

2010-06-28  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/sugar/Im.h:
        * inst/include/Rcpp/sugar/Re.h:
        * inst/include/Rcpp/sugar/Conj.h:
        * inst/include/Rcpp/sugar/Mod.h: added sugar functions for
        complex vectors: Re, Im, Conj, Mod

2010-06-27  Dirk Eddelbuettel  <edd@debian.org>

        * DESCRIPTION: Release 0.8.3

        * debian/*: Similarly updated for new release to Debian

        * inst/unitTests/runTests.R: Stop-gap measure to reduce the number of
        tests run on Windows as we now have so many tests that the build
        exceeds the time limit granted by the win-builder service. The forced
        reduction of tests can be overcome by adding --allTests as a
        command-line argument on Windows, or by running on another platform.

2010-06-25  Romain Francois <romain@r-enthusiasts.com>

        * inst/include/Rcpp/posix.h: anticipate R 2.12.0 switch of classes
        POSIXt and POSIXct

        * inst/include/classic: New home for the 'classic' API headers. Also
        some refactoring of the internals so that they can interoperate
        better withuse the new API.

2010-06-24  Romain Francois <romain@r-enthusiasts.com>

